/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern5 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern5 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_HFmode:
      if (pattern5 (x3, 
E_HFmode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_TImode) != 0)
        return -1;
      return 3;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_QImode) != 0)
        return -1;
      return 4;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern6 (x3, 
E_HImode) != 0)
        return -1;
      return 5;

    case E_V4HImode:
      if (pattern7 (x3, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V4QImode:
      if (pattern8 (x3, 
E_V4QImode) != 0)
        return -1;
      return 7;

    case E_V2QImode:
      if (pattern8 (x3, 
E_V2QImode) != 0)
        return -1;
      return 8;

    case E_V2HImode:
      if (pattern8 (x3, 
E_V2HImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (GET_MODE (x4))
        {
        case E_HFmode:
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          return 0;

        case E_SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 1;

        case E_DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  if (!const_scalar_int_operand (operands[2], E_TImode))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern7 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern7 (x1, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern8 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V2QImode:
      if (pattern8 (x1, 
E_V2QImode) != 0)
        return -1;
      return 3;

    case E_V2HImode:
      if (pattern8 (x1, 
E_V2HImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern26 (x1, 
E_V64QImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern26 (x1, 
E_V32QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern26 (x1, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern26 (x1, 
E_V32HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern26 (x1, 
E_V16HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern26 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_XFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_XFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCCmode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern103 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern102 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern102 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1, int *pnum_clobbers, int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern119 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 2);
  operands[3] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return 0;

        case E_V16HFmode:
          return 1;

        case E_V32HFmode:
          return 2;

        case E_V16SFmode:
          return 3;

        case E_V8SFmode:
          return 4;

        case E_V4SFmode:
          return 5;

        case E_V8DFmode:
          return 6;

        case E_V4DFmode:
          return 7;

        case E_V2DFmode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x5) != E_V2SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 2)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_V4SImode)
          || !nonimm_or_0_operand (operands[2], E_V2DFmode)
          || !register_operand (operands[3], E_QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern144 (x3, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern144 (x3, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern144 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern142 (x3, 
E_V32QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern142 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V64QImode:
      if (pattern142 (x3, 
E_V64QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      return pattern161 (x3, 
E_V8SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern161 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V16SImode:
      if (pattern161 (x3, 
E_V16SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (XINT (x2, 1))
        {
        case 221:
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              return pattern173 (x1, 
E_V32HFmode); /* [-1, 0] */

            case E_V16HFmode:
              if (pattern173 (x1, 
E_V16HFmode) != 0)
                return -1;
              return 1;

            case E_V8HFmode:
              if (pattern173 (x1, 
E_V8HFmode) != 0)
                return -1;
              return 2;

            default:
              return -1;
            }

        case 222:
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern173 (x1, 
E_V32HFmode) != 0)
                return -1;
              return 3;

            case E_V16HFmode:
              if (pattern173 (x1, 
E_V16HFmode) != 0)
                return -1;
              return 4;

            case E_V8HFmode:
              if (pattern173 (x1, 
E_V8HFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x5 = XEXP (x1, 1);
      operands[4] = x5;
      switch (XINT (x2, 1))
        {
        case 217:
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern174 (x1, 
E_V32HFmode) != 0)
                return -1;
              return 6;

            case E_V16HFmode:
              if (pattern174 (x1, 
E_V16HFmode) != 0)
                return -1;
              return 7;

            case E_V8HFmode:
              if (pattern174 (x1, 
E_V8HFmode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        case 219:
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern174 (x1, 
E_V32HFmode) != 0)
                return -1;
              return 9;

            case E_V16HFmode:
              if (pattern174 (x1, 
E_V16HFmode) != 0)
                return -1;
              return 10;

            case E_V8HFmode:
              if (pattern174 (x1, 
E_V8HFmode) != 0)
                return -1;
              return 11;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern187 (x3); /* [-1, 1] */
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern193 (x1); /* [-1, 3] */
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return pattern194 (x1); /* [-1, 3] */
}

int
pattern198 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 0;

    case AND:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      res = pattern195 (x5);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    case PLUS:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      res = pattern196 (x5);
      if (res >= 0)
        return res + 5; /* [5, 8] */
      return -1;

    case MINUS:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      res = pattern197 (x5);
      if (res >= 0)
        return res + 9; /* [9, 12] */
      return -1;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 38)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 17
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!nonimmediate_operand (operands[1], E_SImode))
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  operands[2] = x9;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[2] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XEXP (x5, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != ZERO_EXTRACT)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x10 = XEXP (x8, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!int248_register_operand (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!int248_register_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (x8))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !extract_operator (operands[2], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !extract_operator (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern255 (x1); /* [-1, 2] */

    case E_DImode:
      res = pattern256 (x1);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  return pattern260 (x1); /* [-1, 2] */
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  x10 = XEXP (x1, 1);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern266 (x1, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern266 (x1, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern266 (x1, 
E_DFmode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return 0;

        case E_V16SImode:
          return 1;

        case E_V8DImode:
          return 2;

        case E_V16HImode:
          return 3;

        case E_V8SImode:
          return 4;

        case E_V4DImode:
          return 5;

        case E_V8HImode:
          return 6;

        case E_V4SImode:
          return 7;

        case E_V2DImode:
          return 8;

        default:
          return -1;
        }

    case VEC_SELECT:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != SIGN_EXTEND)
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern296 (x1, 
E_V4DImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern296 (x1, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!nonimmediate_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x1, 1);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case ZERO_EXTEND:
      if (GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern305 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern305 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern306 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern306 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 110)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonimmediate_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern323 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern327 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  return 0;
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern329 (x6, 
37); /* [-1, 0] */
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!ix86_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case STRICT_LOW_PART:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern353 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!general_reg_operand (operands[0], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_operator (x3, i1))
    return -1;
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!memory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern366 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_no_SP_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !immediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern382 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !x86_64_general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern388 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return pattern387 (x1); /* [-1, 1] */

    case PLUS:
      res = pattern387 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      x4 = XEXP (x3, 0);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!int248_register_operand (operands[2], E_VOIDmode))
        return -1;
      res = pattern19 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern400 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      return pattern393 (x1, 
E_V64QImode, 
E_DImode); /* [-1, 0] */

    case E_V32QImode:
      if (pattern393 (x1, 
E_V32QImode, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern393 (x1, 
E_V16QImode, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern410 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[5], i2))
    return -1;
  return 0;
}

int
pattern417 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  operands[3] = x5;
  if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern426 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern426 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern426 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern426 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern426 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern426 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern426 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern426 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern426 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern438 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SFmode
      || !nonimmediate_operand (operands[1], i1)
      || !const0_operand (operands[3], E_V2SFmode)
      || !const0_operand (operands[4], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern442 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern446 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!nonimmediate_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) < 1)
    return -1;
  operands[4] = x2;
  if (!pmovzx_parallel (operands[4], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XVECEXP (x2, 0, 0);
  operands[5] = x8;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern461 (x1, 
E_V16SImode, 
E_V8SImode, 
E_V32SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern461 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V16SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x3) != E_V8SImode
          || GET_MODE (x4) != E_V4SImode
          || !vector_operand (operands[1], E_V2SImode)
          || !const0_operand (operands[2], E_V2SImode)
          || !const0_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern475 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern471 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern471 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern471 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V32BFmode:
      if (pattern471 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 3;

    case E_V16BFmode:
      if (pattern471 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 4;

    case E_V8BFmode:
      if (pattern471 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 5;

    case E_V16SFmode:
      if (pattern471 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 6;

    case E_V8SFmode:
      if (pattern471 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 7;

    case E_V4SFmode:
      if (pattern471 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 8;

    case E_V8DFmode:
      if (pattern471 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 9;

    case E_V4DFmode:
      if (pattern471 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 10;

    case E_V2DFmode:
      if (pattern471 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern488 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode)
          || !x86_64_general_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      res = pattern487 (x1, 
E_SImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_DImode:
      res = pattern487 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (!register_operand (operands[4], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern496 (x6) != 0)
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern549 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (!commutative_operator (x2, E_VOIDmode))
    return -1;
  operands[3] = x2;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XEXP (x1, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern555 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode
      || !nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || GET_MODE (x2) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_QImode)
      || !const_scalar_int_operand (operands[3], E_TImode))
    return -1;
  return 0;
}

int
pattern559 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          return pattern564 (x1, 
E_V16SFmode, 
E_HImode); /* [-1, 0] */

        case E_V8SFmode:
          if (pattern564 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_V4SFmode:
          if (pattern564 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V8DFmode:
          if (pattern564 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_V4DFmode:
          if (pattern564 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V2DFmode:
          if (pattern564 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x4, 0) != 1LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern565 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 6;

        case E_V2DFmode:
          if (pattern565 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern581 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern588 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const48_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return pattern587 (x1); /* [-1, 5] */

    case CONST_INT:
      res = pattern585 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          return pattern592 (x1, 
E_V8SFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern592 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V4DFmode:
          if (pattern592 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 2;

        case E_V2DFmode:
          if (pattern592 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern593 (x1, 
E_V8SImode, 
E_V8SFmode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern593 (x1, 
E_V4SImode, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V4DFmode:
          if (pattern593 (x1, 
E_V4DImode, 
E_V4DFmode) != 0)
            return -1;
          return 6;

        case E_V2DFmode:
          if (pattern593 (x1, 
E_V2DImode, 
E_V2DFmode) != 0)
            return -1;
          return 7;

        case E_V32QImode:
          if (pattern594 (x1, 
E_V32QImode) != 0)
            return -1;
          return 8;

        case E_V16QImode:
          if (pattern594 (x1, 
E_V16QImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern616 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  return 0;
}

int
pattern624 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1
      || pattern623 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int_nonimmediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern627 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern627 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern628 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern628 (x3, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern637 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern635 (x5, 
E_TFmode); /* [-1, 0] */

    case E_HFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern209 (x5, 
E_V8HFmode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_SFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern209 (x5, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern209 (x5, 
E_V2DFmode, 
E_DFmode) != 0)
        return -1;
      return 3;

    case E_V2BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern636 (x5, 
E_V2BFmode) != 0)
        return -1;
      return 4;

    case E_V2HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern636 (x5, 
E_V2HFmode) != 0)
        return -1;
      return 5;

    case E_V32BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V32BFmode) != 0)
        return -1;
      return 6;

    case E_V16BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16BFmode) != 0)
        return -1;
      return 7;

    case E_V8BFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8BFmode) != 0)
        return -1;
      return 8;

    case E_V32HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V32HFmode) != 0)
        return -1;
      return 9;

    case E_V16HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16HFmode) != 0)
        return -1;
      return 10;

    case E_V8HFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8HFmode) != 0)
        return -1;
      return 11;

    case E_V16SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V16SFmode) != 0)
        return -1;
      return 12;

    case E_V8SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8SFmode) != 0)
        return -1;
      return 13;

    case E_V4SFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V4SFmode) != 0)
        return -1;
      return 14;

    case E_V8DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V8DFmode) != 0)
        return -1;
      return 15;

    case E_V4DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V4DFmode) != 0)
        return -1;
      return 16;

    case E_V2DFmode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern635 (x5, 
E_V2DFmode) != 0)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern679 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonmemory_operand (operands[4], i1)
      || !const0_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern690 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || !binary_fp_operator (operands[3], E_XFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !binary_fp_operator (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern698 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern706 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern713 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern719 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 2);
  operands[4] = x9;
  if (!register_operand (operands[4], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  operands[5] = x10;
  if (!const48_operand (operands[5], E_SImode))
    return -1;
  return pattern717 (x1); /* [-1, 2] */
}

int
pattern735 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  return 0;
}

int
pattern740 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ix86_comparison_uns_operator (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern748 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern754 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[3] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != SUBREG
          || maybe_ne (SUBREG_BYTE (x10), 0))
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != AND
          || GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG
          || maybe_ne (SUBREG_BYTE (x12), 0)
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XEXP (x12, 0);
      switch (GET_CODE (x13))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          x14 = XEXP (x9, 0);
          if (GET_CODE (x14) != ZERO_EXTRACT)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x14, 2);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x17 = XEXP (x2, 0);
          operands[4] = x17;
          if (!flags_reg_operand (operands[4], E_VOIDmode))
            return -1;
          operands[5] = x3;
          if (!compare_operator (operands[5], E_VOIDmode)
              || GET_MODE (x4) != E_QImode)
            return -1;
          return pattern538 (x1); /* [-1, 2] */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern775 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern779 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern787 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern786 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern786 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern795 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1)
      || !bcst_vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern805 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern811 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern820 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x19) != CONST_INT)
    return -1;
  x20 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x20) != CONST_INT)
    return -1;
  x21 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x21) != CONST_INT)
    return -1;
  x22 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x22) != CONST_INT)
    return -1;
  x23 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x23) != CONST_INT)
    return -1;
  x24 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x24) != CONST_INT)
    return -1;
  x25 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x25) != CONST_INT)
    return -1;
  x26 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x26) != CONST_INT)
    return -1;
  x27 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x27) != CONST_INT)
    return -1;
  x28 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x28) != CONST_INT)
    return -1;
  x29 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x29) != CONST_INT)
    return -1;
  x30 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x30) != CONST_INT)
    return -1;
  x31 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x31) != CONST_INT)
    return -1;
  x32 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x32) != CONST_INT)
    return -1;
  x33 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x33) != CONST_INT)
    return -1;
  return 0;
}

int
pattern848 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern855 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !const1_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern862 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern868 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      return 0;

    case SET:
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      x5 = XEXP (x3, 1);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern879 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !general_reg_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 4)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x3 = XEXP (x1, 1);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 2)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != ASHIFTRT
          || GET_MODE (x6) != i1)
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 17
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x9 = XEXP (x6, 1);
      operands[4] = x9;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x12) != SET)
        return -1;
      x13 = XEXP (x12, 0);
      operands[3] = x13;
      if (!memory_operand (operands[3], i1))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      return 0;

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x15 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != ASHIFTRT
          || GET_MODE (x16) != i1)
        return -1;
      x17 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x17) != CLOBBER)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 17
          || GET_MODE (x18) != E_CCmode)
        return -1;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      if (!general_reg_operand (operands[2], i1))
        return -1;
      x20 = XEXP (x16, 1);
      operands[4] = x20;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      x21 = XEXP (x16, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x4) != SET)
        return -1;
      x22 = XEXP (x4, 0);
      operands[3] = x22;
      if (!memory_operand (operands[3], i1))
        return -1;
      x23 = XEXP (x4, 1);
      if (!rtx_equal_p (x23, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern902 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[1], E_V64QImode)
      || !nonimmediate_operand (operands[2], E_V64QImode)
      || !const_0_to_7_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern906 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern913 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (!register_operand (x3, i1))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (!register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern922 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern921 (x1, 
E_V8HImode, 
E_HImode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern921 (x1, 
E_V8HFmode, 
E_HFmode) != 0)
        return -1;
      return 1;

    case E_V8BFmode:
      if (pattern921 (x1, 
E_V8BFmode, 
E_BFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern934 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern946 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_VECTOR
      || XVECLEN (x5, 0) != 4
      || GET_MODE (x5) != E_V4SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x4, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || GET_MODE (x4) != E_V4SImode)
    return -1;
  return pattern618 (x1); /* [-1, 2] */
}

int
pattern957 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern960 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != ZERO_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  return pattern302 (x1); /* [-1, 1] */
}

int
pattern969 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern979 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  return pattern685 (); /* [-1, 5] */
}

int
pattern986 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V16SImode:
          if (!nonimmediate_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (!nonimmediate_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[2], E_V16HFmode))
            return -1;
          return 1;

        case E_V16SFmode:
          if (!nonimmediate_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[2], E_V16SFmode))
            return -1;
          return 2;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!nonimmediate_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8SImode:
          if (!nonimmediate_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 5;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 6;

        case E_V8DImode:
          if (!nonimmediate_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 7;

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 8;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 9;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[2], E_V8HFmode))
            return -1;
          return 10;

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[2], E_V8SFmode))
            return -1;
          return 11;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[2], E_V4SFmode))
            return -1;
          return 12;

        case E_V8DFmode:
          if (!nonimmediate_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[2], E_V8DFmode))
            return -1;
          return 13;

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[2], E_V4DFmode))
            return -1;
          return 14;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[2], E_V2DFmode))
            return -1;
          return 15;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 16;

        default:
          return -1;
        }

    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V32HFmode:
          if (!nonimmediate_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[2], E_V32HFmode))
            return -1;
          return 17;

        case E_V32QImode:
          if (!nonimmediate_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 18;

        case E_V32HImode:
          if (!nonimmediate_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode))
        return -1;
      return 20;

    default:
      return -1;
    }
}

int
pattern1048 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern1047 (x5, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      res = pattern1047 (x5, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1057 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XEXP (x1, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1055 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1055 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1056 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1056 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1074 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != STRICT_LOW_PART)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  return pattern321 (x4); /* [-1, 1] */
}

int
pattern1079 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !const0_operand (operands[2], i2)
      || !vector_all_ones_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1086 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (!ix86_carry_flag_operator (x5, i1))
    return -1;
  operands[4] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!flags_reg_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!memory_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x2, 0);
  return pattern1085 (x12, 
i1); /* [-1, 1] */
}

int
pattern1099 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x1, operands[1]))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (!rtx_equal_p (x2, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1112 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern1121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MINUS:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      switch (XWINT (x4, 0))
        {
        case 64LL:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (!rtx_equal_p (x9, operands[2]))
            return -1;
          return 0;

        case 32LL:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
      if (pattern1134 (x1) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1152 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != IF_THEN_ELSE)
    return -1;
  x8 = XEXP (x7, 0);
  if (!bt_comparison_operator (x8, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return pattern1165 (x1); /* [-1, 4] */

    default:
      return -1;
    }
}

int
pattern1174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1178 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i3)
      || pattern418 (
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1186 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !nonimmediate_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern1197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V8HFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8HFmode
      || !nonimm_or_0_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1217 (x2, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1217 (x2, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1226 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !x86_64_general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2QImode)
      || GET_MODE (x1) != E_V2QImode
      || !register_operand (operands[1], E_V2QImode)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!general_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!general_gr_operand (operands[3], i1))
    return -1;
  x4 = PATTERN (peep2_next_insn (3));
  return pattern882 (x4, 
i1); /* [-1, 0] */
}

int
pattern1248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 0;
}

int
pattern1265 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 2);
  if (XWINT (x3, 0) != 1LL
      || !const_0_to_255_operand (operands[3], E_SImode))
    return -1;
  return pattern1285 (x1); /* [-1, 2] */
}

int
pattern1293 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1299 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1308 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_XFmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_XFmode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_XFmode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XVECEXP (x8, 0, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  return 0;
}

int
pattern1323 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !addsub_vm_operator (operands[6], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !vector_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1334 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[6], i3))
    return -1;
  return 0;
}

int
pattern1344 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], E_VOIDmode)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SImode)
      || GET_MODE (x1) != E_V8SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V8SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8SImode
      || !nonimm_or_0_operand (operands[2], E_V8SImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    case E_V8DFmode:
      if (!register_operand (operands[1], E_V8DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1366 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  operands[2] = x2;
  if (!const_4_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  operands[3] = x3;
  if (!const_4_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  operands[4] = x4;
  if (!const_4_to_7_operand (operands[4], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  operands[5] = x5;
  if (!const_4_to_7_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1377 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1384 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1390 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[2], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i4
      || !register_operand (operands[1], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1405 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      x4 = XEXP (x3, 0);
      if (!plusminuslogic_operator (x4, i1))
        return -1;
      operands[3] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!nonmemory_operand (operands[2], i1))
        return -1;
      x9 = XEXP (x4, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      x10 = XEXP (x7, 1);
      if (!rtx_equal_p (x10, operands[3]))
        return -1;
      x11 = XEXP (x7, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 0;

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      if (peep2_current_count < 4)
        return -1;
      operands[3] = x3;
      if (!plusminuslogic_operator (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[4]))
        return -1;
      x12 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x12) != SET)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1434 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !x86_64_immediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1447 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3
      || peep2_current_count < 4)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 40
      || GET_MODE (x3) != E_CCCmode)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 17
      || GET_MODE (x5) != E_CCCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != NEG
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[1] = x8;
  if (!general_reg_operand (operands[1], i1))
    return -1;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = PATTERN (peep2_next_insn (2));
  return pattern1446 (x11, 
i1); /* [-1, 0] */
}

int
pattern1461 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1469 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1479 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[2], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1486 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1485 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1485 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1497 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1506 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i3
      || !vector_operand (operands[1], i2))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i3
      || !vector_operand (operands[2], i2)
      || !const1_operand (operands[3], i2)
      || !nonimm_or_0_operand (operands[4], i2)
      || !register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1521 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1529 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern1540 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i2)
      || !const0_operand (operands[5], i1)
      || !register_operand (operands[6], i3))
    return -1;
  return 0;
}

int
pattern1552 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!bt_comparison_operator (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V16QImode:
      return pattern1551 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern1551 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern1551 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern1551 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern1551 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern1551 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern1551 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern1551 (x1, 
E_V32QImode) != 0)
        return -1;
      return 7;

    case E_V16HImode:
      if (pattern1551 (x1, 
E_V16HImode) != 0)
        return -1;
      return 8;

    case E_V8SImode:
      if (pattern1551 (x1, 
E_V8SImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern1551 (x1, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V2TImode:
      if (pattern1551 (x1, 
E_V2TImode) != 0)
        return -1;
      return 11;

    case E_V8SFmode:
      if (pattern1551 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 12;

    case E_V4DFmode:
      if (pattern1551 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern1579 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1578 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1578 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1591 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!nonimmediate_operand (operands[3], E_V16QImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[4] = x6;
  if (!const_0_to_255_operand (operands[4], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x9 = XEXP (x7, 1);
  x10 = XVECEXP (x9, 0, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (!rtx_equal_p (x12, operands[4]))
    return -1;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 1);
  x15 = XVECEXP (x14, 0, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x14, 0, 1);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = XVECEXP (x14, 0, 2);
  if (!rtx_equal_p (x17, operands[4]))
    return -1;
  return 0;
}

int
pattern1609 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1616 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[11], i1))
    return -1;
  return 0;
}

int
pattern1625 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1635 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1642 (rtx x1, machine_mode i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MULT
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != SIGN_EXTEND
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 4)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x11, 0, 2);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x15 = XVECEXP (x11, 0, 3);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  return 0;
}

int
pattern1668 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x1, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern1676 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1684 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (!register_operand (x6, E_SImode))
    return -1;
  return 0;
}

int
pattern1690 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i4
      || !vector_operand (operands[2], i3)
      || !nonimm_or_0_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1697 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6LL)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 22LL)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7LL)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 23LL)
    return -1;
  return 0;
}

int
pattern1702 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_scalar_int_operand (operands[6], i2)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !ix86_carry_flag_operator (operands[5], i1)
      || !x86_64_immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1713 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 8);
  if (XWINT (x2, 0) != 12LL)
    return -1;
  x3 = XVECEXP (x1, 0, 9);
  if (XWINT (x3, 0) != 28LL)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (XWINT (x4, 0) != 13LL)
    return -1;
  x5 = XVECEXP (x1, 0, 11);
  if (XWINT (x5, 0) != 29LL)
    return -1;
  return 0;
}

int
pattern1718 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != GTU
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[7] = x5;
  if (!register_operand (operands[7], E_QImode))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != LTU
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x7, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x6, 0);
  operands[8] = x10;
  if (!register_operand (operands[8], E_QImode))
    return -1;
  x11 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != COMPARE)
    return -1;
  x13 = XEXP (x11, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 17)
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[7]))
    return -1;
  x15 = XEXP (x12, 1);
  if (!rtx_equal_p (x15, operands[8]))
    return -1;
  return 0;
}

int
pattern1732 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !x86_64_sext_operand (operands[2], i1)
      || pattern1730 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1740 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[5], i1)
      || !general_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1747 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i3
      || !vector_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (!const48_operand (x3, E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (XVECLEN (x4, 0))
    {
    case 3:
      if (XINT (x4, 1) != 59)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[2] = x7;
      x8 = XVECEXP (x4, 0, 2);
      operands[3] = x8;
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !nonimmediate_operand (operands[2], E_V16SImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2761; /* avx512f_cmpv16si3_round */

            case E_V16HFmode:
              if (!register_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[2], E_V16HFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2785; /* avx512vl_cmpv16hf3_round */

            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[2], E_V16SFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2791; /* avx512f_cmpv16sf3_round */

            default:
              return -1;
            }

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !nonimmediate_operand (operands[2], E_V8SImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2765; /* avx512vl_cmpv8si3_round */

            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !nonimmediate_operand (operands[2], E_V8DImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2771; /* avx512f_cmpv8di3_round */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !nonimmediate_operand (operands[2], E_V4DImode)
                  || !const_0_to_7_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DImode == V16SFmode
									       || V4DImode == V8DFmode
									       || V4DImode == V8DImode
									       || V4DImode == V16SImode
									       || V4DImode == V32HImode
									       || V4DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DImode == V8SFmode
										       || V4DImode == V4DFmode
										       || V4DImode == V4DImode
										       || V4DImode == V8SImode
										       || V4DImode == V16HImode
										       || V4DImode == V16HFmode)))) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2775; /* avx512vl_cmpv4di3_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[2], E_V8SFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2795; /* avx512vl_cmpv8sf3_round */

            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[2], E_V8DFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2801; /* avx512f_cmpv8df3_round */

            case E_V4DFmode:
              if (!register_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[2], E_V4DFmode)
                  || !const_0_to_31_operand (operands[3], E_SImode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2805; /* avx512vl_cmpv4df3_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 61
          || GET_MODE (x4) != E_CCFPmode
          || pattern779 (x4) != 0
          || pattern332 (x1, 
E_CCFPmode) != 0)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      x7 = XVECEXP (x4, 0, 1);
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      operands[2] = x3;
      switch (GET_MODE (x6))
        {
        case E_HFmode:
          if (!register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x7) != E_HFmode
              || !register_operand (operands[1], E_V8HFmode)
              || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4853 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1355 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3150; /* avx10_2_comxhf_round */

        case E_SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x7) != E_SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 3154; /* avx10_2_comxsf_round */

        case E_DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x7) != E_DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 3158; /* avx10_2_comxdf_round */

        default:
          return -1;
        }

    case 1:
      if (XINT (x4, 1) != 26
          || GET_MODE (x4) != E_CCFPmode
          || pattern332 (x1, 
E_CCFPmode) != 0)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      if (GET_MODE (x6) != E_CCFPmode)
        return -1;
      operands[2] = x3;
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 61)
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x11) != VEC_SELECT)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 1)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x14) != VEC_SELECT)
            return -1;
          x15 = XEXP (x14, 1);
          if (GET_CODE (x15) != PARALLEL
              || XVECLEN (x15, 0) != 1)
            return -1;
          x16 = XVECEXP (x15, 0, 0);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x17 = XEXP (x11, 0);
          operands[0] = x17;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          switch (GET_MODE (x11))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x14) != E_HFmode
                  || !register_operand (operands[1], E_V8HFmode)
                  || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4853 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 1355 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3152; /* avx10_2_ucomxhf_round */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x14) != E_SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 3156; /* avx10_2_ucomxsf_round */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x14) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4853 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 3160; /* avx10_2_ucomxdf_round */

            default:
              return -1;
            }

        case COMPARE:
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x19 = XEXP (x9, 1);
          if (GET_CODE (x19) != PARALLEL
              || XVECLEN (x19, 0) != 1)
            return -1;
          x20 = XVECEXP (x19, 0, 0);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x21 = XEXP (x6, 1);
          if (GET_CODE (x21) != VEC_SELECT)
            return -1;
          x22 = XEXP (x21, 1);
          if (GET_CODE (x22) != PARALLEL
              || XVECLEN (x22, 0) != 1)
            return -1;
          x23 = XVECEXP (x22, 0, 0);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x24 = XEXP (x9, 0);
          operands[0] = x24;
          x25 = XEXP (x21, 0);
          operands[1] = x25;
          switch (GET_MODE (x9))
            {
            case E_HFmode:
              if (!register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x21) != E_HFmode
                  || !register_operand (operands[1], E_V8HFmode)
                  || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4868 "../../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (HFmode) || HFmode == E_HFmode) && 
#line 1355 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3164; /* avx512fp16_ucomi_round */

            case E_SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x21) != E_SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4868 "../../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (SFmode) || SFmode == E_HFmode)))
                return -1;
              return 3168; /* sse_ucomi_round */

            case E_DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x21) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !(
#line 296 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 4868 "../../../gcc/config/i386/sse.md"
(SSE_FLOAT_MODE_P (DFmode) || DFmode == E_HFmode)))
                return -1;
              return 3172; /* sse2_ucomi_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != ZERO_EXTEND
              || pattern765 (x2, 
E_DImode) != 0
              || !const_int_operand (operands[3], E_DImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !
#line 3748 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll))
            return -1;
          return 127; /* *insvdi_lowpart_1 */

        case XOR:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          x10 = XEXP (x6, 1);
          operands[2] = x10;
          if (!nonimmediate_operand (operands[2], E_HImode)
              || !nonimmediate_operand (operands[3], E_HImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (!rtx_equal_p (x7, operands[1])
              || !
#line 13684 "../../../gcc/config/i386/i386.md"
(TARGET_BMI && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 681; /* *xor2andn */

        default:
          return -1;
        }

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern781 (x2, 
E_QImode) != 0
                  || !
#line 8015 "../../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 304; /* *leaqi_general_4 */

            case E_HImode:
              if (pattern781 (x2, 
E_HImode) != 0
                  || !
#line 8015 "../../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))))
                return -1;
              return 306; /* *leahi_general_4 */

            case E_TImode:
              if (pattern782 (x2, 
E_TImode) != 0
                  || !(
#line 14137 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 748; /* *concatditi3_5 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern555 (x2) != 0
              || !(
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 757; /* *concatditi3_6 */

        case ZERO_EXTEND:
          if (pattern555 (x2) != 0
              || !(
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 760; /* *concatditi3_6 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (pattern77 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 12741 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 589; /* *xorqi_1_slp */
            }
          break;

        case 1:
          if (
#line 12741 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            {
              *pnum_clobbers = 1;
              return 592; /* *xorhi_1_slp */
            }
          break;

        case 2:
          if ((
#line 13527 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 665; /* *xorti3_doubleword */
            }
          break;

        case 3:
          if (
#line 13585 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 668; /* *xorhi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 13585 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)
   && true))
            {
              *pnum_clobbers = 1;
              return 669; /* *xorhi_1 */
            }
          break;

        case 4:
          if (
#line 2582 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1663; /* xorv2bf3 */
          break;

        case 5:
          if (
#line 2582 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
            return 1666; /* xorv2hf3 */
          break;

        case 6:
          if (
#line 4687 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (XOR, V8QImode, operands)))
            return 1798; /* *mmx_xorv8qi3 */
          break;

        case 7:
          if (
#line 4687 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (XOR, V4HImode, operands)))
            return 1801; /* *mmx_xorv4hi3 */
          break;

        case 8:
          if (
#line 4687 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && ix86_binary_operator_ok (XOR, V2SImode, operands)))
            return 1804; /* *mmx_xorv2si3 */
          break;

        case 9:
          if (
#line 4713 "../../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V4QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 1807; /* *xorv4qi3 */
            }
          break;

        case 10:
          if (
#line 4713 "../../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2QImode, operands)))
            {
              *pnum_clobbers = 1;
              return 1810; /* *xorv2qi3 */
            }
          break;

        case 11:
          if (
#line 4713 "../../../gcc/config/i386/mmx.md"
(ix86_binary_operator_ok (XOR, V2HImode, operands)))
            {
              *pnum_clobbers = 1;
              return 1813; /* *xorv2hi3 */
            }
          break;

        case 12:
          if (
#line 5662 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3266; /* xorbf3 */
          break;

        case 13:
          if (
#line 5662 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3269; /* xorhf3 */
          break;

        case 14:
          if (
#line 5662 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return 3272; /* xorsf3 */
          break;

        case 15:
          if ((
#line 5662 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 1352 "../../../gcc/config/i386/i386.md"
(TARGET_SSE2)))
            return 3275; /* xordf3 */
          break;

        case 16:
          if (
#line 5736 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return 3278; /* *xortf3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL
          && pattern78 (x2) == 0)
        {
          x6 = XEXP (x3, 0);
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          switch (pattern1164 (x1))
            {
            case 0:
              if (
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 595; /* *xorqi_exthi_1_slp */
                }
              break;

            case 1:
              if (
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                {
                  *pnum_clobbers = 1;
                  return 598; /* *xorqi_extsi_1_slp */
                }
              break;

            case 2:
              if ((
#line 12768 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 601; /* *xorqi_extdi_1_slp */
                }
              break;

            case 3:
              *pnum_clobbers = 1;
              return 617; /* *xorqi_exthi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 620; /* *xorqi_extsi_0 */

            default:
              break;
            }
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) == SUBREG)
            {
              switch (pattern1166 (x1))
                {
                case 0:
                  if (
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 604; /* *xorqi_exthi_2_slp */
                    }
                  break;

                case 1:
                  if (
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                    {
                      *pnum_clobbers = 1;
                      return 607; /* *xorqi_extsi_2_slp */
                    }
                  break;

                case 2:
                  if ((
#line 12801 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 610; /* *xorqi_extdi_2_slp */
                    }
                  break;

                case 3:
                  *pnum_clobbers = 1;
                  return 623; /* *xorqi_ext2hi_0 */

                case 4:
                  *pnum_clobbers = 1;
                  return 626; /* *xorqi_ext2si_0 */

                default:
                  break;
                }
            }
        }
      operands[1] = x3;
      if (pattern79 (x1) != 0)
        return -1;
      if (
#line 13775 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
        return 706; /* *xorqi_1_nf */
      if (pnum_clobbers == NULL
          || !
#line 13775 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)
   && true))
        return -1;
      *pnum_clobbers = 1;
      return 707; /* *xorqi_1 */

    case ZERO_EXTEND:
      if (pattern40 (x1) != 0
          || !(
#line 14198 "../../../gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      return 766; /* *concatditi3_7 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern240 (x3, pnum_clobbers, 
E_TImode) != 0
          || !(
#line 14600 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 806; /* *absti2_doubleword */

    case E_QImode:
      if (pattern240 (x3, pnum_clobbers, 
E_QImode) != 0
          || !
#line 14687 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 809; /* *absqi2_1 */

    case E_HImode:
      if (pattern240 (x3, pnum_clobbers, 
E_HImode) != 0
          || !
#line 14687 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 810; /* *abshi2_1 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14810 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 820; /* *abssf2_i387_1 */
        }
      if (!
#line 14932 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 834; /* *abssf2_i387 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14810 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 822; /* *absdf2_i387_1 */
        }
      if (!
#line 14932 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 836; /* *absdf2_i387 */

    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || !register_operand (operands[1], E_XFmode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 14810 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 824; /* *absxf2_i387_1 */
        }
      if (!
#line 14932 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
        return -1;
      return 838; /* *absxf2_i387 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_mmxmem_operand (operands[1], E_V8QImode)
          || !
#line 3814 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 1727; /* ssse3_absv8qi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_mmxmem_operand (operands[1], E_V4HImode)
          || !
#line 3814 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 1728; /* ssse3_absv4hi2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_mmxmem_operand (operands[1], E_V2SImode)
          || !
#line 3814 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
        return -1;
      return 1729; /* ssse3_absv2si2 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode)
          || !
#line 3835 "../../../gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 1730; /* absv4qi2 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode)
          || !
#line 3835 "../../../gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 1731; /* absv2qi2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !
#line 3835 "../../../gcc/config/i386/mmx.md"
(TARGET_SSSE3))
        return -1;
      return 1732; /* absv2hi2 */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCCmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (pattern561 (x1))
    {
    case 0:
      if (!
#line 9893 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
        return -1;
      return 443; /* *setcc_qi_negqi_ccc_1_cc */

    case 1:
      if (!
#line 9893 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()))
        return -1;
      return 444; /* *setcc_qi_negqi_ccc_1_ccc */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == EQ)
    {
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  if (!bt_comparison_operator (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
      || !nonimmediate_operand (operands[0], E_QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode)
          || !(
#line 2383 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1555 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512DQ)))
        return -1;
      *pnum_clobbers = 1;
      return 2114; /* *kortest_cmpqi_setcc */

    case E_HImode:
      if (!register_operand (operands[2], E_HImode)
          || !
#line 2383 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))
        return -1;
      *pnum_clobbers = 1;
      return 2115; /* *kortest_cmphi_setcc */

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 2383 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))
        return -1;
      *pnum_clobbers = 1;
      return 2116; /* *kortest_cmpsi_setcc */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x3;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (pattern688 (
E_SFmode) != 0
          || !
#line 19676 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)))
        return -1;
      return 1200; /* setcc_sf_sse */

    case E_DFmode:
      if (pattern688 (
E_DFmode) != 0
          || !
#line 19676 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)))
        return -1;
      return 1201; /* setcc_df_sse */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LTU:
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG
      && REGNO (x3) == 17)
    {
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  switch (GET_CODE (operands[1]))
    {
    case NE:
    case EQ:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      operands[2] = x3;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern689 (
E_V8QImode) != 0
              || !
#line 4218 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1768; /* *xop_maskcmp_unsv8qi3 */

        case E_V4HImode:
          if (pattern689 (
E_V4HImode) != 0
              || !
#line 4218 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1769; /* *xop_maskcmp_unsv4hi3 */

        case E_V2SImode:
          if (pattern689 (
E_V2SImode) != 0
              || !
#line 4218 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1770; /* *xop_maskcmp_unsv2si3 */

        case E_V4QImode:
          if (pattern689 (
E_V4QImode) != 0
              || !
#line 4228 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1771; /* *xop_maskcmp_unsv4qi3 */

        case E_V2QImode:
          if (pattern689 (
E_V2QImode) != 0
              || !
#line 4228 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1772; /* *xop_maskcmp_unsv2qi3 */

        case E_V2HImode:
          if (pattern689 (
E_V2HImode) != 0
              || !
#line 4228 "../../../gcc/config/i386/mmx.md"
(TARGET_XOP))
            return -1;
          return 1773; /* *xop_maskcmp_unsv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_54 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case DIV:
      if (GET_MODE (x2) == E_HFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (nonimmediate_operand (operands[1], E_HFmode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (nonimmediate_operand (operands[2], E_HFmode)
                      && 
#line 23445 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return 1339; /* *divhf */
                }
            }
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !binary_fp_operator (operands[3], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !register_operand (operands[2], E_XFmode))
                return -1;
              if (
#line 23397 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && COMMUTATIVE_ARITH_P (operands[3])))
                return 1333; /* *fop_xf_comm_i387 */
              if (!
#line 23495 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && !COMMUTATIVE_ARITH_P (operands[3])))
                return -1;
              return 1342; /* *fop_xf_1_i387 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !binary_fp_operator (operands[3], E_SFmode)
                  || !nonimmediate_operand (operands[2], E_SFmode))
                return -1;
              if (nonimmediate_operand (operands[1], E_SFmode)
                  && 
#line 23411 "../../../gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (SFmode)))
   && COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 1334; /* *fop_sf_comm */
              if (!x87nonimm_ssenomem_operand (operands[1], E_SFmode)
                  || !
#line 23511 "../../../gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (SFmode)))
   && !COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 1343; /* *fop_sf_1 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !binary_fp_operator (operands[3], E_DFmode)
                  || !nonimmediate_operand (operands[2], E_DFmode))
                return -1;
              if (nonimmediate_operand (operands[1], E_DFmode)
                  && 
#line 23411 "../../../gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (DFmode)))
   && COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 1335; /* *fop_df_comm */
              if (!x87nonimm_ssenomem_operand (operands[1], E_DFmode)
                  || !
#line 23511 "../../../gcc/config/i386/i386.md"
(((SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
    || (TARGET_80387 && X87_ENABLE_ARITH (DFmode)))
   && !COMMUTATIVE_ARITH_P (operands[3])
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 1344; /* *fop_df_1 */

            default:
              return -1;
            }

        case FLOAT:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              switch (pattern788 (x5, 
E_SFmode))
                {
                case 0:
                  if (!
#line 23567 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, HImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1351; /* *fop_sf_3_i387 */

                case 1:
                  if (!
#line 23567 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, SImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1354; /* *fop_sf_3_i387 */

                default:
                  return -1;
                }

            case E_DFmode:
              switch (pattern788 (x5, 
E_DFmode))
                {
                case 0:
                  if (!
#line 23567 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, HImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1352; /* *fop_df_3_i387 */

                case 1:
                  if (!
#line 23567 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, SImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1355; /* *fop_df_3_i387 */

                default:
                  return -1;
                }

            case E_XFmode:
              switch (pattern788 (x5, 
E_XFmode))
                {
                case 0:
                  if (!
#line 23567 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, HImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1353; /* *fop_xf_3_i387 */

                case 1:
                  if (!
#line 23567 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, SImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 1356; /* *fop_xf_3_i387 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (pattern690 ())
            {
            case 0:
              if (!register_operand (operands[1], E_XFmode)
                  || GET_MODE (x5) != E_XFmode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_SFmode:
                  if (!nonimmediate_operand (operands[2], E_SFmode)
                      || !
#line 23623 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1360; /* *fop_xf_5_i387 */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[2], E_DFmode)
                      || !
#line 23623 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1361; /* *fop_xf_5_i387 */

                default:
                  return -1;
                }

            case 1:
              if (!register_operand (operands[1], E_DFmode)
                  || GET_MODE (x5) != E_DFmode
                  || !nonimmediate_operand (operands[2], E_SFmode)
                  || !
#line 23640 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_ARITH (DFmode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1362; /* *fop_df_5_i387 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern691 (x4, 
E_SFmode))
            {
            case 0:
              if (!
#line 23546 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, HImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1345; /* *fop_sf_2_i387 */

            case 1:
              if (!
#line 23546 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (SFmode, SImode)
   && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1348; /* *fop_sf_2_i387 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern691 (x4, 
E_DFmode))
            {
            case 0:
              if (!
#line 23546 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, HImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1346; /* *fop_df_2_i387 */

            case 1:
              if (!
#line 23546 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (DFmode, SImode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1349; /* *fop_df_2_i387 */

            default:
              return -1;
            }

        case E_XFmode:
          switch (pattern691 (x4, 
E_XFmode))
            {
            case 0:
              if (!
#line 23546 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, HImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1347; /* *fop_xf_2_i387 */

            case 1:
              if (!
#line 23546 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_FLOAT (XFmode, SImode)
   && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                return -1;
              return 1350; /* *fop_xf_2_i387 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (pattern690 ())
            {
            case 0:
              if (GET_MODE (x4) != E_XFmode
                  || !register_operand (operands[2], E_XFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (!nonimmediate_operand (operands[1], E_SFmode)
                      || !
#line 23588 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1357; /* *fop_xf_4_i387 */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[1], E_DFmode)
                      || !
#line 23588 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1358; /* *fop_xf_4_i387 */

                default:
                  return -1;
                }

            case 1:
              if (GET_MODE (x4) != E_DFmode
                  || !nonimmediate_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_DFmode)
                  || !
#line 23605 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_ARITH (DFmode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1359; /* *fop_df_4_i387 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !binary_fp_operator (operands[3], E_XFmode)
                  || GET_MODE (x4) != E_XFmode
                  || GET_MODE (x5) != E_XFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (!register_operand (operands[1], E_SFmode)
                      || !nonimmediate_operand (operands[2], E_SFmode)
                      || !
#line 23659 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1363; /* *fop_xf_6_i387 */

                case E_DFmode:
                  if (!register_operand (operands[1], E_DFmode)
                      || !nonimmediate_operand (operands[2], E_DFmode)
                      || !
#line 23659 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                    return -1;
                  return 1364; /* *fop_xf_6_i387 */

                default:
                  return -1;
                }

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !binary_fp_operator (operands[3], E_DFmode)
                  || GET_MODE (x4) != E_DFmode
                  || !register_operand (operands[1], E_SFmode)
                  || GET_MODE (x5) != E_DFmode
                  || !nonimmediate_operand (operands[2], E_SFmode)
                  || !
#line 23677 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && X87_ENABLE_ARITH (DFmode)
   && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 1365; /* *fop_df_6_i387 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern695 (x2, 
E_SImode))
            {
            case 0:
              if (
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 228; /* *addqi_1_zextsi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 229; /* *addqi_1_zextsi */

            case 1:
              if (
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 232; /* *addhi_1_zextsi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 233; /* *addhi_1_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern695 (x2, 
E_DImode))
            {
            case 0:
              if (
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 230; /* *addqi_1_zextdi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 231; /* *addqi_1_zextdi */

            case 1:
              if (
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && TARGET_APX_NF
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return 234; /* *addhi_1_zextdi_nf */
              if (pnum_clobbers == NULL
                  || !
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 235; /* *addhi_1_zextdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case LTU:
        case UNLT:
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 17)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern1250 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 388; /* *addqi3_carry_zextsi */

                case 1:
                  if (!
#line 8914 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 390; /* *addhi3_carry_zextsi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern1250 (x2, 
E_DImode))
                {
                case 0:
                  if (!
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 389; /* *addqi3_carry_zextdi */

                case 1:
                  if (!
#line 8914 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 391; /* *addhi3_carry_zextdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern246 (x3, pnum_clobbers))
        {
        case 0:
          switch (pattern1097 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 393; /* *addqi3_carry_zextsi_0 */

            case 1:
              if (!
#line 8966 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 395; /* *addhi3_carry_zextsi_0 */

            default:
              return -1;
            }

        case 1:
          switch (pattern1097 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 394; /* *addqi3_carry_zextdi_0 */

            case 1:
              if (!
#line 8966 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 396; /* *addhi3_carry_zextdi_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern246 (x3, pnum_clobbers))
        {
        case 0:
          switch (pattern1098 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 398; /* *addqi3_carry_zextsi_0r */

            case 1:
              if (!
#line 9011 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 400; /* *addhi3_carry_zextsi_0r */

            default:
              return -1;
            }

        case 1:
          switch (pattern1098 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 399; /* *addqi3_carry_zextdi_0r */

            case 1:
              if (!
#line 9011 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
                return -1;
              *pnum_clobbers = 1;
              return 401; /* *addhi3_carry_zextdi_0r */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 19
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 23231 "../../../gcc/config/i386/i386.md"
(TARGET_X32))
        return -1;
      *pnum_clobbers = 1;
      return 1329; /* *add_tp_x32_zext */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      switch (pattern377 (x2))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 8069 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 309; /* *subdi3_doubleword */
            }
          if (!x86_64_general_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 8125 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 319; /* *subdi_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 8125 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 320; /* *subdi_1 */

        case 1:
          if (
#line 8125 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 317; /* *subsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 8125 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
  && true))
            return -1;
          *pnum_clobbers = 1;
          return 318; /* *subsi_1 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode
          || pattern698 (x2, 
E_SImode, 
E_DImode) != 0
          || !(
#line 8103 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 311; /* *subdi3_doubleword_zext */

    case LTU:
    case UNLT:
      switch (pattern381 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1100 (x2, 
E_SImode) != 0
              || !
#line 9349 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 412; /* *subsi3_carry_0 */

        case 1:
          if (pattern1100 (x2, 
E_DImode) != 0
              || !(
#line 9349 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 413; /* *subdi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern381 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1101 (x2, 
E_SImode) != 0
              || !
#line 9363 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 416; /* *subsi3_carry_0r */

        case 1:
          if (pattern1101 (x2, 
E_DImode) != 0
              || !(
#line 9363 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 417; /* *subdi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern383 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 10307 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 493; /* *subsi3_eq_0 */

        case 1:
          if (!(
#line 10307 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *subdi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern383 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 10328 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 497; /* *subsi3_ne_0 */

        case 1:
          if (!(
#line 10328 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (MINUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 498; /* *subdi3_ne_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      operands[1] = x3;
      if (bt_comparison_operator (operands[1], E_VOIDmode))
        {
          res = recog_75 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x3) != NE
          || GET_MODE (x3) != E_QImode
          || XWINT (x4, 0) != 0LL)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UMIN
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x2, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x3, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[1] = x11;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x13 = XEXP (x7, 0);
      if (!rtx_equal_p (x13, operands[2])
          || !
#line 22036 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && INTVAL (operands[3]) == 4 * BITS_PER_UNIT))
        return -1;
      *pnum_clobbers = 1;
      return 1290; /* *bmi2_bzhi_si3 */

    case LTU:
    case UNLT:
      operands[1] = x3;
      if (!ix86_carry_flag_operator (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 17
          || XWINT (x4, 0) != 0LL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x9 = XEXP (x2, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      *pnum_clobbers = 1;
      return 1447; /* *x86_movsicc_0_m1 */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern74 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 12501 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 569; /* *anddi3_doubleword */

        case E_SImode:
          if (pattern376 (x3) != 0)
            return -1;
          if (
#line 12671 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF))
            return 583; /* *andsi_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 12671 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 584; /* *andsi_1 */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern683 (x3, 
E_DImode) != 0)
                return -1;
              if ((
#line 13312 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 654; /* *andndi3_doubleword_bmi */
                }
              if (!(
#line 13330 "../../../gcc/config/i386/i386.md"
(!TARGET_BMI
   && ix86_pre_reload_split ()) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 655; /* *andndi3_doubleword */

            case E_SImode:
              if (pattern683 (x3, 
E_SImode) != 0
                  || !
#line 13346 "../../../gcc/config/i386/i386.md"
(TARGET_BMI || TARGET_AVX512BW))
                return -1;
              *pnum_clobbers = 1;
              return 657; /* *andnsi_1 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern991 (x3, 
E_SImode) != 0
                  || !
#line 19362 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1185; /* *btsi_setncsi */

            case E_DImode:
              if (pattern991 (x3, 
E_DImode) != 0
                  || !(
#line 19362 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1186; /* *btdi_setncdi */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22084 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          *pnum_clobbers = 1;
          return 1293; /* *bmi2_bzhi_si3_3 */

        default:
          return -1;
        }

    case ROTATE:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      switch (pattern251 (x3))
        {
        case 0:
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (pattern699 (x3) == 0
              && 
#line 18873 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
            {
              *pnum_clobbers = 1;
              return 1155; /* *btrsi */
            }
          if (GET_CODE (x9) != SUBREG)
            return -1;
          switch (pattern700 (x3))
            {
            case 0:
              if (!
#line 18892 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 1156; /* *btrsi_mask */

            case 1:
              if (!(
#line 18892 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1157; /* *btrdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18920 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1158; /* *btrsi_mask_1 */

        case 2:
          if (!(
#line 18920 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1159; /* *btrdi_mask_1 */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern384 (x3) != 0
          || !
#line 21761 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
        return -1;
      *pnum_clobbers = 1;
      return 1277; /* *bmi_blsi_si */

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != CONST_INT
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x9, 0))
            {
            case -1LL:
              x5 = XEXP (x3, 1);
              switch (pattern1099 (x5))
                {
                case 0:
                  if (!
#line 21906 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1286; /* *bmi_blsr_si */

                case 1:
                  if (!
#line 22277 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1305; /* *tbm_tzmsk_si */

                default:
                  return -1;
                }

            case 1LL:
              x5 = XEXP (x3, 1);
              switch (pattern1099 (x5))
                {
                case 0:
                  if (!
#line 22168 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1297; /* *tbm_blcfill_si */

                case 1:
                  if (!
#line 22196 "../../../gcc/config/i386/i386.md"
(TARGET_TBM))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1299; /* *tbm_blcic_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x9, 0) != -1LL)
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22070 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2))
            return -1;
          *pnum_clobbers = 1;
          return 1292; /* *bmi2_bzhi_si3_2 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x10 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XVECEXP (x4, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x4, 0, 1);
          operands[2] = x12;
          switch (XINT (x4, 1))
            {
            case 59:
              operands[3] = x10;
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern975 (x3, 
E_SImode) == 0)
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V32HFmode:
                          if (register_operand (operands[1], E_V32HFmode)
                              && nonimmediate_operand (operands[2], E_V32HFmode)
                              && const_0_to_31_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4394 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                            return 2782; /* avx512bw_cmpv32hf3_mask */
                          break;

                        case E_V32QImode:
                          if (register_operand (operands[1], E_V32QImode)
                              && nonimmediate_operand (operands[2], E_V32QImode)
                              && const_0_to_7_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4486 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                            return 2920; /* avx512vl_cmpv32qi3_mask */
                          break;

                        case E_V32HImode:
                          if (register_operand (operands[1], E_V32HImode)
                              && nonimmediate_operand (operands[2], E_V32HImode)
                              && const_0_to_7_operand (operands[3], E_SImode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4486 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                            return 2922; /* avx512bw_cmpv32hi3_mask */
                          break;

                        case E_V32BFmode:
                          if (register_operand (operands[1], E_V32BFmode)
                              && nonimmediate_operand (operands[2], E_V32BFmode)
                              && const_0_to_31_operand (operands[3], E_VOIDmode)
                              && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32459 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
                            return 10089; /* avx10_2_cmpbf16_v32bf_mask */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case E_DImode:
                  if (pattern902 (x3) == 0
                      && register_operand (operands[4], E_DImode)
                      && (
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4486 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return 2916; /* avx512bw_cmpv64qi3_mask */
                  break;

                default:
                  break;
                }
              if (XWINT (x10, 0) != 0LL)
                return -1;
              switch (pattern900 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2976; /* *avx512bw_eqv64qi3_mask_1 */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 2984; /* *avx512vl_eqv32qi3_mask_1 */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 2988; /* *avx512bw_eqv32hi3_mask_1 */

                default:
                  return -1;
                }

            case 157:
              if (XWINT (x10, 0) == 0LL)
                {
                  switch (pattern900 (x3))
                    {
                    case 0:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 2978; /* *avx512bw_eqv64qi3_mask_1 */
                      break;

                    case 1:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return 2986; /* *avx512vl_eqv32qi3_mask_1 */
                      break;

                    case 2:
                      if ((
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return 2990; /* *avx512bw_eqv32hi3_mask_1 */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x10;
              if (!const_0_to_7_operand (operands[3], E_SImode))
                return -1;
              x5 = XEXP (x3, 1);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern992 (x3, 
E_V64QImode, 
E_DImode) != 0
                      || !register_operand (operands[4], E_DImode)
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4596 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3000; /* avx512bw_ucmpv64qi3_mask */

                case E_SImode:
                  if (pattern975 (x3, 
E_SImode) != 0)
                    return -1;
                  switch (pattern798 ())
                    {
                    case 0:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4596 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                        return -1;
                      return 3004; /* avx512vl_ucmpv32qi3_mask */

                    case 1:
                      if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4596 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                        return -1;
                      return 3006; /* avx512bw_ucmpv32hi3_mask */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x11 = XVECEXP (x4, 0, 0);
          operands[1] = x11;
          x12 = XVECEXP (x4, 0, 1);
          operands[2] = x12;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (XINT (x4, 1))
            {
            case 158:
              switch (pattern801 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7530; /* avx512bw_testmv64qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7532; /* avx512vl_testmv32qi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19065 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7536; /* avx512bw_testmv32hi3_mask */

                default:
                  return -1;
                }

            case 159:
              switch (pattern801 (x3))
                {
                case 0:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 504 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7554; /* avx512bw_testnmv64qi3_mask */

                case 1:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 505 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && TARGET_AVX512BW))))
                    return -1;
                  return 7556; /* avx512vl_testnmv32qi3_mask */

                case 2:
                  if (!(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 19076 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 507 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
                    return -1;
                  return 7560; /* avx512bw_testnmv32hi3_mask */

                default:
                  return -1;
                }

            case 193:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !vector_operand (operands[1], E_V32HFmode)
                  || !const_0_to_255_operand (operands[2], E_VOIDmode)
                  || !register_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29867 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ || VALID_AVX512FP16_REG_MODE(V32HFmode)) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 9359; /* avx512dq_fpclassv32hf_mask */

            case 214:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern800 (x3, 
E_DImode, 
E_V64QImode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 9687; /* avx512vl_vpshufbitqmbv64qi_mask */

                case E_SImode:
                  if (pattern800 (x3, 
E_SImode, 
E_V32QImode) != 0
                      || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 9691; /* avx512vl_vpshufbitqmbv32qi_mask */

                default:
                  return -1;
                }

            case 262:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nonimmediate_operand (operands[1], E_V32BFmode)
                  || !const_0_to_255_operand (operands[2], E_VOIDmode)
                  || !register_operand (operands[3], E_SImode)
                  || !(
#line 122 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32448 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
                return -1;
              return 10083; /* avx10_2_fpclassbf16_v32bf_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V64QImode:
      if (pattern904 (x2, 
E_V64QImode, 
E_DImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 514 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10341; /* avx10_2_vmovrsbv64qi_mask */

    case E_V32QImode:
      if (pattern904 (x2, 
E_V32QImode, 
E_SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10343; /* avx10_2_vmovrsbv32qi_mask */

    case E_V16QImode:
      if (pattern904 (x2, 
E_V16QImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10345; /* avx10_2_vmovrsbv16qi_mask */

    case E_V32HImode:
      if (pattern904 (x2, 
E_V32HImode, 
E_SImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 515 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10347; /* avx10_2_vmovrswv32hi_mask */

    case E_V16HImode:
      if (pattern904 (x2, 
E_V16HImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10349; /* avx10_2_vmovrswv16hi_mask */

    case E_V8HImode:
      if (pattern904 (x2, 
E_V8HImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10351; /* avx10_2_vmovrswv8hi_mask */

    case E_V16SImode:
      if (pattern904 (x2, 
E_V16SImode, 
E_HImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 516 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10353; /* avx10_2_vmovrsdv16si_mask */

    case E_V8SImode:
      if (pattern904 (x2, 
E_V8SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10355; /* avx10_2_vmovrsdv8si_mask */

    case E_V4SImode:
      if (pattern904 (x2, 
E_V4SImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10357; /* avx10_2_vmovrsdv4si_mask */

    case E_V8DImode:
      if (pattern904 (x2, 
E_V8DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS) && 
#line 517 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 10359; /* avx10_2_vmovrsqv8di_mask */

    case E_V4DImode:
      if (pattern904 (x2, 
E_V4DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10361; /* avx10_2_vmovrsqv4di_mask */

    case E_V2DImode:
      if (pattern904 (x2, 
E_V2DImode, 
E_QImode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32673 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && TARGET_MOVRS)))
        return -1;
      return 10363; /* avx10_2_vmovrsqv2di_mask */

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      x6 = XEXP (x2, 2);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern913 (x2, 
E_V16SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28157 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8734; /* *avx512f_vpermi2varv16si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16SImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8800; /* avx512f_vpermt2varv16si3_mask */
            }
          break;

        case E_V8DImode:
          if (pattern913 (x2, 
E_V8DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28157 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8735; /* *avx512f_vpermi2varv8di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 8802; /* avx512f_vpermt2varv8di3_mask */
            }
          break;

        case E_V8SImode:
          if (pattern913 (x2, 
E_V8SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28158 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8736; /* *avx512vl_vpermi2varv8si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8804; /* avx512vl_vpermt2varv8si3_mask */
            }
          break;

        case E_V4SImode:
          if (pattern913 (x2, 
E_V4SImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28158 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8737; /* *avx512vl_vpermi2varv4si3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4SImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8808; /* avx512vl_vpermt2varv4si3_mask */
            }
          break;

        case E_V4DImode:
          if (pattern913 (x2, 
E_V4DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8738; /* *avx512vl_vpermi2varv4di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V4DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8806; /* avx512vl_vpermt2varv4di3_mask */
            }
          break;

        case E_V2DImode:
          if (pattern913 (x2, 
E_V2DImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8739; /* *avx512vl_vpermi2varv2di3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V2DImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 8810; /* avx512vl_vpermt2varv2di3_mask */
            }
          break;

        case E_V32HImode:
          if (pattern913 (x2, 
E_V32HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28160 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8740; /* *avx512bw_vpermi2varv32hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32HImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28149 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 8812; /* avx512bw_vpermt2varv32hi3_mask */
            }
          break;

        case E_V16HImode:
          if (pattern913 (x2, 
E_V16HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28161 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8741; /* *avx512vl_vpermi2varv16hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16HImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28150 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8813; /* avx512vl_vpermt2varv16hi3_mask */
            }
          break;

        case E_V8HImode:
          if (pattern913 (x2, 
E_V8HImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28162 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8742; /* *avx512vl_vpermi2varv8hi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V8HImode)
                  && register_operand (operands[4], E_QImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
                return 8814; /* avx512vl_vpermt2varv8hi3_mask */
            }
          break;

        case E_V64QImode:
          if (pattern913 (x2, 
E_V64QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28163 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 8743; /* *avx512bw_vpermi2varv64qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V64QImode)
                  && register_operand (operands[4], E_DImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28152 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
                return 8815; /* avx512bw_vpermt2varv64qi3_mask */
            }
          break;

        case E_V32QImode:
          if (pattern913 (x2, 
E_V32QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28164 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8744; /* *avx512vl_vpermi2varv32qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V32QImode)
                  && register_operand (operands[4], E_SImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28153 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8816; /* avx512vl_vpermt2varv32qi3_mask */
            }
          break;

        case E_V16QImode:
          if (pattern913 (x2, 
E_V16QImode) == 0)
            {
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 0);
              operands[2] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28193 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28165 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8745; /* *avx512vl_vpermi2varv16qi3_mask */
              operands[2] = x7;
              operands[1] = x8;
              if (nonimmediate_operand (operands[3], E_V16QImode)
                  && register_operand (operands[4], E_HImode)
                  && rtx_equal_p (x5, operands[2])
                  && (
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28154 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
                return 8817; /* avx512vl_vpermt2varv16qi3_mask */
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x5) == SUBREG
          && known_eq (SUBREG_BYTE (x5), 0))
        {
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          x7 = XVECEXP (x3, 0, 1);
          operands[1] = x7;
          x9 = XEXP (x5, 0);
          if (rtx_equal_p (x9, operands[2]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1331 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) == 0
                      && (
#line 28209 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8746; /* *avx512f_vpermi2varv16sf3_mask */
                  break;

                case E_V8SFmode:
                  if (pattern1331 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) == 0
                      && (
#line 28209 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8747; /* *avx512vl_vpermi2varv8sf3_mask */
                  break;

                case E_V4SFmode:
                  if (pattern1331 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) == 0
                      && (
#line 28209 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8748; /* *avx512vl_vpermi2varv4sf3_mask */
                  break;

                case E_V8DFmode:
                  if (pattern1331 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) == 0
                      && (
#line 28209 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return 8749; /* *avx512f_vpermi2varv8df3_mask */
                  break;

                case E_V4DFmode:
                  if (pattern1331 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) == 0
                      && (
#line 28209 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8750; /* *avx512vl_vpermi2varv4df3_mask */
                  break;

                case E_V2DFmode:
                  if (pattern1331 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) == 0
                      && (
#line 28209 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return 8751; /* *avx512vl_vpermi2varv2df3_mask */
                  break;

                default:
                  break;
                }
            }
        }
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1177 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8801; /* avx512f_vpermt2varv16sf3_mask */

        case E_V8DFmode:
          if (pattern1177 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8803; /* avx512f_vpermt2varv8df3_mask */

        case E_V8SFmode:
          if (pattern1177 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8805; /* avx512vl_vpermt2varv8sf3_mask */

        case E_V4DFmode:
          if (pattern1177 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8807; /* avx512vl_vpermt2varv4df3_mask */

        case E_V4SFmode:
          if (pattern1177 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8809; /* avx512vl_vpermt2varv4sf3_mask */

        case E_V2DFmode:
          if (pattern1177 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28269 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8811; /* avx512vl_vpermt2varv2df3_mask */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x5;
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      x6 = XEXP (x2, 2);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern419 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8753; /* avx512f_vpermt2varv16si3_maskz_1 */

        case E_V16SFmode:
          if (pattern1178 (x2, 
E_V16SFmode, 
E_HImode, 
E_V16SImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28143 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8755; /* avx512f_vpermt2varv16sf3_maskz_1 */

        case E_V8DImode:
          if (pattern419 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8757; /* avx512f_vpermt2varv8di3_maskz_1 */

        case E_V8DFmode:
          if (pattern1178 (x2, 
E_V8DFmode, 
E_QImode, 
E_V8DImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28144 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8759; /* avx512f_vpermt2varv8df3_maskz_1 */

        case E_V8SImode:
          if (pattern419 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8761; /* avx512vl_vpermt2varv8si3_maskz_1 */

        case E_V8SFmode:
          if (pattern1178 (x2, 
E_V8SFmode, 
E_QImode, 
E_V8SImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28145 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8763; /* avx512vl_vpermt2varv8sf3_maskz_1 */

        case E_V4DImode:
          if (pattern419 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8765; /* avx512vl_vpermt2varv4di3_maskz_1 */

        case E_V4DFmode:
          if (pattern1178 (x2, 
E_V4DFmode, 
E_QImode, 
E_V4DImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28146 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8767; /* avx512vl_vpermt2varv4df3_maskz_1 */

        case E_V4SImode:
          if (pattern419 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8769; /* avx512vl_vpermt2varv4si3_maskz_1 */

        case E_V4SFmode:
          if (pattern1178 (x2, 
E_V4SFmode, 
E_QImode, 
E_V4SImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28147 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8771; /* avx512vl_vpermt2varv4sf3_maskz_1 */

        case E_V2DImode:
          if (pattern419 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8773; /* avx512vl_vpermt2varv2di3_maskz_1 */

        case E_V2DFmode:
          if (pattern1178 (x2, 
E_V2DFmode, 
E_QImode, 
E_V2DImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8775; /* avx512vl_vpermt2varv2df3_maskz_1 */

        case E_V32HImode:
          if (pattern419 (x2, 
E_V32HImode, 
E_SImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28149 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8777; /* avx512bw_vpermt2varv32hi3_maskz_1 */

        case E_V16HImode:
          if (pattern419 (x2, 
E_V16HImode, 
E_HImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28150 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 8779; /* avx512vl_vpermt2varv16hi3_maskz_1 */

        case E_V8HImode:
          if (pattern419 (x2, 
E_V8HImode, 
E_QImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_AVX512VL)))
            return -1;
          return 8781; /* avx512vl_vpermt2varv8hi3_maskz_1 */

        case E_V64QImode:
          if (pattern419 (x2, 
E_V64QImode, 
E_DImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28152 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_EVEX512)))
            return -1;
          return 8783; /* avx512bw_vpermt2varv64qi3_maskz_1 */

        case E_V32QImode:
          if (pattern419 (x2, 
E_V32QImode, 
E_SImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28153 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 8785; /* avx512vl_vpermt2varv32qi3_maskz_1 */

        case E_V16QImode:
          if (pattern419 (x2, 
E_V16QImode, 
E_HImode) != 0
              || !(
#line 28236 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 28154 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI && TARGET_AVX512VL)))
            return -1;
          return 8787; /* avx512vl_vpermt2varv16qi3_maskz_1 */

        case E_V32HFmode:
          if (pattern1178 (x2, 
E_V32HFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28251 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8789; /* avx512bw_vpermt2varv32hf3_maskz_1 */

        case E_V16HFmode:
          if (pattern1178 (x2, 
E_V16HFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28251 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8791; /* avx512vl_vpermt2varv16hf3_maskz_1 */

        case E_V8HFmode:
          if (pattern1178 (x2, 
E_V8HFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28251 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 557 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8793; /* avx512fp16_vpermt2varv8hf3_maskz_1 */

        case E_V32BFmode:
          if (pattern1178 (x2, 
E_V32BFmode, 
E_SImode, 
E_V32HImode) != 0
              || !(
#line 28251 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8795; /* avx512bw_vpermt2varv32bf3_maskz_1 */

        case E_V16BFmode:
          if (pattern1178 (x2, 
E_V16BFmode, 
E_HImode, 
E_V16HImode) != 0
              || !(
#line 28251 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8797; /* avx512vl_vpermt2varv16bf3_maskz_1 */

        case E_V8BFmode:
          if (pattern1178 (x2, 
E_V8BFmode, 
E_QImode, 
E_V8HImode) != 0
              || !(
#line 28251 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 558 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8799; /* avx512vl_vpermt2varv8bf3_maskz_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (pattern576 (x2))
    {
    case 0:
      if (pattern1274 (x2, 
E_V32HFmode, 
E_SImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3424; /* fma_fnmadd_v32hf_maskz_1 */

    case 1:
      if (pattern1274 (x2, 
E_V16HFmode, 
E_HImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3428; /* fma_fnmadd_v16hf_maskz_1 */

    case 2:
      if (pattern1274 (x2, 
E_V8HFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5929 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3432; /* fma_fnmadd_v8hf_maskz_1 */

    case 3:
      if (pattern1274 (x2, 
E_V16SFmode, 
E_HImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3436; /* fma_fnmadd_v16sf_maskz_1 */

    case 4:
      if (pattern1274 (x2, 
E_V8SFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3440; /* fma_fnmadd_v8sf_maskz_1 */

    case 5:
      if (pattern1274 (x2, 
E_V4SFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3444; /* fma_fnmadd_v4sf_maskz_1 */

    case 6:
      if (pattern1274 (x2, 
E_V8DFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3447; /* fma_fnmadd_v8df_maskz_1 */

    case 7:
      if (pattern1274 (x2, 
E_V4DFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3451; /* fma_fnmadd_v4df_maskz_1 */

    case 8:
      if (pattern1274 (x2, 
E_V2DFmode, 
E_QImode) != 0
          || !(
#line 6151 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3455; /* fma_fnmadd_v2df_maskz_1 */

    case 9:
      if (pattern1275 (x2, 
E_SImode, 
E_V32BFmode) != 0
          || !(
#line 32211 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10005; /* avx10_2_fnmaddbf16_v32bf_maskz_1 */

    case 10:
      if (pattern1275 (x2, 
E_HImode, 
E_V16BFmode) != 0
          || !
#line 32211 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10007; /* avx10_2_fnmaddbf16_v16bf_maskz_1 */

    case 11:
      if (pattern1275 (x2, 
E_QImode, 
E_V8BFmode) != 0
          || !
#line 32211 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10009; /* avx10_2_fnmaddbf16_v8bf_maskz_1 */

    case 12:
      if (pattern1276 (x2, 
E_V4SFmode) != 0
          || !
#line 6987 "../../../gcc/config/i386/sse.md"
(TARGET_FMA4))
        return -1;
      return 3803; /* *fma4i_vmfnmadd_v4sf */

    case 13:
      if (pattern1276 (x2, 
E_V2DFmode) != 0
          || !(
#line 6987 "../../../gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3804; /* *fma4i_vmfnmadd_v2df */

    case 14:
      if (pattern1196 (x2, 
E_V32HFmode, 
E_SImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V32HFmode)
          && vector_operand (operands[3], E_V32HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return 3456; /* avx512bw_fnmadd_v32hf_mask */
        }
      if (!vector_operand (operands[1], E_V32HFmode)
          || !nonimmediate_operand (operands[3], E_V32HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 3471; /* avx512bw_fnmadd_v32hf_mask3 */

    case 15:
      if (pattern1196 (x2, 
E_V16HFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16HFmode)
          && vector_operand (operands[3], E_V16HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3458; /* avx512vl_fnmadd_v16hf_mask */
        }
      if (!vector_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[3], E_V16HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3473; /* avx512vl_fnmadd_v16hf_mask3 */

    case 16:
      if (pattern1196 (x2, 
E_V8HFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8HFmode)
          && vector_operand (operands[3], E_V8HFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return 3460; /* avx512fp16_fnmadd_v8hf_mask */
        }
      if (!vector_operand (operands[1], E_V8HFmode)
          || !nonimmediate_operand (operands[3], E_V8HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 3475; /* avx512fp16_fnmadd_v8hf_mask3 */

    case 17:
      if (pattern1196 (x2, 
E_V16SFmode, 
E_HImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V16SFmode)
          && vector_operand (operands[3], E_V16SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3461; /* avx512f_fnmadd_v16sf_mask */
        }
      if (!vector_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[3], E_V16SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3476; /* avx512f_fnmadd_v16sf_mask3 */

    case 18:
      if (pattern1196 (x2, 
E_V8SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SFmode)
          && vector_operand (operands[3], E_V8SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3463; /* avx512vl_fnmadd_v8sf_mask */
        }
      if (!vector_operand (operands[1], E_V8SFmode)
          || !nonimmediate_operand (operands[3], E_V8SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3478; /* avx512vl_fnmadd_v8sf_mask3 */

    case 19:
      if (pattern1196 (x2, 
E_V4SFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4SFmode)
          && vector_operand (operands[3], E_V4SFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3465; /* avx512vl_fnmadd_v4sf_mask */
        }
      if (!vector_operand (operands[1], E_V4SFmode)
          || !nonimmediate_operand (operands[3], E_V4SFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3480; /* avx512vl_fnmadd_v4sf_mask3 */

    case 20:
      if (pattern1196 (x2, 
E_V8DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8DFmode)
          && vector_operand (operands[3], E_V8DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return 3466; /* avx512f_fnmadd_v8df_mask */
        }
      if (!vector_operand (operands[1], E_V8DFmode)
          || !nonimmediate_operand (operands[3], E_V8DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 3481; /* avx512f_fnmadd_v8df_mask3 */

    case 21:
      if (pattern1196 (x2, 
E_V4DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V4DFmode)
          && vector_operand (operands[3], E_V4DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3468; /* avx512vl_fnmadd_v4df_mask */
        }
      if (!vector_operand (operands[1], E_V4DFmode)
          || !nonimmediate_operand (operands[3], E_V4DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3483; /* avx512vl_fnmadd_v4df_mask3 */

    case 22:
      if (pattern1196 (x2, 
E_V2DFmode, 
E_QImode) != 0)
        return -1;
      if (nonimmediate_operand (operands[1], E_V2DFmode)
          && vector_operand (operands[3], E_V2DFmode))
        {
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 6194 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return 3470; /* avx512vl_fnmadd_v2df_mask */
        }
      if (!vector_operand (operands[1], E_V2DFmode)
          || !nonimmediate_operand (operands[3], E_V2DFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 6212 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 3485; /* avx512vl_fnmadd_v2df_mask3 */

    case 23:
      if (pattern1197 (x2, 
E_SImode, 
E_V32BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && (
#line 32230 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return 10010; /* avx10_2_fnmaddbf16_v32bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !(
#line 32248 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10013; /* avx10_2_fnmaddbf16_v32bf_mask3 */

    case 24:
      if (pattern1197 (x2, 
E_HImode, 
E_V16BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32230 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return 10011; /* avx10_2_fnmaddbf16_v16bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32248 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10014; /* avx10_2_fnmaddbf16_v16bf_mask3 */

    case 25:
      if (pattern1197 (x2, 
E_QImode, 
E_V8BFmode) != 0)
        return -1;
      x6 = XEXP (x2, 1);
      if (rtx_equal_p (x6, operands[1])
          && 
#line 32230 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return 10012; /* avx10_2_fnmaddbf16_v8bf_mask */
      if (!rtx_equal_p (x6, operands[3])
          || !
#line 32248 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10015; /* avx10_2_fnmaddbf16_v8bf_mask3 */

    case 26:
      if (pattern1277 (x2, 
E_V8HFmode) != 0
          || !(
#line 6632 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 3715; /* *fmai_fnmadd_v8hf */

    case 27:
      if (pattern1277 (x2, 
E_V4SFmode) != 0
          || !
#line 6632 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
        return -1;
      return 3717; /* *fmai_fnmadd_v4sf */

    case 28:
      if (pattern1277 (x2, 
E_V2DFmode) != 0
          || !(
#line 6632 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 3719; /* *fmai_fnmadd_v2df */

    case 29:
      return recog_144 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x4, 0, 3);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XEXP (x2, 2);
  if (!register_operand (x7, E_QImode))
    return -1;
  x8 = XVECEXP (x4, 0, 0);
  switch (XWINT (x8, 0))
    {
    case 2LL:
      x9 = XVECEXP (x4, 0, 1);
      if (XWINT (x9, 0) != 6LL
          || XWINT (x5, 0) != 3LL
          || XWINT (x6, 0) != 7LL)
        return -1;
      x10 = XEXP (x3, 0);
      x11 = XEXP (x10, 1);
      operands[2] = x11;
      x12 = XEXP (x2, 1);
      operands[3] = x12;
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1452 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11230 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL)))
            return -1;
          return 4677; /* vec_interleave_highv4sf_mask */

        case E_V4SImode:
          if (pattern1452 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19772 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 7792; /* vec_interleave_highv4si_mask */

        default:
          return -1;
        }

    case 0LL:
      x9 = XVECEXP (x4, 0, 1);
      switch (XWINT (x9, 0))
        {
        case 4LL:
          switch (XWINT (x5, 0))
            {
            case 1LL:
              if (XWINT (x6, 0) != 5LL)
                return -1;
              x10 = XEXP (x3, 0);
              x11 = XEXP (x10, 1);
              operands[2] = x11;
              x12 = XEXP (x2, 1);
              operands[3] = x12;
              operands[4] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern1451 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 11287 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
                    return -1;
                  return 4682; /* unpcklps128_mask */

                case E_V4SImode:
                  if (pattern1452 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 19826 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
                    return -1;
                  return 7798; /* vec_interleave_lowv4si_mask */

                default:
                  return -1;
                }

            case 2LL:
              if (XWINT (x6, 0) != 6LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4DFmode:
                  if (pattern1502 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0)
                    return -1;
                  x12 = XEXP (x2, 1);
                  operands[2] = x12;
                  if (nonimmediate_operand (operands[1], E_V4DFmode))
                    {
                      operands[3] = x7;
                      x10 = XEXP (x3, 0);
                      x11 = XEXP (x10, 1);
                      if (rtx_equal_p (x11, operands[1])
                          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13482 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
                        return 4837; /* avx_movddup256_mask */
                    }
                  operands[3] = x12;
                  if (!register_operand (operands[1], E_V4DFmode))
                    return -1;
                  x10 = XEXP (x3, 0);
                  x11 = XEXP (x10, 1);
                  operands[2] = x11;
                  if (!nonimmediate_operand (operands[2], E_V4DFmode))
                    return -1;
                  operands[4] = x7;
                  if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13496 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
                    return -1;
                  return 4839; /* avx_unpcklpd256_mask */

                case E_V4DImode:
                  if (pattern1503 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
                    return -1;
                  return 6628; /* avx2_interleave_lowv4di_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0LL:
          if (XWINT (x5, 0) != 6LL
              || XWINT (x6, 0) != 6LL
              || pattern1450 (x2) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11425 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_AVX512VL)))
            return -1;
          return 4693; /* sse3_movsldup_mask */

        default:
          return -1;
        }

    case 1LL:
      if (XWINT (x6, 0) != 7LL)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      switch (XWINT (x9, 0))
        {
        case 1LL:
          if (XWINT (x5, 0) != 7LL
              || pattern1450 (x2) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 11372 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_AVX512VL)))
            return -1;
          return 4687; /* sse3_movshdup_mask */

        case 5LL:
          if (XWINT (x5, 0) != 3LL)
            return -1;
          x10 = XEXP (x3, 0);
          x11 = XEXP (x10, 1);
          operands[2] = x11;
          x12 = XEXP (x2, 1);
          operands[3] = x12;
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DFmode:
              if (pattern1451 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 13352 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
                return -1;
              return 4829; /* avx_unpckhpd256_mask */

            case E_V4DImode:
              if (pattern1451 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 14478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && TARGET_AVX512VL)))
                return -1;
              return 6622; /* avx2_interleave_highv4di_mask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 4);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[6] = x5;
  res = recog_156 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 4LL)
    return -1;
  x6 = XVECEXP (x4, 0, 5);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x7 = XVECEXP (x4, 0, 6);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x8 = XVECEXP (x4, 0, 7);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern1201 (x2, 
E_V8HImode) != 0
      || pattern821 (x4) != 0)
    return -1;
  x9 = XEXP (x2, 1);
  operands[6] = x9;
  if (!nonimm_or_0_operand (operands[6], E_V8HImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[7] = x10;
  if (!register_operand (operands[7], E_QImode)
      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20859 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512BW && TARGET_AVX512VL)))
    return -1;
  return 7868; /* sse2_pshuflw_1_mask */
}

 int
recog_162 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_VECTOR
      || XVECLEN (x6, 0) != 32
      || GET_MODE (x6) != E_V32HImode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x11 = XVECEXP (x6, 0, 4);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x6, 0, 5);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x6, 0, 6);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XVECEXP (x6, 0, 7);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x6, 0, 8);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XVECEXP (x6, 0, 9);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XVECEXP (x6, 0, 10);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x18 = XVECEXP (x6, 0, 11);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x19 = XVECEXP (x6, 0, 12);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x20 = XVECEXP (x6, 0, 13);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x21 = XVECEXP (x6, 0, 14);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x22 = XVECEXP (x6, 0, 15);
  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x23 = XVECEXP (x6, 0, 16);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x24 = XVECEXP (x6, 0, 17);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x25 = XVECEXP (x6, 0, 18);
  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x26 = XVECEXP (x6, 0, 19);
  if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x27 = XVECEXP (x6, 0, 20);
  if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x28 = XVECEXP (x6, 0, 21);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x29 = XVECEXP (x6, 0, 22);
  if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x30 = XVECEXP (x6, 0, 23);
  if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x31 = XVECEXP (x6, 0, 24);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x32 = XVECEXP (x6, 0, 25);
  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x33 = XVECEXP (x6, 0, 26);
  if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x34 = XVECEXP (x6, 0, 27);
  if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x35 = XVECEXP (x6, 0, 28);
  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x36 = XVECEXP (x6, 0, 29);
  if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x37 = XVECEXP (x6, 0, 30);
  if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x38 = XVECEXP (x6, 0, 31);
  if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_V32HImode)
      || GET_MODE (x2) != E_V32HImode
      || GET_MODE (x3) != E_V32HImode
      || GET_MODE (x4) != E_V32SImode
      || GET_MODE (x5) != E_V32SImode)
    return -1;
  x39 = XEXP (x5, 0);
  if (GET_MODE (x39) != E_V32SImode)
    return -1;
  x40 = XEXP (x39, 0);
  if (GET_MODE (x40) != E_V32SImode)
    return -1;
  x41 = XEXP (x40, 0);
  if (GET_MODE (x41) != E_V32SImode)
    return -1;
  x42 = XEXP (x40, 1);
  if (GET_MODE (x42) != E_V32SImode)
    return -1;
  x43 = XEXP (x42, 0);
  operands[2] = x43;
  if (!nonimmediate_operand (operands[2], E_V32HImode))
    return -1;
  x44 = XEXP (x2, 1);
  operands[3] = x44;
  if (!nonimm_or_0_operand (operands[3], E_V32HImode))
    return -1;
  x45 = XEXP (x2, 2);
  operands[4] = x45;
  if (!register_operand (operands[4], E_SImode)
      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 22840 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
    return -1;
  return 7984; /* avx512bw_umulhrswv32hi3_mask */
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      return recog_130 (x1, insn, pnum_clobbers);

    case 2:
      return recog_129 (x1, insn, pnum_clobbers);

    case 3:
      return recog_128 (x1, insn, pnum_clobbers);

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 3);
      operands[4] = x7;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 164:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1332 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 13664 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 4885; /* avx512f_vternlogv16si_maskz_1 */

                case E_V8SImode:
                  if (pattern1332 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4887; /* avx512vl_vternlogv8si_maskz_1 */

                case E_V4SImode:
                  if (pattern1332 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4889; /* avx512vl_vternlogv4si_maskz_1 */

                case E_V8DImode:
                  if (pattern1332 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 4891; /* avx512f_vternlogv8di_maskz_1 */

                case E_V4DImode:
                  if (pattern1332 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4893; /* avx512vl_vternlogv4di_maskz_1 */

                case E_V2DImode:
                  if (pattern1332 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 13664 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 4895; /* avx512vl_vternlogv2di_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x2, 2);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SImode:
                  if (pattern1333 (x2, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14034 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6456; /* *avx512f_vternlogv16si_mask */

                case E_V8SImode:
                  if (pattern1333 (x2, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6457; /* *avx512vl_vternlogv8si_mask */

                case E_V4SImode:
                  if (pattern1333 (x2, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6458; /* *avx512vl_vternlogv4si_mask */

                case E_V8DImode:
                  if (pattern1333 (x2, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6459; /* *avx512f_vternlogv8di_mask */

                case E_V4DImode:
                  if (pattern1333 (x2, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6460; /* *avx512vl_vternlogv4di_mask */

                case E_V2DImode:
                  if (pattern1333 (x2, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14034 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6461; /* *avx512vl_vternlogv2di_mask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 163:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              operands[5] = x8;
              x9 = XEXP (x2, 2);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16SFmode:
                  if (pattern1334 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
                      || !(
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6526; /* avx512f_fixupimmv16sf_maskz_1 */

                case E_V8SFmode:
                  if (pattern1334 (x2, 
E_V8SFmode, 
E_V8SImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6530; /* avx512vl_fixupimmv8sf_maskz_1 */

                case E_V4SFmode:
                  if (pattern1334 (x2, 
E_V4SFmode, 
E_V4SImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6533; /* avx512vl_fixupimmv4sf_maskz_1 */

                case E_V8DFmode:
                  if (pattern1334 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 6536; /* avx512f_fixupimmv8df_maskz_1 */

                case E_V4DFmode:
                  if (pattern1334 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6540; /* avx512vl_fixupimmv4df_maskz_1 */

                case E_V2DFmode:
                  if (pattern1334 (x2, 
E_V2DFmode, 
E_V2DImode, 
E_QImode) != 0
                      || !(
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 6543; /* avx512vl_fixupimmv2df_maskz_1 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              x9 = XEXP (x2, 2);
              switch (GET_CODE (x9))
                {
                case REG:
                case SUBREG:
                  operands[5] = x9;
                  if (!rtx_equal_p (x8, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16SFmode:
                      if (pattern1386 (x2, 
E_V16SImode, 
E_V16SFmode, 
E_HImode) != 0
                          || !(
#line 14175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 6544; /* avx512f_fixupimmv16sf_mask */

                    case E_V8SFmode:
                      if (pattern1386 (x2, 
E_V8SImode, 
E_V8SFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6546; /* avx512vl_fixupimmv8sf_mask */

                    case E_V4SFmode:
                      if (pattern1386 (x2, 
E_V4SImode, 
E_V4SFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6548; /* avx512vl_fixupimmv4sf_mask */

                    case E_V8DFmode:
                      if (pattern1386 (x2, 
E_V8DImode, 
E_V8DFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                        return -1;
                      return 6549; /* avx512f_fixupimmv8df_mask */

                    case E_V4DFmode:
                      if (pattern1386 (x2, 
E_V4DImode, 
E_V4DFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6551; /* avx512vl_fixupimmv4df_mask */

                    case E_V2DFmode:
                      if (pattern1386 (x2, 
E_V2DImode, 
E_V2DFmode, 
E_QImode) != 0
                          || !(
#line 14175 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                        return -1;
                      return 6553; /* avx512vl_fixupimmv2df_mask */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (XWINT (x9, 0) != 1LL
                      || !rtx_equal_p (x8, operands[2]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern1387 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                          || !
#line 14207 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                        return -1;
                      return 6554; /* avx512f_sfixupimmv4sf */

                    case E_V2DFmode:
                      if (pattern1387 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                          || !(
#line 14207 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                        return -1;
                      return 6558; /* avx512f_sfixupimmv2df */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern132 (x2))
    {
    case 0:
      if (nonimmediate_operand (operands[1], E_V16HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17303 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7069; /* ashlv16hi3_mask */
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28947 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8970; /* avx512vl_ashlvv16hi_mask */

    case 1:
      if (nonimmediate_operand (operands[1], E_V8HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17303 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 798 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))))
        return 7073; /* ashlv8hi3_mask */
      if (!register_operand (operands[1], E_V8HImode)
          || !nonimmediate_operand (operands[2], E_V8HImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28947 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 8966; /* avx512vl_ashlvv8hi_mask */

    case 2:
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7077; /* ashlv8si3_mask */
      if (!register_operand (operands[1], E_V8SImode)
          || !nonimmediate_operand (operands[2], E_V8SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8946; /* avx2_ashlvv8si_mask */

    case 3:
      if (nonimmediate_operand (operands[1], E_V4SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7081; /* ashlv4si3_mask */
      if (!register_operand (operands[1], E_V4SImode)
          || !nonimmediate_operand (operands[2], E_V4SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8950; /* avx2_ashlvv4si_mask */

    case 4:
      if (nonimmediate_operand (operands[1], E_V4DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7085; /* ashlv4di3_mask */
      if (!register_operand (operands[1], E_V4DImode)
          || !nonimmediate_operand (operands[2], E_V4DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8958; /* avx2_ashlvv4di_mask */

    case 5:
      if (nonimmediate_operand (operands[1], E_V2DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17303 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return 7089; /* ashlv2di3_mask */
      if (!register_operand (operands[1], E_V2DImode)
          || !nonimmediate_operand (operands[2], E_V2DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 28936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (16 == 64 || TARGET_AVX512VL))))
        return -1;
      return 8962; /* avx2_ashlvv2di_mask */

    case 6:
      if (nonimmediate_operand (operands[1], E_V32HImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
        return 7109; /* ashlv32hi3_mask */
      if (!register_operand (operands[1], E_V32HImode)
          || !nonimmediate_operand (operands[2], E_V32HImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28947 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 8974; /* avx512bw_ashlvv32hi_mask */

    case 7:
      if (nonimmediate_operand (operands[1], E_V16SImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 784 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7113; /* ashlv16si3_mask */
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 803 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8942; /* avx512f_ashlvv16si_mask */

    case 8:
      if (nonimmediate_operand (operands[1], E_V8DImode)
          && nonmemory_operand (operands[2], E_DImode)
          && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 785 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return 7117; /* ashlv8di3_mask */
      if (!register_operand (operands[1], E_V8DImode)
          || !nonimmediate_operand (operands[2], E_V8DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 28936 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (64 == 64 || TARGET_AVX512VL)) && 
#line 804 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 8954; /* avx512f_ashlvv8di_mask */

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern128 (x2))
    {
    case 0:
      if (pattern713 (x2, 
E_V8HImode, 
E_QImode, 
E_V8HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4080; /* avx512fp16_fix_truncv8hi2_mask */

    case 1:
      if (pattern713 (x2, 
E_V16HImode, 
E_HImode, 
E_V16HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
        return -1;
      return 4085; /* avx512fp16_fix_truncv16hi2_mask */

    case 2:
      if (pattern713 (x2, 
E_V32HImode, 
E_SImode, 
E_V32HFmode) != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
        return -1;
      return 4093; /* avx512fp16_fix_truncv32hi2_mask */

    case 3:
      if (pattern712 (x2, 
E_V8SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4101; /* avx512fp16_fix_truncv8si2_mask */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8806 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL)))
            return -1;
          return 4342; /* fix_truncv8sfv8si2_mask */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4460; /* fix_truncv8dfv8si2_mask */

        default:
          return -1;
        }

    case 4:
      switch (pattern816 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4109; /* avx512fp16_fix_truncv16si2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4331; /* fix_truncv16sfv16si2_mask */

        default:
          return -1;
        }

    case 5:
      switch (pattern817 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4117; /* avx512fp16_fix_truncv8di2_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4505; /* fix_truncv8dfv8di2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4560; /* fix_truncv8sfv8di2_mask */

        default:
          return -1;
        }

    case 6:
      if (pattern712 (x2, 
E_V4SImode, 
E_QImode) != 0)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4144; /* *avx512fp16_fix_truncv4si2_load_mask */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8836 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
            return -1;
          return 4346; /* fix_truncv4sfv4si2_mask */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F))))
            return -1;
          return 4476; /* fix_truncv4dfv4si2_mask */

        default:
          return -1;
        }

    case 7:
      switch (pattern818 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4148; /* *avx512fp16_fix_truncv4di2_load_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4513; /* fix_truncv4dfv4di2_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4564; /* fix_truncv4sfv4di2_mask */

        default:
          return -1;
        }

    case 8:
      switch (pattern819 (x2))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7978 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 4160; /* *avx512fp16_fix_truncv2di2_load_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 4520; /* fix_truncv2dfv2di2_mask */

        default:
          return -1;
        }

    case 9:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4136; /* avx512fp16_fix_truncv4si2_mask */

    case 10:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4140; /* avx512fp16_fix_truncv4di2_mask */

    case 11:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 7968 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 4156; /* avx512fp16_fix_truncv2di2_mask */

    case 12:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9778 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL)))
        return -1;
      return 4572; /* avx512dq_fix_truncv2sfv2di2_mask */

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (pattern425 (x2))
    {
    case 0:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
        return -1;
      return 2164; /* *addv32hf3_mask */

    case 1:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2172; /* *addv16hf3_mask */

    case 2:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
        return -1;
      return 2180; /* *addv8hf3_mask */

    case 3:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 2188; /* *addv16sf3_mask */

    case 4:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 2196; /* *addv8sf3_mask */

    case 5:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1)))
        return -1;
      return 2204; /* *addv4sf3_mask */

    case 6:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
        return -1;
      return 2212; /* *addv8df3_mask */

    case 7:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
        return -1;
      return 2220; /* *addv4df3_mask */

    case 8:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
        return -1;
      return 2228; /* *addv2df3_mask */

    case 9:
      if (!(
#line 16298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_binary_operator_ok (PLUS, V16SImode, operands)) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6911; /* *addv16si3_mask */

    case 10:
      if (!(
#line 16298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_binary_operator_ok (PLUS, V8SImode, operands)) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6913; /* *addv8si3_mask */

    case 11:
      if (!(
#line 16298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_binary_operator_ok (PLUS, V4SImode, operands)) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6915; /* *addv4si3_mask */

    case 12:
      if (!(
#line 16298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_binary_operator_ok (PLUS, V8DImode, operands)) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6917; /* *addv8di3_mask */

    case 13:
      if (!(
#line 16298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_binary_operator_ok (PLUS, V4DImode, operands)) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6919; /* *addv4di3_mask */

    case 14:
      if (!(
#line 16298 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_binary_operator_ok (PLUS, V2DImode, operands)) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6921; /* *addv2di3_mask */

    case 15:
      if (!(
#line 16312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_binary_operator_ok (PLUS, V64QImode, operands)) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6923; /* *addv64qi3_mask */

    case 16:
      if (!(
#line 16312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_binary_operator_ok (PLUS, V16QImode, operands)) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6925; /* *addv16qi3_mask */

    case 17:
      if (!(
#line 16312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_binary_operator_ok (PLUS, V32QImode, operands)) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6927; /* *addv32qi3_mask */

    case 18:
      if (!(
#line 16312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_binary_operator_ok (PLUS, V32HImode, operands)) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 6929; /* *addv32hi3_mask */

    case 19:
      if (!(
#line 16312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_binary_operator_ok (PLUS, V16HImode, operands)) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6931; /* *addv16hi3_mask */

    case 20:
      if (!(
#line 16312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_binary_operator_ok (PLUS, V8HImode, operands)) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 6933; /* *addv8hi3_mask */

    case 21:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
        return -1;
      return 9969; /* avx10_2_addbf16_v32bf_mask */

    case 22:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 9977; /* avx10_2_addbf16_v16bf_mask */

    case 23:
      if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
        return -1;
      return 9985; /* avx10_2_addbf16_v8bf_mask */

    case 24:
      if (!(
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
        return -1;
      return 2240; /* avx512fp16_vmaddv8hf3 */

    case 25:
      if (!
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return -1;
      return 2248; /* sse_vmaddv4sf3 */

    case 26:
      if (!(
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2256; /* sse2_vmaddv2df3 */

    default:
      return -1;
    }
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 2);
  if (!register_operand (x6, E_QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  if (!const_4_or_8_to_11_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x11;
          switch (pattern1389 (x2))
            {
            case 0:
              if (pattern1537 (x2, 
E_V8HFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                        return 3728; /* avx512f_vmfmadd_v8hf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3734; /* avx512f_vmfmadd_v8hf_mask3_round */

            case 1:
              if (pattern1537 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && 
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return 3730; /* avx512f_vmfmadd_v4sf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3736; /* avx512f_vmfmadd_v4sf_mask3_round */

            case 2:
              if (pattern1537 (x2, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && register_operand (operands[3], E_V2DFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                        return 3732; /* avx512f_vmfmadd_v2df_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6691 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3738; /* avx512f_vmfmadd_v2df_mask3_round */

            case 3:
              if (pattern1596 (x2, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3740; /* avx512f_vmfmadd_v8hf_maskz_1_round */

            case 4:
              if (pattern1596 (x2, 
E_V4SFmode) != 0
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3742; /* avx512f_vmfmadd_v4sf_maskz_1_round */

            case 5:
              if (pattern1596 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6723 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3744; /* avx512f_vmfmadd_v2df_maskz_1_round */

            default:
              return -1;
            }

        case NEG:
          x14 = XEXP (x11, 0);
          operands[3] = x14;
          switch (pattern1389 (x2))
            {
            case 0:
              if (pattern1538 (x2, 
E_V8HFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                        return 3746; /* *avx512f_vmfmsub_v8hf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3752; /* avx512f_vmfmsub_v8hf_mask3_round */

            case 1:
              if (pattern1538 (x2, 
E_V4SFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && 
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                        return 3748; /* *avx512f_vmfmsub_v4sf_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3754; /* avx512f_vmfmsub_v4sf_mask3_round */

            case 2:
              if (pattern1538 (x2, 
E_V2DFmode) != 0)
                return -1;
              if (nonimmediate_operand (operands[1], E_V2DFmode)
                  && register_operand (operands[3], E_V2DFmode))
                {
                  x12 = XEXP (x5, 1);
                  if (rtx_equal_p (x12, operands[1]))
                    {
                      x13 = XEXP (x3, 1);
                      if (rtx_equal_p (x13, operands[1])
                          && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6744 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                        return 3750; /* *avx512f_vmfmsub_v2df_mask_round */
                    }
                }
              if (!register_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode))
                return -1;
              x12 = XEXP (x5, 1);
              if (!rtx_equal_p (x12, operands[3]))
                return -1;
              x13 = XEXP (x3, 1);
              if (!rtx_equal_p (x13, operands[3])
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6765 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3756; /* avx512f_vmfmsub_v2df_mask3_round */

            case 3:
              if (pattern1597 (x2, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3758; /* *avx512f_vmfmsub_v8hf_maskz_1_round */

            case 4:
              if (pattern1597 (x2, 
E_V4SFmode) != 0
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3760; /* *avx512f_vmfmsub_v4sf_maskz_1_round */

            case 5:
              if (pattern1597 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6784 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3762; /* *avx512f_vmfmsub_v2df_maskz_1_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x11 = XEXP (x8, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x11;
          switch (pattern1289 (x2))
            {
            case 0:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1668 (x3, 
E_V8HFmode) == 0
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return 3764; /* avx512f_vmfnmadd_v8hf_mask_round */
              operands[1] = x10;
              if (pattern1669 (x3, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6826 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3770; /* avx512f_vmfnmadd_v8hf_mask3_round */

            case 1:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1668 (x3, 
E_V4SFmode) == 0
                  && 
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return 3766; /* avx512f_vmfnmadd_v4sf_mask_round */
              operands[1] = x10;
              if (pattern1669 (x3, 
E_V4SFmode) != 0
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3772; /* avx512f_vmfnmadd_v4sf_mask3_round */

            case 2:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1668 (x3, 
E_V2DFmode) == 0
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return 3768; /* avx512f_vmfnmadd_v2df_mask_round */
              operands[1] = x10;
              if (pattern1669 (x3, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6826 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3774; /* avx512f_vmfnmadd_v2df_mask3_round */

            case 3:
              if (pattern1598 (x2, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3776; /* avx512f_vmfnmadd_v8hf_maskz_1_round */

            case 4:
              if (pattern1598 (x2, 
E_V4SFmode) != 0
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3778; /* avx512f_vmfnmadd_v4sf_maskz_1_round */

            case 5:
              if (pattern1598 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6859 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3780; /* avx512f_vmfnmadd_v2df_maskz_1_round */

            default:
              return -1;
            }

        case NEG:
          x14 = XEXP (x11, 0);
          operands[3] = x14;
          switch (pattern1289 (x2))
            {
            case 0:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1670 (x3, 
E_V8HFmode) == 0
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6881 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return 3782; /* *avx512f_vmfnmsub_v8hf_mask_round */
              operands[1] = x10;
              if (pattern1671 (x3, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3788; /* *avx512f_vmfnmsub_v8hf_mask3_round */

            case 1:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1670 (x3, 
E_V4SFmode) == 0
                  && 
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return 3784; /* *avx512f_vmfnmsub_v4sf_mask_round */
              operands[1] = x10;
              if (pattern1671 (x3, 
E_V4SFmode) != 0
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3790; /* *avx512f_vmfnmsub_v4sf_mask3_round */

            case 2:
              x10 = XEXP (x8, 1);
              operands[2] = x10;
              if (pattern1670 (x3, 
E_V2DFmode) == 0
                  && (
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6881 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return 3786; /* *avx512f_vmfnmsub_v2df_mask_round */
              operands[1] = x10;
              if (pattern1671 (x3, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6903 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3792; /* *avx512f_vmfnmsub_v2df_mask3_round */

            case 3:
              if (pattern1599 (x2, 
E_V8HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6923 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 3794; /* *avx512f_vmfnmsub_v8hf_maskz_1_round */

            case 4:
              if (pattern1599 (x2, 
E_V4SFmode) != 0
                  || !
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F))
                return -1;
              return 3796; /* *avx512f_vmfnmsub_v4sf_maskz_1_round */

            case 5:
              if (pattern1599 (x2, 
E_V2DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6923 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 3798; /* *avx512f_vmfnmsub_v2df_maskz_1_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[3] = x6;
      switch (XINT (x3, 1))
        {
        case 63:
          switch (pattern1033 (x2))
            {
            case 0:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2547; /* ieee_maxv32hf3_round */

            case 1:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2555; /* ieee_maxv16hf3_round */

            case 2:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2567; /* ieee_maxv16sf3_round */

            case 3:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2575; /* ieee_maxv8sf3_round */

            case 4:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2587; /* ieee_maxv8df3_round */

            case 5:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2595; /* ieee_maxv4df3_round */

            default:
              return -1;
            }

        case 62:
          switch (pattern1033 (x2))
            {
            case 0:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2551; /* ieee_minv32hf3_round */

            case 1:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2559; /* ieee_minv16hf3_round */

            case 2:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2571; /* ieee_minv16sf3_round */

            case 3:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2579; /* ieee_minv8sf3_round */

            case 4:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
                return -1;
              return 2591; /* ieee_minv8df3_round */

            case 5:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
                return -1;
              return 2599; /* ieee_minv4df3_round */

            default:
              return -1;
            }

        case 192:
          if (!const_0_to_255_operand (operands[2], E_SImode)
              || !const48_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1122 (x2, 
E_V32HFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V32HFmode))) && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 2675; /* *reducepv32hf_round */

            case E_V16HFmode:
              if (pattern1122 (x2, 
E_V16HFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16HFmode))) && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 2679; /* *reducepv16hf_round */

            case E_V16SFmode:
              if (pattern1122 (x2, 
E_V16SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V16SFmode))) && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2685; /* *reducepv16sf_round */

            case E_V8SFmode:
              if (pattern1122 (x2, 
E_V8SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8SFmode))) && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2689; /* *reducepv8sf_round */

            case E_V8DFmode:
              if (pattern1122 (x2, 
E_V8DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V8DFmode))) && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 2695; /* *reducepv8df_round */

            case E_V4DFmode:
              if (pattern1122 (x2, 
E_V4DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 4024 "../../../gcc/config/i386/sse.md"
((TARGET_AVX512DQ || (VALID_AVX512FP16_REG_MODE (V4DFmode))) && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 2699; /* *reducepv4df_round */

            default:
              return -1;
            }

        case 221:
          switch (pattern1034 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3863; /* avx512bw_fmulc_v32hf_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3871; /* avx512vl_fmulc_v16hf_round */

            default:
              return -1;
            }

        case 222:
          switch (pattern1034 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3867; /* avx512bw_fcmulc_v32hf_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3875; /* avx512vl_fcmulc_v16hf_round */

            default:
              return -1;
            }

        case 58:
          if (!const_4_or_8_to_11_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1210 (x2, 
E_V32HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 4855; /* avx512bw_scalefv32hf_round */

            case E_V16HFmode:
              if (pattern1210 (x2, 
E_V16HFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 4859; /* avx512vl_scalefv16hf_round */

            case E_V16SFmode:
              if (pattern1210 (x2, 
E_V16SFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4865; /* avx512f_scalefv16sf_round */

            case E_V8SFmode:
              if (pattern1210 (x2, 
E_V8SFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4869; /* avx512vl_scalefv8sf_round */

            case E_V8DFmode:
              if (pattern1210 (x2, 
E_V8DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4875; /* avx512f_scalefv8df_round */

            case E_V4DFmode:
              if (pattern1210 (x2, 
E_V4DFmode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 13636 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4879; /* avx512vl_scalefv4df_round */

            default:
              return -1;
            }

        case 94:
          if (!const_0_to_255_operand (operands[2], E_SImode))
            return -1;
          switch (pattern1115 (x2))
            {
            case 0:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 6567; /* avx512bw_rndscalev32hf_round */

            case 1:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 6571; /* avx512vl_rndscalev16hf_round */

            case 2:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 6577; /* avx512f_rndscalev16sf_round */

            case 3:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6581; /* avx512vl_rndscalev8sf_round */

            case 4:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 6587; /* avx512f_rndscalev8df_round */

            case 5:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 6591; /* avx512vl_rndscalev4df_round */

            default:
              return -1;
            }

        case 150:
          if (GET_MODE (x3) != E_V16HImode
              || !register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || !register_operand (operands[1], E_V16SFmode)
              || !const_0_to_255_operand (operands[2], E_SImode)
              || !const48_operand (operands[3], E_SImode)
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 29231 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9037; /* *avx512f_vcvtps2ph512_round */

        case 166:
          if (!const_0_to_15_operand (operands[2], E_SImode))
            return -1;
          switch (pattern1115 (x2))
            {
            case 0:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                return -1;
              return 9383; /* avx512bw_getmantv32hf_round */

            case 1:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                return -1;
              return 9387; /* avx512vl_getmantv16hf_round */

            case 2:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9393; /* avx512f_getmantv16sf_round */

            case 3:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9397; /* avx512vl_getmantv8sf_round */

            case 4:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9403; /* avx512f_getmantv8df_round */

            case 5:
              if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29895 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9407; /* avx512vl_getmantv4df_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[4] = x6;
      switch (XINT (x3, 1))
        {
        case 133:
          if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[3] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1035 (x2, 
E_V32HFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3575; /* *fma_fmaddsub_v32hf_round */

                case E_V16HFmode:
                  if (pattern1035 (x2, 
E_V16HFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                    return -1;
                  return 3579; /* *fma_fmaddsub_v16hf_round */

                case E_V16SFmode:
                  if (pattern1035 (x2, 
E_V16SFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3585; /* *fma_fmaddsub_v16sf_round */

                case E_V8SFmode:
                  if (pattern1035 (x2, 
E_V8SFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3589; /* *fma_fmaddsub_v8sf_round */

                case E_V8DFmode:
                  if (pattern1035 (x2, 
E_V8DFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3595; /* *fma_fmaddsub_v8df_round */

                case E_V4DFmode:
                  if (pattern1035 (x2, 
E_V4DFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3599; /* *fma_fmaddsub_v4df_round */

                default:
                  return -1;
                }

            case NEG:
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V32HFmode:
                  if (pattern1359 (x2, 
E_V32HFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
                    return -1;
                  return 3639; /* *fma_fmsubadd_v32hf_round */

                case E_V16HFmode:
                  if (pattern1359 (x2, 
E_V16HFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
                    return -1;
                  return 3643; /* *fma_fmsubadd_v16hf_round */

                case E_V16SFmode:
                  if (pattern1359 (x2, 
E_V16SFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3649; /* *fma_fmsubadd_v16sf_round */

                case E_V8SFmode:
                  if (pattern1359 (x2, 
E_V8SFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3653; /* *fma_fmsubadd_v8sf_round */

                case E_V8DFmode:
                  if (pattern1359 (x2, 
E_V8DFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                    return -1;
                  return 3659; /* *fma_fmsubadd_v8df_round */

                case E_V4DFmode:
                  if (pattern1359 (x2, 
E_V4DFmode) != 0
                      || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1 && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                    return -1;
                  return 3663; /* *fma_fmsubadd_v4df_round */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 217:
          switch (pattern1036 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7160 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3808; /* fma_fmaddc_v32hf_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7160 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3816; /* fma_fmaddc_v16hf_round */

            default:
              return -1;
            }

        case 219:
          switch (pattern1036 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7160 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 3812; /* fma_fcmaddc_v32hf_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7160 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 3820; /* fma_fcmaddc_v16hf_round */

            default:
              return -1;
            }

        case 194:
          x7 = XVECEXP (x3, 0, 2);
          operands[3] = x7;
          if (!const_0_to_15_operand (operands[3], E_SImode)
              || !const48_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16SFmode:
              if (pattern1032 (x2, 
E_V16SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9331; /* avx512dq_rangepv16sf_round */

            case E_V8SFmode:
              if (pattern1032 (x2, 
E_V8SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9335; /* avx512dq_rangepv8sf_round */

            case E_V8DFmode:
              if (pattern1032 (x2, 
E_V8DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 9341; /* avx512dq_rangepv8df_round */

            case E_V4DFmode:
              if (pattern1032 (x2, 
E_V4DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 9345; /* avx512dq_rangepv4df_round */

            default:
              return -1;
            }

        case 278:
          x7 = XVECEXP (x3, 0, 2);
          operands[3] = x7;
          if (!const_0_to_255_operand (operands[3], E_SImode)
              || !const48_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1032 (x2, 
E_V32HFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 531 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
                return -1;
              return 10293; /* avx10_2_minmaxpv32hf_round */

            case E_V16HFmode:
              if (pattern1032 (x2, 
E_V16HFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10297; /* avx10_2_minmaxpv16hf_round */

            case E_V8HFmode:
              if (pattern1032 (x2, 
E_V8HFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10301; /* avx10_2_minmaxpv8hf_round */

            case E_V16SFmode:
              if (pattern1032 (x2, 
E_V16SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 532 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
                return -1;
              return 10305; /* avx10_2_minmaxpv16sf_round */

            case E_V8SFmode:
              if (pattern1032 (x2, 
E_V8SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10309; /* avx10_2_minmaxpv8sf_round */

            case E_V4SFmode:
              if (pattern1032 (x2, 
E_V4SFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10313; /* avx10_2_minmaxpv4sf_round */

            case E_V8DFmode:
              if (pattern1032 (x2, 
E_V8DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 533 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
                return -1;
              return 10317; /* avx10_2_minmaxpv8df_round */

            case E_V4DFmode:
              if (pattern1032 (x2, 
E_V4DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10321; /* avx10_2_minmaxpv4df_round */

            case E_V2DFmode:
              if (pattern1032 (x2, 
E_V2DFmode) != 0
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32648 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
                return -1;
              return 10325; /* avx10_2_minmaxpv2df_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_212 (x1, insn, pnum_clobbers);

    case 4:
      if (XINT (x3, 1) != 163)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      x9 = XVECEXP (x3, 0, 3);
      operands[4] = x9;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[5] = x6;
      if (!const48_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern1391 (x2, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6525; /* avx512f_fixupimmv16sf_round */

        case E_V8SFmode:
          if (pattern1391 (x2, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6529; /* avx512vl_fixupimmv8sf_round */

        case E_V8DFmode:
          if (pattern1391 (x2, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 6535; /* avx512f_fixupimmv8df_round */

        case E_V4DFmode:
          if (pattern1391 (x2, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 14159 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 521 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 6539; /* avx512vl_fixupimmv4df_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1))
    {
    case 0:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9545; /* vpshrd_v32hi */

    case 1:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9547; /* vpshrd_v16si */

    case 2:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 757 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 9549; /* vpshrd_v8di */

    case 3:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9551; /* vpshrd_v16hi */

    case 4:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 758 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9553; /* vpshrd_v8si */

    case 5:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9555; /* vpshrd_v4di */

    case 6:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 759 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9557; /* vpshrd_v8hi */

    case 7:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9559; /* vpshrd_v4si */

    case 8:
      if (!(
#line 30409 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI2) && 
#line 760 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 9561; /* vpshrd_v2di */

    default:
      return -1;
    }
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 175:
      return recog_224 (x1, insn, pnum_clobbers);

    case 178:
      return recog_217 (x1, insn, pnum_clobbers);

    case 63:
      switch (pattern143 (x1))
        {
        case 0:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2546; /* ieee_maxv32hf3 */

        case 1:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2554; /* ieee_maxv16hf3 */

        case 2:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2562; /* ieee_maxv8hf3 */

        case 3:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2566; /* ieee_maxv16sf3 */

        case 4:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2574; /* ieee_maxv8sf3 */

        case 5:
          if (!
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1))
            return -1;
          return 2582; /* ieee_maxv4sf3 */

        case 6:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2586; /* ieee_maxv8df3 */

        case 7:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2594; /* ieee_maxv4df3 */

        case 8:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2602; /* ieee_maxv2df3 */

        default:
          return -1;
        }

    case 62:
      switch (pattern143 (x1))
        {
        case 0:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 2550; /* ieee_minv32hf3 */

        case 1:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2558; /* ieee_minv16hf3 */

        case 2:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 2564; /* ieee_minv8hf3 */

        case 3:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2570; /* ieee_minv16sf3 */

        case 4:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2578; /* ieee_minv8sf3 */

        case 5:
          if (!
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1))
            return -1;
          return 2584; /* ieee_minv4sf3 */

        case 6:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 2590; /* ieee_minv8df3 */

        case 7:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 2598; /* ieee_minv4df3 */

        case 8:
          if (!(
#line 3393 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && 1
   && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2604; /* ieee_minv2df3 */

        default:
          return -1;
        }

    case 192:
      return recog_223 (x1, insn, pnum_clobbers);

    case 221:
      switch (pattern145 (x1))
        {
        case 0:
          if (!(
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3861; /* avx512bw_fmulc_v32hf */

        case 1:
          if (!(
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3869; /* avx512vl_fmulc_v16hf */

        case 2:
          if (!(
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3877; /* avx512fp16_fmulc_v8hf */

        default:
          return -1;
        }

    case 222:
      switch (pattern145 (x1))
        {
        case 0:
          if (!(
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3865; /* avx512bw_fcmulc_v32hf */

        case 1:
          if (!(
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3873; /* avx512vl_fcmulc_v16hf */

        case 2:
          if (!(
#line 7318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 554 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3879; /* avx512fp16_fcmulc_v8hf */

        default:
          return -1;
        }

    case 58:
      return recog_225 (x1, insn, pnum_clobbers);

    case 94:
      return recog_220 (x1, insn, pnum_clobbers);

    case 188:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern152 (x2, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 16684 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7013; /* avx512bw_pmaddwd512v32hi */

        case E_V8SImode:
          if (pattern152 (x2, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 16684 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7015; /* avx512bw_pmaddwd512v16hi */

        case E_V4SImode:
          if (pattern152 (x2, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 16684 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && 1))
            return -1;
          return 7017; /* avx512bw_pmaddwd512v8hi */

        default:
          return -1;
        }

    case 57:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern676 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 19389 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7733; /* avx512bw_packuswb */

        case E_V32QImode:
          if (pattern676 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 19389 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7735; /* avx2_packuswb */

        case E_V16QImode:
          if (pattern676 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !
#line 19389 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1 && 1))
            return -1;
          return 7737; /* sse2_packuswb */

        case E_V32HImode:
          if (pattern676 (x2, 
E_V16SImode, 
E_V32HImode) != 0
              || !(
#line 23854 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 8099; /* avx512bw_packusdw */

        case E_V16HImode:
          if (pattern676 (x2, 
E_V8SImode, 
E_V16HImode) != 0
              || !(
#line 23854 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1) && 
#line 652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 8101; /* avx2_packusdw */

        case E_V8HImode:
          if (pattern676 (x2, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 23854 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return -1;
          return 8103; /* sse4_1_packusdw */

        default:
          return -1;
        }

    case 190:
      if (pattern146 (x1) != 0
          || !
#line 20726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7863; /* *avx512bw_pshuflwv32hi */

    case 189:
      if (pattern146 (x1) != 0
          || !
#line 20902 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 7869; /* *avx512bw_pshufhwv32hi */

    case 56:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DImode:
          if (pattern721 (x2, 
E_V64QImode, 
E_V8DImode) != 0
              || !(
#line 21929 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V64QImode, operands)) && 
#line 701 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7918; /* *avx512f_psadbw */

        case E_V4DImode:
          if (pattern721 (x2, 
E_V32QImode, 
E_V4DImode) != 0
              || !(
#line 21929 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V32QImode, operands)) && 
#line 701 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7919; /* *avx2_psadbw */

        case E_V2DImode:
          if (pattern721 (x2, 
E_V16QImode, 
E_V2DImode) != 0
              || !
#line 21929 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2
   && ix86_binary_operator_ok (PLUS, V16QImode, operands)))
            return -1;
          return 7920; /* *sse2_psadbw */

        default:
          return -1;
        }

    case 187:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern152 (x2, 
E_V8HImode, 
E_V16QImode) != 0
              || !(
#line 22805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7977; /* avx512bw_pmaddubsw512v8hi */

        case E_V16HImode:
          if (pattern152 (x2, 
E_V16HImode, 
E_V32QImode) != 0
              || !(
#line 22805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7979; /* avx512bw_pmaddubsw512v16hi */

        case E_V32HImode:
          if (pattern152 (x2, 
E_V32HImode, 
E_V64QImode) != 0
              || !(
#line 22805 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 685 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7981; /* avx512bw_pmaddubsw512v32hi */

        default:
          return -1;
        }

    case 52:
      switch (pattern147 (x1))
        {
        case 0:
          if (!(
#line 23130 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return -1;
          return 7995; /* avx512bw_pshufbv64qi3 */

        case 1:
          if (!(
#line 23130 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1) && 
#line 632 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
            return -1;
          return 7997; /* avx2_pshufbv32qi3 */

        case 2:
          if (!
#line 23130 "../../../gcc/config/i386/sse.md"
(TARGET_SSSE3 && 1 && 1))
            return -1;
          return 7999; /* ssse3_pshufbv16qi3 */

        default:
          return -1;
        }

    case 120:
      return recog_228 (x1, insn, pnum_clobbers);

    case 123:
      if (pattern148 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 23460 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 8047; /* sse4a_extrq */

    case 125:
      if (pattern71 (x1, 
E_V2DImode) != 0
          || !
#line 23486 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
        return -1;
      return 8049; /* sse4a_insertq */

    case 130:
      return recog_219 (x1, insn, pnum_clobbers);

    case 137:
      if (pattern149 (x1, 
E_V2DImode) != 0
          || !
#line 27110 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8452; /* aesenc */

    case 138:
      if (pattern149 (x1, 
E_V2DImode) != 0
          || !
#line 27128 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8453; /* aesenclast */

    case 139:
      if (pattern149 (x1, 
E_V2DImode) != 0
          || !
#line 27146 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8454; /* aesdec */

    case 140:
      if (pattern149 (x1, 
E_V2DImode) != 0
          || !
#line 27164 "../../../gcc/config/i386/sse.md"
(TARGET_AES || (TARGET_VAES && TARGET_AVX512VL)))
        return -1;
      return 8455; /* aesdeclast */

    case 142:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vector_operand (operands[1], E_V2DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_0_to_255_operand (operands[2], E_SImode)
          || !
#line 27194 "../../../gcc/config/i386/sse.md"
(TARGET_AES))
        return -1;
      return 8457; /* aeskeygenassist */

    case 151:
      return recog_221 (x1, insn, pnum_clobbers);

    case 144:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          if (pattern724 (x2, 
E_V16SImode, 
E_V16SFmode) != 0
              || !(
#line 28134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 374 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8722; /* avx512f_vpermilvarv16sf3 */

        case E_V8SFmode:
          if (pattern724 (x2, 
E_V8SImode, 
E_V8SFmode) != 0
              || !(
#line 28134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 374 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8724; /* avx_vpermilvarv8sf3 */

        case E_V4SFmode:
          if (pattern724 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 28134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 8726; /* avx_vpermilvarv4sf3 */

        case E_V8DFmode:
          if (pattern724 (x2, 
E_V8DImode, 
E_V8DFmode) != 0
              || !(
#line 28134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 375 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 8728; /* avx512f_vpermilvarv8df3 */

        case E_V4DFmode:
          if (pattern724 (x2, 
E_V4DImode, 
E_V4DFmode) != 0
              || !(
#line 28134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 375 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 8730; /* avx_vpermilvarv4df3 */

        case E_V2DFmode:
          if (pattern724 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !(
#line 28134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1) && 
#line 376 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 8732; /* avx_vpermilvarv2df3 */

        default:
          return -1;
        }

    case 47:
      return recog_226 (x1, insn, pnum_clobbers);

    case 150:
      return recog_227 (x1, insn, pnum_clobbers);

    case 160:
      return recog_218 (x1, insn, pnum_clobbers);

    case 166:
      return recog_222 (x1, insn, pnum_clobbers);

    case 179:
      if (pattern149 (x1, 
E_V4SImode) != 0
          || !
#line 29971 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9454; /* sha1msg1 */

    case 180:
      if (pattern149 (x1, 
E_V4SImode) != 0
          || !
#line 29982 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9455; /* sha1msg2 */

    case 181:
      if (pattern149 (x1, 
E_V4SImode) != 0
          || !
#line 29993 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9456; /* sha1nexte */

    case 183:
      if (pattern149 (x1, 
E_V4SImode) != 0
          || !
#line 30017 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9458; /* sha256msg1 */

    case 184:
      if (pattern149 (x1, 
E_V4SImode) != 0
          || !
#line 30028 "../../../gcc/config/i386/sse.md"
(TARGET_SHA))
        return -1;
      return 9459; /* sha256msg2 */

    case 239:
      if (pattern148 (x1, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 30090 "../../../gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 9464; /* vsha512msg1 */

    case 240:
      if (pattern71 (x1, 
E_V4DImode) != 0
          || !
#line 30101 "../../../gcc/config/i386/sse.md"
(TARGET_SHA512))
        return -1;
      return 9465; /* vsha512msg2 */

    case 242:
      switch (pattern150 (x1))
        {
        case 0:
          if (!(
#line 30124 "../../../gcc/config/i386/sse.md"
(TARGET_SM4) && 
#line 677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9467; /* vsm4key4_v16si */

        case 1:
          if (!
#line 30124 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9468; /* vsm4key4_v8si */

        case 2:
          if (!
#line 30124 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9469; /* vsm4key4_v4si */

        default:
          return -1;
        }

    case 243:
      switch (pattern150 (x1))
        {
        case 0:
          if (!(
#line 30137 "../../../gcc/config/i386/sse.md"
(TARGET_SM4) && 
#line 677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9470; /* vsm4rnds4_v16si */

        case 1:
          if (!
#line 30137 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9471; /* vsm4rnds4_v8si */

        case 2:
          if (!
#line 30137 "../../../gcc/config/i386/sse.md"
(TARGET_SM4))
            return -1;
          return 9472; /* vsm4rnds4_v4si */

        default:
          return -1;
        }

    case 197:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V64QImode:
          if (pattern64 (x2, 
E_V64QImode) != 0
              || !(
#line 30283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9497; /* vpmultishiftqbv64qi */

        case E_V16QImode:
          if (pattern64 (x2, 
E_V16QImode) != 0
              || !(
#line 30283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9499; /* vpmultishiftqbv16qi */

        case E_V32QImode:
          if (pattern64 (x2, 
E_V32QImode) != 0
              || !(
#line 30283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VBMI) && 
#line 327 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9501; /* vpmultishiftqbv32qi */

        default:
          return -1;
        }

    case 200:
      switch (pattern147 (x1))
        {
        case 0:
          if (!(
#line 30392 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9539; /* vgf2p8mulb_v64qi */

        case 1:
          if (!(
#line 30392 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI) && 
#line 635 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 9541; /* vgf2p8mulb_v32qi */

        case 2:
          if (!
#line 30392 "../../../gcc/config/i386/sse.md"
(TARGET_GFNI))
            return -1;
          return 9543; /* vgf2p8mulb_v16qi */

        default:
          return -1;
        }

    case 209:
      switch (pattern151 (x1))
        {
        case 0:
          if (!
#line 30868 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9671; /* vaesdec_v32qi */

        case 1:
          if (!(
#line 30868 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9672; /* vaesdec_v16qi */

        case 2:
          if (!(
#line 30868 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9673; /* vaesdec_v64qi */

        default:
          return -1;
        }

    case 210:
      switch (pattern151 (x1))
        {
        case 0:
          if (!
#line 30882 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9674; /* vaesdeclast_v32qi */

        case 1:
          if (!(
#line 30882 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9675; /* vaesdeclast_v16qi */

        case 2:
          if (!(
#line 30882 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9676; /* vaesdeclast_v64qi */

        default:
          return -1;
        }

    case 211:
      switch (pattern151 (x1))
        {
        case 0:
          if (!
#line 30896 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9677; /* vaesenc_v32qi */

        case 1:
          if (!(
#line 30896 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9678; /* vaesenc_v16qi */

        case 2:
          if (!(
#line 30896 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9679; /* vaesenc_v64qi */

        default:
          return -1;
        }

    case 212:
      switch (pattern151 (x1))
        {
        case 0:
          if (!
#line 30910 "../../../gcc/config/i386/sse.md"
(TARGET_VAES))
            return -1;
          return 9680; /* vaesenclast_v32qi */

        case 1:
          if (!(
#line 30910 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9681; /* vaesenclast_v16qi */

        case 2:
          if (!(
#line 30910 "../../../gcc/config/i386/sse.md"
(TARGET_VAES) && 
#line 698 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 9682; /* vaesenclast_v64qi */

        default:
          return -1;
        }

    case 249:
      switch (pattern153 (x1))
        {
        case 0:
          if (!(
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9809; /* vcvt2ph2bf8v32hf */

        case 1:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9817; /* vcvt2ph2bf8v16hf */

        case 2:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9825; /* vcvt2ph2bf8v8hf */

        default:
          return -1;
        }

    case 250:
      switch (pattern153 (x1))
        {
        case 0:
          if (!(
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9811; /* vcvt2ph2bf8sv32hf */

        case 1:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9819; /* vcvt2ph2bf8sv16hf */

        case 2:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9827; /* vcvt2ph2bf8sv8hf */

        default:
          return -1;
        }

    case 251:
      switch (pattern153 (x1))
        {
        case 0:
          if (!(
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9813; /* vcvt2ph2hf8v32hf */

        case 1:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9821; /* vcvt2ph2hf8v16hf */

        case 2:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9829; /* vcvt2ph2hf8v8hf */

        default:
          return -1;
        }

    case 252:
      switch (pattern153 (x1))
        {
        case 0:
          if (!(
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9815; /* vcvt2ph2hf8sv32hf */

        case 1:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9823; /* vcvt2ph2hf8sv16hf */

        case 2:
          if (!
#line 31741 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9831; /* vcvt2ph2hf8sv8hf */

        default:
          return -1;
        }

    case 245:
      switch (pattern155 (x1))
        {
        case 0:
          if (!(
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9841; /* vcvtbiasph2bf8v32hf */

        case 1:
          if (!
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9849; /* vcvtbiasph2bf8v16hf */

        default:
          return -1;
        }

    case 246:
      switch (pattern155 (x1))
        {
        case 0:
          if (!(
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9843; /* vcvtbiasph2bf8sv32hf */

        case 1:
          if (!
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9851; /* vcvtbiasph2bf8sv16hf */

        default:
          return -1;
        }

    case 247:
      switch (pattern155 (x1))
        {
        case 0:
          if (!(
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9845; /* vcvtbiasph2hf8v32hf */

        case 1:
          if (!
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9853; /* vcvtbiasph2hf8v16hf */

        default:
          return -1;
        }

    case 248:
      switch (pattern155 (x1))
        {
        case 0:
          if (!(
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 31822 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9847; /* vcvtbiasph2hf8sv32hf */

        case 1:
          if (!
#line 31830 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9855; /* vcvtbiasph2hf8sv16hf */

        default:
          return -1;
        }

    case 258:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V32BFmode:
          if (pattern64 (x2, 
E_V32BFmode) != 0
              || !(
#line 32097 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 9950; /* avx10_2_scalefbf16_v32bf */

        case E_V16BFmode:
          if (pattern64 (x2, 
E_V16BFmode) != 0
              || !
#line 32097 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9952; /* avx10_2_scalefbf16_v16bf */

        case E_V8BFmode:
          if (pattern64 (x2, 
E_V8BFmode) != 0
              || !
#line 32097 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 9954; /* avx10_2_scalefbf16_v8bf */

        default:
          return -1;
        }

    case 259:
      switch (pattern156 (x1))
        {
        case 0:
          if (!(
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10064; /* avx10_2_rndscalebf16_v32bf */

        case 1:
          if (!
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10070; /* avx10_2_rndscalebf16_v16bf */

        case 2:
          if (!
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10076; /* avx10_2_rndscalebf16_v8bf */

        default:
          return -1;
        }

    case 260:
      switch (pattern156 (x1))
        {
        case 0:
          if (!(
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10066; /* avx10_2_reducebf16_v32bf */

        case 1:
          if (!
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10072; /* avx10_2_reducebf16_v16bf */

        case 2:
          if (!
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10078; /* avx10_2_reducebf16_v8bf */

        default:
          return -1;
        }

    case 261:
      switch (pattern156 (x1))
        {
        case 0:
          if (!(
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10068; /* avx10_2_getmantbf16_v32bf */

        case 1:
          if (!
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10074; /* avx10_2_getmantbf16_v16bf */

        case 2:
          if (!
#line 32438 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10080; /* avx10_2_getmantbf16_v8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern851 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 8LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 9LL)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 10LL)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 11LL)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 12LL)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 13LL)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 14LL)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 15LL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!nonimmediate_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || !register_operand (operands[1], E_V16SFmode)
              || !(
#line 12720 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4780; /* vec_extract_hi_v16sf */

        case E_V8SImode:
          if (!nonimmediate_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || !register_operand (operands[1], E_V16SImode)
              || !(
#line 12720 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4781; /* vec_extract_hi_v16si */

        case E_V8HImode:
          if (!nonimmediate_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_V16HImode)
              || !
#line 13108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 4811; /* vec_extract_hi_v16hi */

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[0], E_V8HFmode)
              || GET_MODE (x2) != E_V8HFmode
              || !register_operand (operands[1], E_V16HFmode)
              || !
#line 13108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 4812; /* vec_extract_hi_v16hf */

        case E_V8BFmode:
          if (!nonimmediate_operand (operands[0], E_V8BFmode)
              || GET_MODE (x2) != E_V8BFmode
              || !register_operand (operands[1], E_V16BFmode)
              || !
#line 13108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))
            return -1;
          return 4813; /* vec_extract_hi_v16bf */

        default:
          return -1;
        }

    case 0LL:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 1LL)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 2LL)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 3LL)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 4LL)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 5LL)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 6LL)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 7LL)
        return -1;
      switch (pattern1401 (x2))
        {
        case 0:
          if (!(
#line 12825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4784; /* vec_extract_lo_v16sf */

        case 1:
          if (!(
#line 12825 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4785; /* vec_extract_lo_v16si */

        case 2:
          if (!
#line 13094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 4808; /* vec_extract_lo_v16hi */

        case 3:
          if (!
#line 13094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 4809; /* vec_extract_lo_v16hf */

        case 4:
          if (!
#line 13094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
            return -1;
          return 4810; /* vec_extract_lo_v16bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern611 (x3) != 0
      || !nonimmediate_operand (operands[0], E_V32QImode)
      || GET_MODE (x2) != E_V32QImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0LL:
      if (pattern1628 (x3) != 0)
        return -1;
      x5 = XVECEXP (x3, 0, 16);
      if (XWINT (x5, 0) != 16LL)
        return -1;
      x6 = XVECEXP (x3, 0, 17);
      if (XWINT (x6, 0) != 17LL)
        return -1;
      x7 = XVECEXP (x3, 0, 18);
      if (XWINT (x7, 0) != 18LL)
        return -1;
      x8 = XVECEXP (x3, 0, 19);
      if (XWINT (x8, 0) != 19LL)
        return -1;
      x9 = XVECEXP (x3, 0, 20);
      if (XWINT (x9, 0) != 20LL)
        return -1;
      x10 = XVECEXP (x3, 0, 21);
      if (XWINT (x10, 0) != 21LL)
        return -1;
      x11 = XVECEXP (x3, 0, 22);
      if (XWINT (x11, 0) != 22LL)
        return -1;
      x12 = XVECEXP (x3, 0, 23);
      if (XWINT (x12, 0) != 23LL
          || pattern1745 (x3) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 28);
      if (XWINT (x13, 0) != 28LL)
        return -1;
      x14 = XVECEXP (x3, 0, 29);
      if (XWINT (x14, 0) != 29LL)
        return -1;
      x15 = XVECEXP (x3, 0, 30);
      if (XWINT (x15, 0) != 30LL)
        return -1;
      x16 = XVECEXP (x3, 0, 31);
      if (XWINT (x16, 0) != 31LL
          || !nonimmediate_operand (operands[1], E_V64QImode)
          || !
#line 13140 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
        return -1;
      return 4814; /* vec_extract_lo_v64qi */

    case 32LL:
      x17 = XVECEXP (x3, 0, 1);
      if (XWINT (x17, 0) != 33LL)
        return -1;
      x18 = XVECEXP (x3, 0, 2);
      if (XWINT (x18, 0) != 34LL)
        return -1;
      x19 = XVECEXP (x3, 0, 3);
      if (XWINT (x19, 0) != 35LL)
        return -1;
      x20 = XVECEXP (x3, 0, 4);
      if (XWINT (x20, 0) != 36LL)
        return -1;
      x21 = XVECEXP (x3, 0, 5);
      if (XWINT (x21, 0) != 37LL)
        return -1;
      x22 = XVECEXP (x3, 0, 6);
      if (XWINT (x22, 0) != 38LL)
        return -1;
      x23 = XVECEXP (x3, 0, 7);
      if (XWINT (x23, 0) != 39LL)
        return -1;
      x24 = XVECEXP (x3, 0, 8);
      if (XWINT (x24, 0) != 40LL)
        return -1;
      x25 = XVECEXP (x3, 0, 9);
      if (XWINT (x25, 0) != 41LL)
        return -1;
      x26 = XVECEXP (x3, 0, 10);
      if (XWINT (x26, 0) != 42LL)
        return -1;
      x27 = XVECEXP (x3, 0, 11);
      if (XWINT (x27, 0) != 43LL)
        return -1;
      x28 = XVECEXP (x3, 0, 12);
      if (XWINT (x28, 0) != 44LL)
        return -1;
      x29 = XVECEXP (x3, 0, 13);
      if (XWINT (x29, 0) != 45LL)
        return -1;
      x30 = XVECEXP (x3, 0, 14);
      if (XWINT (x30, 0) != 46LL)
        return -1;
      x31 = XVECEXP (x3, 0, 15);
      if (XWINT (x31, 0) != 47LL)
        return -1;
      x5 = XVECEXP (x3, 0, 16);
      if (XWINT (x5, 0) != 48LL)
        return -1;
      x6 = XVECEXP (x3, 0, 17);
      if (XWINT (x6, 0) != 49LL)
        return -1;
      x7 = XVECEXP (x3, 0, 18);
      if (XWINT (x7, 0) != 50LL)
        return -1;
      x8 = XVECEXP (x3, 0, 19);
      if (XWINT (x8, 0) != 51LL)
        return -1;
      x9 = XVECEXP (x3, 0, 20);
      if (XWINT (x9, 0) != 52LL)
        return -1;
      x10 = XVECEXP (x3, 0, 21);
      if (XWINT (x10, 0) != 53LL)
        return -1;
      x11 = XVECEXP (x3, 0, 22);
      if (XWINT (x11, 0) != 54LL)
        return -1;
      x12 = XVECEXP (x3, 0, 23);
      if (XWINT (x12, 0) != 55LL)
        return -1;
      x32 = XVECEXP (x3, 0, 24);
      if (XWINT (x32, 0) != 56LL)
        return -1;
      x33 = XVECEXP (x3, 0, 25);
      if (XWINT (x33, 0) != 57LL)
        return -1;
      x34 = XVECEXP (x3, 0, 26);
      if (XWINT (x34, 0) != 58LL)
        return -1;
      x35 = XVECEXP (x3, 0, 27);
      if (XWINT (x35, 0) != 59LL)
        return -1;
      x13 = XVECEXP (x3, 0, 28);
      if (XWINT (x13, 0) != 60LL)
        return -1;
      x14 = XVECEXP (x3, 0, 29);
      if (XWINT (x14, 0) != 61LL)
        return -1;
      x15 = XVECEXP (x3, 0, 30);
      if (XWINT (x15, 0) != 62LL)
        return -1;
      x16 = XVECEXP (x3, 0, 31);
      if (XWINT (x16, 0) != 63LL
          || !register_operand (operands[1], E_V64QImode)
          || !
#line 13189 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 4815; /* vec_extract_hi_v64qi */

    default:
      return -1;
    }
}

 int
recog_290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern470 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4954; /* *avx512bw_vpternlogv64qi_1 */

        case 1:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4981; /* *avx512vl_vpternlogv32qi_1 */

        case 2:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5008; /* *avx512vl_vpternlogv16qi_1 */

        case 3:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5035; /* *avx512bw_vpternlogv32hi_1 */

        case 4:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5062; /* *avx512vl_vpternlogv16hi_1 */

        case 5:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5089; /* *avx512vl_vpternlogv8hi_1 */

        case 6:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5116; /* *avx512f_vpternlogv16si_1 */

        case 7:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5143; /* *avx512vl_vpternlogv8si_1 */

        case 8:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5170; /* *avx512vl_vpternlogv4si_1 */

        case 9:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5197; /* *avx512f_vpternlogv8di_1 */

        case 10:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5224; /* *avx512vl_vpternlogv4di_1 */

        case 11:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5251; /* *avx512vl_vpternlogv2di_1 */

        case 12:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4957; /* *avx512bw_vpternlogv64qi_1 */

        case 13:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4984; /* *avx512vl_vpternlogv32qi_1 */

        case 14:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5011; /* *avx512vl_vpternlogv16qi_1 */

        case 15:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5038; /* *avx512bw_vpternlogv32hi_1 */

        case 16:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5065; /* *avx512vl_vpternlogv16hi_1 */

        case 17:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5092; /* *avx512vl_vpternlogv8hi_1 */

        case 18:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5119; /* *avx512f_vpternlogv16si_1 */

        case 19:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5146; /* *avx512vl_vpternlogv8si_1 */

        case 20:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5173; /* *avx512vl_vpternlogv4si_1 */

        case 21:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5200; /* *avx512f_vpternlogv8di_1 */

        case 22:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5227; /* *avx512vl_vpternlogv4di_1 */

        case 23:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5254; /* *avx512vl_vpternlogv2di_1 */

        case 24:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 4960; /* *avx512bw_vpternlogv64qi_1 */

        case 25:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 4987; /* *avx512vl_vpternlogv32qi_1 */

        case 26:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5014; /* *avx512vl_vpternlogv16qi_1 */

        case 27:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5041; /* *avx512bw_vpternlogv32hi_1 */

        case 28:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5068; /* *avx512vl_vpternlogv16hi_1 */

        case 29:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5095; /* *avx512vl_vpternlogv8hi_1 */

        case 30:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5122; /* *avx512f_vpternlogv16si_1 */

        case 31:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5149; /* *avx512vl_vpternlogv8si_1 */

        case 32:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5176; /* *avx512vl_vpternlogv4si_1 */

        case 33:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5203; /* *avx512f_vpternlogv8di_1 */

        case 34:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5230; /* *avx512vl_vpternlogv4di_1 */

        case 35:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5257; /* *avx512vl_vpternlogv2di_1 */

        case 36:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6244; /* *avx512bw_vpternlogv64qi_3 */

        case 37:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6253; /* *avx512vl_vpternlogv32qi_3 */

        case 38:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6262; /* *avx512vl_vpternlogv16qi_3 */

        case 39:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6271; /* *avx512bw_vpternlogv32hi_3 */

        case 40:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6280; /* *avx512vl_vpternlogv16hi_3 */

        case 41:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6289; /* *avx512vl_vpternlogv8hi_3 */

        case 42:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6298; /* *avx512f_vpternlogv16si_3 */

        case 43:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6307; /* *avx512vl_vpternlogv8si_3 */

        case 44:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6316; /* *avx512vl_vpternlogv4si_3 */

        case 45:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6325; /* *avx512f_vpternlogv8di_3 */

        case 46:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6334; /* *avx512vl_vpternlogv4di_3 */

        case 47:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6343; /* *avx512vl_vpternlogv2di_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5602; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5629; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5656; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5683; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5710; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5737; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5764; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5791; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5818; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5845; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5872; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5899; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5605; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5632; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5659; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5686; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5713; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5740; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5767; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5794; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5821; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5848; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5875; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5902; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5608; /* *avx512bw_vpternlogv64qi_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5635; /* *avx512vl_vpternlogv32qi_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5662; /* *avx512vl_vpternlogv16qi_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5689; /* *avx512bw_vpternlogv32hi_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5716; /* *avx512vl_vpternlogv16hi_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5743; /* *avx512vl_vpternlogv8hi_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5770; /* *avx512f_vpternlogv16si_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5797; /* *avx512vl_vpternlogv8si_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5824; /* *avx512vl_vpternlogv4si_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5851; /* *avx512f_vpternlogv8di_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5878; /* *avx512vl_vpternlogv4di_2 */

        case 11:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5905; /* *avx512vl_vpternlogv2di_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern474 (x2))
            {
            case 0:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5268; /* *avx512bw_vpternlogv32hf_1 */

            case 1:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5295; /* *avx512vl_vpternlogv16hf_1 */

            case 2:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5322; /* *avx512fp16_vpternlogv8hf_1 */

            case 3:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5349; /* *avx512bw_vpternlogv32bf_1 */

            case 4:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5376; /* *avx512vl_vpternlogv16bf_1 */

            case 5:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5403; /* *avx512vl_vpternlogv8bf_1 */

            case 6:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5430; /* *avx512f_vpternlogv16sf_1 */

            case 7:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5457; /* *avx512vl_vpternlogv8sf_1 */

            case 8:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5484; /* *avx512vl_vpternlogv4sf_1 */

            case 9:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5511; /* *avx512f_vpternlogv8df_1 */

            case 10:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5538; /* *avx512vl_vpternlogv4df_1 */

            case 11:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 5565; /* *avx512vl_vpternlogv2df_1 */

            case 12:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5271; /* *avx512bw_vpternlogv32hf_1 */

            case 13:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5298; /* *avx512vl_vpternlogv16hf_1 */

            case 14:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5325; /* *avx512fp16_vpternlogv8hf_1 */

            case 15:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5352; /* *avx512bw_vpternlogv32bf_1 */

            case 16:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5379; /* *avx512vl_vpternlogv16bf_1 */

            case 17:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5406; /* *avx512vl_vpternlogv8bf_1 */

            case 18:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5433; /* *avx512f_vpternlogv16sf_1 */

            case 19:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5460; /* *avx512vl_vpternlogv8sf_1 */

            case 20:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5487; /* *avx512vl_vpternlogv4sf_1 */

            case 21:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5514; /* *avx512f_vpternlogv8df_1 */

            case 22:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5541; /* *avx512vl_vpternlogv4df_1 */

            case 23:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 5568; /* *avx512vl_vpternlogv2df_1 */

            case 24:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5274; /* *avx512bw_vpternlogv32hf_1 */

            case 25:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5301; /* *avx512vl_vpternlogv16hf_1 */

            case 26:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5328; /* *avx512fp16_vpternlogv8hf_1 */

            case 27:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5355; /* *avx512bw_vpternlogv32bf_1 */

            case 28:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5382; /* *avx512vl_vpternlogv16bf_1 */

            case 29:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5409; /* *avx512vl_vpternlogv8bf_1 */

            case 30:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5436; /* *avx512f_vpternlogv16sf_1 */

            case 31:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5463; /* *avx512vl_vpternlogv8sf_1 */

            case 32:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5490; /* *avx512vl_vpternlogv4sf_1 */

            case 33:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5517; /* *avx512f_vpternlogv8df_1 */

            case 34:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5544; /* *avx512vl_vpternlogv4df_1 */

            case 35:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 5571; /* *avx512vl_vpternlogv2df_1 */

            case 36:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6348; /* *avx512bw_vpternlogv32hf_3 */

            case 37:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6357; /* *avx512vl_vpternlogv16hf_3 */

            case 38:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6366; /* *avx512fp16_vpternlogv8hf_3 */

            case 39:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6375; /* *avx512bw_vpternlogv32bf_3 */

            case 40:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6384; /* *avx512vl_vpternlogv16bf_3 */

            case 41:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6393; /* *avx512vl_vpternlogv8bf_3 */

            case 42:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6402; /* *avx512f_vpternlogv16sf_3 */

            case 43:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6411; /* *avx512vl_vpternlogv8sf_3 */

            case 44:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6420; /* *avx512vl_vpternlogv4sf_3 */

            case 45:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6429; /* *avx512f_vpternlogv8df_3 */

            case 46:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6438; /* *avx512vl_vpternlogv4df_3 */

            case 47:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6447; /* *avx512vl_vpternlogv2df_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern475 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5916; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5943; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5970; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5997; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6024; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6051; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6078; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6105; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6132; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6159; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6186; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6213; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern475 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5919; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5946; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5973; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6000; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6027; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6054; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6081; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6108; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6135; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6162; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6189; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6216; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern475 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5922; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5949; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5976; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6003; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6030; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6057; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6084; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6111; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6138; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6165; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6192; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6219; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern474 (x2))
            {
            case 0:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5277; /* *avx512bw_vpternlogv32hf_1 */

            case 1:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5304; /* *avx512vl_vpternlogv16hf_1 */

            case 2:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5331; /* *avx512fp16_vpternlogv8hf_1 */

            case 3:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5358; /* *avx512bw_vpternlogv32bf_1 */

            case 4:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5385; /* *avx512vl_vpternlogv16bf_1 */

            case 5:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5412; /* *avx512vl_vpternlogv8bf_1 */

            case 6:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5439; /* *avx512f_vpternlogv16sf_1 */

            case 7:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5466; /* *avx512vl_vpternlogv8sf_1 */

            case 8:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5493; /* *avx512vl_vpternlogv4sf_1 */

            case 9:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5520; /* *avx512f_vpternlogv8df_1 */

            case 10:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5547; /* *avx512vl_vpternlogv4df_1 */

            case 11:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 5574; /* *avx512vl_vpternlogv2df_1 */

            case 12:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5280; /* *avx512bw_vpternlogv32hf_1 */

            case 13:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5307; /* *avx512vl_vpternlogv16hf_1 */

            case 14:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5334; /* *avx512fp16_vpternlogv8hf_1 */

            case 15:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5361; /* *avx512bw_vpternlogv32bf_1 */

            case 16:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5388; /* *avx512vl_vpternlogv16bf_1 */

            case 17:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5415; /* *avx512vl_vpternlogv8bf_1 */

            case 18:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5442; /* *avx512f_vpternlogv16sf_1 */

            case 19:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5469; /* *avx512vl_vpternlogv8sf_1 */

            case 20:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5496; /* *avx512vl_vpternlogv4sf_1 */

            case 21:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5523; /* *avx512f_vpternlogv8df_1 */

            case 22:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5550; /* *avx512vl_vpternlogv4df_1 */

            case 23:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 5577; /* *avx512vl_vpternlogv2df_1 */

            case 24:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5283; /* *avx512bw_vpternlogv32hf_1 */

            case 25:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5310; /* *avx512vl_vpternlogv16hf_1 */

            case 26:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5337; /* *avx512fp16_vpternlogv8hf_1 */

            case 27:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5364; /* *avx512bw_vpternlogv32bf_1 */

            case 28:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5391; /* *avx512vl_vpternlogv16bf_1 */

            case 29:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5418; /* *avx512vl_vpternlogv8bf_1 */

            case 30:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5445; /* *avx512f_vpternlogv16sf_1 */

            case 31:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5472; /* *avx512vl_vpternlogv8sf_1 */

            case 32:
              if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5499; /* *avx512vl_vpternlogv4sf_1 */

            case 33:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5526; /* *avx512f_vpternlogv8df_1 */

            case 34:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5553; /* *avx512vl_vpternlogv4df_1 */

            case 35:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 5580; /* *avx512vl_vpternlogv2df_1 */

            case 36:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6351; /* *avx512bw_vpternlogv32hf_3 */

            case 37:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6360; /* *avx512vl_vpternlogv16hf_3 */

            case 38:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6369; /* *avx512fp16_vpternlogv8hf_3 */

            case 39:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6378; /* *avx512bw_vpternlogv32bf_3 */

            case 40:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6387; /* *avx512vl_vpternlogv16bf_3 */

            case 41:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6396; /* *avx512vl_vpternlogv8bf_3 */

            case 42:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6405; /* *avx512f_vpternlogv16sf_3 */

            case 43:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6414; /* *avx512vl_vpternlogv8sf_3 */

            case 44:
              if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
                return -1;
              return 6423; /* *avx512vl_vpternlogv4sf_3 */

            case 45:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6432; /* *avx512f_vpternlogv8df_3 */

            case 46:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6441; /* *avx512vl_vpternlogv4df_3 */

            case 47:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6450; /* *avx512vl_vpternlogv2df_3 */

            default:
              return -1;
            }

        case AND:
          switch (pattern475 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5925; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5952; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5979; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6006; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6033; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6060; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6087; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6114; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6141; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6168; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6195; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6222; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern475 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5928; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5955; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5982; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6009; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6036; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6063; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6090; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6117; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6144; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6171; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6198; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6225; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern475 (x2))
            {
            case 0:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 5931; /* *avx512bw_vpternlogv32hf_2 */

            case 1:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 5958; /* *avx512vl_vpternlogv16hf_2 */

            case 2:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 5985; /* *avx512fp16_vpternlogv8hf_2 */

            case 3:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6012; /* *avx512bw_vpternlogv32bf_2 */

            case 4:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6039; /* *avx512vl_vpternlogv16bf_2 */

            case 5:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6066; /* *avx512vl_vpternlogv8bf_2 */

            case 6:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6093; /* *avx512f_vpternlogv16sf_2 */

            case 7:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6120; /* *avx512vl_vpternlogv8sf_2 */

            case 8:
              if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
                return -1;
              return 6147; /* *avx512vl_vpternlogv4sf_2 */

            case 9:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 6174; /* *avx512f_vpternlogv8df_2 */

            case 10:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 6201; /* *avx512vl_vpternlogv4df_2 */

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 6228; /* *avx512vl_vpternlogv2df_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_294 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pattern505 (x1, 
AND) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (pattern870 (x8, 
E_QImode) != 0)
        return -1;
      if (
#line 12959 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)
   && ix86_match_ccmode (insn,
			 CONST_INT_P (operands[2])
			 && INTVAL (operands[2]) >= 0 ? CCNOmode : CCZmode)))
        return 611; /* *andqi_2_maybe_si */
      if (!
#line 13001 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (AND, QImode, operands, TARGET_APX_NDD)))
        return -1;
      return 612; /* *andqi_2 */

    case E_HImode:
      if (pattern870 (x8, 
E_HImode) != 0
          || !
#line 13001 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (AND, HImode, operands, TARGET_APX_NDD)))
        return -1;
      return 613; /* *andhi_2 */

    case E_SImode:
      if (pattern871 (x8, 
E_SImode) != 0
          || !
#line 13001 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)))
        return -1;
      return 614; /* *andsi_2 */

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (XWINT (x8, 0) == 0LL)
            {
              switch (pattern873 (x1, 
PLUS))
                {
                case 0:
                  if (
#line 7128 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)))
                    return 248; /* *addqi_2 */
                  break;

                case 1:
                  if (
#line 7128 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)))
                    return 249; /* *addhi_2 */
                  break;

                case 2:
                  if (
#line 7128 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                    return 250; /* *addsi_2 */
                  break;

                case 3:
                  if ((
#line 7128 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 251; /* *adddi_2 */
                  break;

                case 4:
                  if (
#line 7410 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return 259; /* *addqi_5 */
                  break;

                case 5:
                  if (
#line 7410 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return 260; /* *addhi_5 */
                  break;

                case 6:
                  if (
#line 7410 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                    return 261; /* *addsi_5 */
                  break;

                case 7:
                  if ((
#line 7410 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCGOCmode)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 262; /* *adddi_5 */
                  break;

                default:
                  break;
                }
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_360 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (GET_MODE (x3) != E_CCCmode
          || GET_MODE (x4) != E_CCCmode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          if (!rtx_equal_p (x8, operands[2]))
            return -1;
          switch (pattern1367 (x5))
            {
            case 0:
              if (!
#line 10025 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 454; /* *addqi3_cconly_overflow_2 */

            case 1:
              if (!
#line 10025 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 455; /* *addhi3_cconly_overflow_2 */

            case 2:
              if (!
#line 10025 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 456; /* *addsi3_cconly_overflow_2 */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != PLUS)
            return -1;
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_QImode:
              if (pattern1496 (x1, 
E_QImode) != 0
                  || !
#line 10043 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 457; /* *addqi3_cc_overflow_2 */

            case E_HImode:
              if (pattern1496 (x1, 
E_HImode) != 0
                  || !
#line 10043 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 458; /* *addhi3_cc_overflow_2 */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x11) != E_SImode
                  || !rtx_equal_p (x8, operands[2])
                  || !
#line 10043 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 459; /* *addsi3_cc_overflow_2 */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x11) != E_DImode)
                return -1;
              if (x86_64_general_operand (operands[2], E_DImode)
                  && rtx_equal_p (x8, operands[2])
                  && (
#line 10043 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 460; /* *adddi3_cc_overflow_2 */
              if (!x86_64_hilo_general_operand (operands[2], E_DImode)
                  || !rtx_equal_p (x8, operands[1])
                  || !(
#line 10081 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 461; /* *adddi3_doubleword_cc_overflow_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 110)
        return -1;
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x11 = XEXP (x9, 1);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x3) != E_CCGOCmode)
        return -1;
      switch (pattern310 (x1, 
E_CCGOCmode))
        {
        case 0:
          return 10415; /* atomic_add_fetch_cmp_0qi_1 */

        case 1:
          return 10416; /* atomic_add_fetch_cmp_0hi_1 */

        case 2:
          return 10417; /* atomic_add_fetch_cmp_0si_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = recog_370 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 17
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_CODE (x4))
        {
        case SUBREG:
          switch (pattern953 (x2))
            {
            case 0:
              if (!
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 336; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              return 337; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 338; /* *subqi_extdi_2_slp */

            case 3:
              return 345; /* *subqi_ext2hi_0 */

            case 4:
              return 346; /* *subqi_ext2si_0 */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 31LL)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != CLZ
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21276 "../../../gcc/config/i386/i386.md"
(!TARGET_LZCNT))
            return -1;
          return 1256; /* bsr_1 */

        default:
          return -1;
        }

    case MINUS:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern299 (x5) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x11 = XEXP (x4, 1);
      switch (GET_CODE (x11))
        {
        case LTU:
        case UNLT:
          operands[4] = x11;
          x12 = XEXP (x11, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x11, 0);
          operands[3] = x13;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1497 (x3, 
E_QImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 406; /* subqi3_carry */

            case E_HImode:
              if (pattern1497 (x3, 
E_HImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 407; /* subhi3_carry */

            case E_SImode:
              if (pattern1498 (x3, 
E_SImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 408; /* subsi3_carry */

            case E_DImode:
              if (pattern1498 (x3, 
E_DImode) != 0
                  || !(
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 409; /* subdi3_carry */

            default:
              return -1;
            }

        case EQ:
          x12 = XEXP (x11, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x11, 0);
          operands[3] = x13;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1438 (x3, 
E_QImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 479; /* *subqi3_eq */

            case E_HImode:
              if (pattern1438 (x3, 
E_HImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 480; /* *subhi3_eq */

            case E_SImode:
              if (pattern1439 (x3, 
E_SImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              return 481; /* *subsi3_eq */

            case E_DImode:
              if (pattern1439 (x3, 
E_DImode) != 0
                  || !(
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 482; /* *subdi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 17
              || GET_MODE (x7) != E_CCmode)
            return -1;
          operands[1] = x5;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !(
#line 10604 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                return -1;
              return 500; /* *mulhi3_1 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !
#line 10604 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
                return -1;
              return 502; /* *mulsi3_1 */

            case E_QImode:
              if (pattern201 (x4, 
E_QImode) != 0
                  || !
#line 10691 "../../../gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
                return -1;
              return 508; /* *mulqi3_1 */

            default:
              return -1;
            }

        case SET:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != UMUL_HIGHPART
              || GET_MODE (x9) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || pattern662 (x1) != 0
              || !(
#line 10955 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 517; /* *bmi2_umulsidi3_1 */

        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 110)
            return -1;
          x10 = XVECEXP (x6, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x4) != E_V2SFmode)
            return -1;
          operands[1] = x5;
          if (!nonimmediate_operand (operands[1], E_V2SFmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!nonimmediate_operand (operands[2], E_V2SFmode)
              || !
#line 795 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW && ix86_binary_operator_ok (MULT, V2SFmode, operands)))
            return -1;
          return 1628; /* *mmx_mulv2sf3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern510 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!(
#line 10994 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 518; /* *umulsidi3_1 */

        case 1:
          if (!
#line 11060 "../../../gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          return 524; /* *umulqihi3_1 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern510 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!(
#line 11040 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 520; /* *mulsidi3_1 */

        case 1:
          if (!
#line 11060 "../../../gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          return 522; /* *mulqihi3_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern322 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 14237 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return 767; /* *negdi2_doubleword */
              if (!(
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 776; /* *negdi_1 */

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x3) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14237 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 768; /* *negti2_doubleword */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, QImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 770; /* *negqi_1 */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, HImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 772; /* *neghi_1 */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 14346 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)
   && true))
                return -1;
              return 774; /* *negsi_1 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 14810 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              return 821; /* *negsf2_i387_1 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 14810 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              return 823; /* *negdf2_i387_1 */

            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || GET_MODE (x3) != E_XFmode
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 14810 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && !(SSE_FLOAT_MODE_P (XFmode) && TARGET_SSE_MATH)))
                return -1;
              return 825; /* *negxf2_i387_1 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x3) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode)
                  || !
#line 3134 "../../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size || TARGET_SSE2))
                return -1;
              return 1667; /* negv2qi2 */

            default:
              return -1;
            }

        case 1:
          switch (pattern637 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 14748 "../../../gcc/config/i386/i386.md"
(TARGET_SSE))
                return -1;
              return 818; /* *negtf2_1 */

            case 1:
              if (!
#line 14834 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return -1;
              *pnum_clobbers = 1;
              return 827; /* *neghf2_1 */

            case 2:
              if (!
#line 14850 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
                return -1;
              *pnum_clobbers = 1;
              return 829; /* *negsf2_1 */

            case 3:
              if (!
#line 14850 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
                return -1;
              *pnum_clobbers = 1;
              return 831; /* *negdf2_1 */

            case 4:
              if (!
#line 2239 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1654; /* *mmx_negv2bf */

            case 5:
              if (!
#line 2239 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1656; /* *mmx_negv2hf */

            case 6:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 411 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2133; /* *negv32bf2 */

            case 7:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2135; /* *negv16bf2 */

            case 8:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 412 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2137; /* *negv8bf2 */

            case 9:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 413 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2139; /* *negv32hf2 */

            case 10:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2141; /* *negv16hf2 */

            case 11:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 414 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2143; /* *negv8hf2 */

            case 12:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2145; /* *negv16sf2 */

            case 13:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 415 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2147; /* *negv8sf2 */

            case 14:
              if (!
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2149; /* *negv4sf2 */

            case 15:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 416 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2151; /* *negv8df2 */

            case 16:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2153; /* *negv4df2 */

            case 17:
              if (!(
#line 2585 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 417 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2155; /* *negv2df2 */

            default:
              return -1;
            }

        case 2:
          if (!
#line 14395 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 787; /* *negqi_1_slp */

        case 3:
          if (!
#line 14395 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 788; /* *neghi_1_slp */

        default:
          return -1;
        }

    case ABS:
      switch (pattern324 (x1))
        {
        case 0:
          if ((
#line 14644 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 807; /* *nabsdi2_doubleword */
          if (!(
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 816; /* *nabsdi2_1 */

        case 1:
          if (!(
#line 14644 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 808; /* *nabsti2_doubleword */

        case 2:
          if (!
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 813; /* *nabsqi2_1 */

        case 3:
          if (!
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 814; /* *nabshi2_1 */

        case 4:
          if (!
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()))
            return -1;
          return 815; /* *nabssi2_1 */

        case 5:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern957 (x3, 
E_TFmode) != 0
                  || !
#line 14773 "../../../gcc/config/i386/i386.md"
(TARGET_SSE))
                return -1;
              return 819; /* *nabstf2_1 */

            case E_SFmode:
              if (pattern958 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 14909 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH))
                return -1;
              return 832; /* *nabssf2_1 */

            case E_DFmode:
              if (pattern958 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 14909 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH))
                return -1;
              return 833; /* *nabsdf2_1 */

            case E_V2BFmode:
              if (pattern959 (x3, 
E_V2BFmode) != 0
                  || !
#line 2256 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1657; /* *mmx_nabsv2bf2 */

            case E_V2HFmode:
              if (pattern959 (x3, 
E_V2HFmode) != 0
                  || !
#line 2256 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE))
                return -1;
              return 1658; /* *mmx_nabsv2hf2 */

            case E_V16SFmode:
              if (pattern957 (x3, 
E_V16SFmode) != 0
                  || !(
#line 2610 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2156; /* *nabsv16sf2 */

            case E_V8SFmode:
              if (pattern957 (x3, 
E_V8SFmode) != 0
                  || !(
#line 2610 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 374 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2157; /* *nabsv8sf2 */

            case E_V4SFmode:
              if (pattern957 (x3, 
E_V4SFmode) != 0
                  || !
#line 2610 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return -1;
              return 2158; /* *nabsv4sf2 */

            case E_V8DFmode:
              if (pattern957 (x3, 
E_V8DFmode) != 0
                  || !(
#line 2610 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return -1;
              return 2159; /* *nabsv8df2 */

            case E_V4DFmode:
              if (pattern957 (x3, 
E_V4DFmode) != 0
                  || !(
#line 2610 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 375 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 2160; /* *nabsv4df2 */

            case E_V2DFmode:
              if (pattern957 (x3, 
E_V2DFmode) != 0
                  || !(
#line 2610 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 376 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 2161; /* *nabsv2df2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      operands[1] = x4;
      if (pattern507 (operands[1]) != 0
          || pattern300 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode)
            return -1;
          return 1449; /* *x86_movqicc_0_m1_neg */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode)
            return -1;
          return 1450; /* *x86_movhicc_0_m1_neg */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 1451; /* *x86_movsicc_0_m1_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 106:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern620 (x6, 
E_DImode, 
107, 
UNSPEC) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != UNSPEC
              || XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 108
              || GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || !pop_operand (operands[1], E_TImode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 3941 "../../../gcc/config/i386/i386.md"
(TARGET_APX_PUSH2POP2 && TARGET_APX_PPX))
            return -1;
          return 137; /* pop2p_di */

        case 97:
          if (pattern759 (x1) != 0
              || !
#line 21628 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1269; /* *tzcnt_si_falsedep */

        case 96:
          if (pattern759 (x1) != 0
              || !
#line 21629 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1270; /* *lzcnt_si_falsedep */

        case 74:
          if (pattern760 (x1) != 0
              || !
#line 25238 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)))
            return -1;
          return 1400; /* frndintxf2_roundeven_i387 */

        case 75:
          if (pattern760 (x1) != 0
              || !
#line 25238 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)))
            return -1;
          return 1401; /* frndintxf2_floor_i387 */

        case 76:
          if (pattern760 (x1) != 0
              || !
#line 25238 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)))
            return -1;
          return 1402; /* frndintxf2_ceil_i387 */

        case 77:
          if (pattern760 (x1) != 0
              || !
#line 25238 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)))
            return -1;
          return 1403; /* frndintxf2_trunc_i387 */

        case 78:
          switch (pattern762 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 25356 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              *pnum_clobbers = 1;
              return 1410; /* fistdi2_floor */

            case 1:
              if (!
#line 25369 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              return 1412; /* fisthi2_floor */

            case 2:
              if (!
#line 25369 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              return 1414; /* fistsi2_floor */

            default:
              return -1;
            }

        case 79:
          switch (pattern762 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 25356 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              *pnum_clobbers = 1;
              return 1411; /* fistdi2_ceil */

            case 1:
              if (!
#line 25369 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              return 1413; /* fisthi2_ceil */

            case 2:
              if (!
#line 25369 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
                return -1;
              return 1415; /* fistsi2_ceil */

            default:
              return -1;
            }

        case 92:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x10 = XEXP (x6, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (pattern875 (x7, 
E_CCmode, 
17) != 0)
            return -1;
          switch (pattern1048 (x1))
            {
            case 0:
              if (!(
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
                return -1;
              return 1513; /* stack_protect_set_1_si_si */

            case 1:
              if (!(
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
                return -1;
              return 1515; /* stack_protect_set_1_si_di */

            case 2:
              if (!(
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
                return -1;
              return 1514; /* stack_protect_set_1_di_si */

            case 3:
              if (!(
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
                return -1;
              return 1516; /* stack_protect_set_1_di_di */

            default:
              return -1;
            }

        case 287:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != CLOBBER
              || !nonimmediate_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          if (!memory_operand (operands[2], E_DImode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[3] = x11;
          if (!scratch_operand (operands[3], E_DFmode)
              || !
#line 196 "../../../gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
            return -1;
          return 10368; /* atomic_loaddi_fpu */

        case 288:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x7) != CLOBBER
              || !memory_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          if (!memory_operand (operands[2], E_DImode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[3] = x11;
          if (!scratch_operand (operands[3], E_DFmode)
              || !
#line 295 "../../../gcc/config/i386/sync.md"
(!TARGET_64BIT && (TARGET_80387 || TARGET_SSE)))
            return -1;
          return 10372; /* atomic_storedi_fpu */

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != UNSPEC
          || XVECLEN (x10, 0) != 2
          || GET_MODE (x10) != E_XFmode)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != SET)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_CODE (x12) != UNSPEC
          || XVECLEN (x12, 0) != 2
          || XINT (x12, 1) != 90
          || GET_MODE (x12) != E_CCFPmode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 18
          || GET_MODE (x11) != E_CCFPmode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || pattern1308 (x1) != 0)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x14 = XVECEXP (x12, 0, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 86:
          if (XINT (x10, 1) != 87
              || !
#line 23875 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1375; /* fpremxf4_i387 */

        case 88:
          if (XINT (x10, 1) != 89
              || !
#line 23947 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1376; /* fprem1xf4_i387 */

        default:
          return -1;
        }

    case 4:
      if (XINT (x3, 1) != 23)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_BLKmode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (pattern1050 (x1))
        {
        case 0:
          if (!(
#line 26115 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return -1;
          return 1445; /* *strlenqi_1 */

        case 1:
          if (!(
#line 26115 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[CX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return -1;
          return 1446; /* *strlenqi_1 */

        default:
          return -1;
        }

    case 5:
      if (XINT (x3, 1) != 131)
        return -1;
      if (GET_MODE (x3) == E_SImode
          && pattern647 (x1, 
131, 
5) == 0
          && pattern1590 (x1) == 0
          && 
#line 25855 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2
   && ix86_pre_reload_split ()))
        return 8348; /* sse4_2_pcmpestr */
      if (GET_MODE (x3) != E_CCmode
          || pattern648 (x1) != 0
          || !register_operand (operands[3], E_SImode))
        return -1;
      x15 = XVECEXP (x3, 0, 2);
      operands[4] = x15;
      if (!nonimmediate_operand (operands[4], E_V16QImode))
        return -1;
      x16 = XVECEXP (x3, 0, 3);
      operands[5] = x16;
      if (!register_operand (operands[5], E_SImode))
        return -1;
      x17 = XVECEXP (x3, 0, 4);
      operands[6] = x17;
      if (!const_0_to_255_operand (operands[6], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_V16QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      if (!scratch_operand (operands[1], E_SImode)
          || !
#line 25958 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
        return -1;
      return 8351; /* sse4_2_pcmpestr_cconly */

    case 3:
      if (XINT (x3, 1) != 132)
        return -1;
      if (GET_MODE (x3) == E_SImode
          && pattern647 (x1, 
132, 
3) == 0
          && pattern1591 (x1) == 0
          && 
#line 25992 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2
   && ix86_pre_reload_split ()))
        return 8352; /* sse4_2_pcmpistr */
      if (GET_MODE (x3) != E_CCmode
          || pattern648 (x1) != 0
          || !nonimmediate_operand (operands[3], E_V16QImode))
        return -1;
      x15 = XVECEXP (x3, 0, 2);
      operands[4] = x15;
      if (!const_0_to_255_operand (operands[4], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_V16QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      if (!scratch_operand (operands[1], E_SImode)
          || !
#line 26083 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_2))
        return -1;
      return 8355; /* sse4_2_pcmpistr_cconly */

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!add_comparison_operator (x2, E_QImode))
    return NULL;
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NOT)
    return NULL;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  switch (GET_MODE (x3))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode)
          || !nonimmediate_operand (operands[3], E_QImode))
        return NULL;
      return gen_split_708 (insn, operands);

    case E_HImode:
      if (!register_operand (operands[2], E_HImode)
          || !nonimmediate_operand (operands[3], E_HImode))
        return NULL;
      return gen_split_709 (insn, operands);

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return NULL;
      return gen_split_710 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (pattern333 (x3) != 0
          || !(
#line 3748 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && CONST_INT_P (operands[3])
   && UINTVAL (operands[3]) == 0xffffffff00000000ll) && 
#line 3752 "../../../gcc/config/i386/i386.md"
( reload_completed)))
        return NULL;
      return gen_split_13 (insn, operands);

    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
              operands[3] = x7;
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern781 (x3, 
E_QImode) != 0
                      || !(
#line 8015 "../../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_130 (insn, operands);

                case E_HImode:
                  if (pattern781 (x3, 
E_HImode) != 0
                      || !(
#line 8015 "../../../gcc/config/i386/i386.md"
((!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && ((unsigned HOST_WIDE_INT) INTVAL (operands[3])
       < (HOST_WIDE_INT_1U << INTVAL (operands[2])))) && 
#line 8019 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_132 (insn, operands);

                case E_SImode:
                  if (pattern781 (x3, 
E_SImode) != 0
                      || !(
#line 8039 "../../../gcc/config/i386/i386.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[3])
   < (HOST_WIDE_INT_1U << INTVAL (operands[2]))) && 
#line 8042 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_134 (insn, operands);

                case E_DImode:
                  if (pattern782 (x3, 
E_DImode) != 0
                      || !((
#line 14137 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14151 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_372 (insn, operands);

                case E_TImode:
                  if (pattern782 (x3, 
E_TImode) != 0
                      || !((
#line 14137 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 16 * BITS_PER_UNIT / 2
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14151 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_375 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return NULL;
              operands[1] = x6;
              if (!register_operand (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_QImode))
                return NULL;
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !((
#line 14060 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14062 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            case LSHIFTRT:
              if (pattern765 (x3, 
E_SImode) != 0)
                return NULL;
              operands[4] = x6;
              if (!nonimmediate_operand (operands[4], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!nonimmediate_operand (operands[1], E_SImode))
                return NULL;
              x9 = XEXP (x7, 1);
              operands[3] = x9;
              if (!const_0_to_31_operand (operands[3], E_QImode)
                  || !(
#line 15707 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 15711 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_465 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern337 (x3))
            {
            case 0:
              if (!((
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_360 (insn, operands);

            case 1:
              if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_378 (insn, operands);

            case 2:
              if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_384 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern337 (x3))
            {
            case 0:
              if (!((
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14098 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_363 (insn, operands);

            case 1:
              if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_381 (insn, operands);

            case 2:
              if (!((
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT
   && (TImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14183 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_387 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern340 (x3))
        {
        case 0:
          if (!((
#line 14077 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14079 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_357 (insn, operands);

        case 1:
          if (!((
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_366 (insn, operands);

        case 2:
          if (!((
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14123 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_369 (insn, operands);

        case 3:
          if (!((
#line 14198 "../../../gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14209 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_390 (insn, operands);

        case 4:
          if (!((
#line 14198 "../../../gcc/config/i386/i386.md"
(TImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14209 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_393 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return NULL;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != ASHIFT
          || GET_MODE (x7) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_SImode))
        return NULL;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!const_0_to_31_operand (operands[2], E_QImode))
        return NULL;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return NULL;
      x9 = XEXP (x7, 1);
      operands[3] = x9;
      if (!const_0_to_31_operand (operands[3], E_QImode)
          || !(
#line 17091 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF
   && INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()) && 
#line 17095 "../../../gcc/config/i386/i386.md"
( 1)))
        return NULL;
      return gen_split_498 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern536 (x1, 
E_CCCmode) != 0
          || GET_MODE (x3) != E_CCCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      x9 = XEXP (x3, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return NULL;
      x10 = XEXP (x7, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return NULL;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return NULL;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern1532 (x10, 
E_DImode) != 0
              || !((
#line 10081 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 10083 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_166 (insn, operands);

        case E_TImode:
          if (pattern1532 (x10, 
E_TImode) != 0
              || !((
#line 10081 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 10083 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_167 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SUBREG:
          switch (pattern754 (x1))
            {
            case 0:
              if (!(
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_282 (insn, operands);

            case 1:
              if (!(
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_285 (insn, operands);

            case 2:
              if (!((
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case NOT:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return NULL;
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          if (!flags_reg_operand (operands[0], E_VOIDmode))
            return NULL;
          operands[1] = x3;
          if (!compare_operator (operands[1], E_VOIDmode)
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x14 = XEXP (x5, 0);
          operands[2] = x14;
          if (!general_reg_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_SImode))
            return NULL;
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[2])
              || !
#line 13416 "../../../gcc/config/i386/i386.md"
(reload_completed
   && optimize_insn_for_size_p () && optimize_size > 1
   && LEGACY_INT_REG_P (operands[2])
   && !REX_INT_REG_P (operands[3])
   && !reg_overlap_mentioned_p (operands[2], operands[3])))
            return NULL;
          return gen_split_316 (insn, operands);

        case NEG:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return NULL;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != AND)
            return NULL;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != NEG)
            return NULL;
          x13 = XEXP (x2, 0);
          operands[3] = x13;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return NULL;
          operands[4] = x3;
          if (!compare_operator (operands[4], E_VOIDmode))
            return NULL;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x6 = XEXP (x4, 1);
          if (!rtx_equal_p (x6, operands[1]))
            return NULL;
          switch (pattern1371 (x1))
            {
            case 0:
              if (!
#line 21805 "../../../gcc/config/i386/i386.md"
(TARGET_BMI
   && TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])))
                return NULL;
              return gen_split_741 (insn, operands);

            case 1:
              if (!(
#line 21805 "../../../gcc/config/i386/i386.md"
(TARGET_BMI
   && TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1])) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_742 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || pattern621 (x1, 
SET, 
E_CCZmode, 
17) != 0)
            return NULL;
          x7 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x7, 1);
          if (pattern1319 (x10) != 0
              || GET_MODE (x3) != E_CCZmode
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x4, 1);
          if (!rtx_equal_p (x6, operands[1]))
            return NULL;
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return NULL;
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[1])
              || !(
#line 21942 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 21944 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BLS
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_746 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern539 (x1, 
IOR))
        {
        case 0:
          if (!(
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_283 (insn, operands);

        case 1:
          if (!(
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_286 (insn, operands);

        case 2:
          if (!((
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_289 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern539 (x1, 
XOR))
        {
        case 0:
          if (!(
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_284 (insn, operands);

        case 1:
          if (!(
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_287 (insn, operands);

        case 2:
          if (!((
#line 13137 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 13141 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_290 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return NULL;
      x13 = XEXP (x2, 0);
      operands[0] = x13;
      if (!flags_reg_operand (operands[0], E_VOIDmode))
        return NULL;
      operands[2] = x3;
      if (!compare_operator (operands[2], E_VOIDmode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return NULL;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[3], E_QImode)
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || GET_MODE (x10) != E_QImode
                  || !
#line 15092 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_449 (insn, operands);

            case E_HImode:
              if (!nonimmediate_operand (operands[3], E_HImode)
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || GET_MODE (x10) != E_HImode
                  || !
#line 15092 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_450 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || GET_MODE (x10) != E_SImode
                  || !
#line 15092 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
                return NULL;
              return gen_split_451 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[3], E_DImode)
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || GET_MODE (x10) != E_DImode
                  || !(
#line 15092 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_452 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x10) != E_DImode)
            return NULL;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != NOT
              || GET_MODE (x11) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !nonimmediate_operand (operands[3], E_SImode)
              || !register_operand (operands[1], E_DImode))
            return NULL;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[3])
              || !
#line 15119 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)))
            return NULL;
          return gen_split_453 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return NULL;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x13 = XEXP (x2, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 17
          || GET_MODE (x13) != E_CCCmode)
        return NULL;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return NULL;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != CTZ
          || GET_MODE (x10) != E_SImode
          || GET_MODE (x3) != E_CCCmode)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !(
#line 20994 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 20996 "../../../gcc/config/i386/i386.md"
( (TARGET_AVOID_FALSE_DEP_FOR_BMI || TARGET_AVOID_FALSE_DEP_FOR_TZCNT)
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_728 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern322 (x1))
        {
        case 0:
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 14237 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14239 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_395 (insn, operands);

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x3) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !((
#line 14237 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NEG, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14239 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_396 (insn, operands);

            case E_SFmode:
              if (GET_MODE (x3) != E_SFmode)
                return NULL;
              if (fp_register_operand (operands[0], E_SFmode)
                  && fp_register_operand (operands[1], E_SFmode)
                  && 
#line 14817 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_418 (insn, operands);
              if (!general_reg_operand (operands[0], E_SFmode)
                  || !general_reg_operand (operands[1], E_SFmode)
                  || !
#line 14824 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_424 (insn, operands);

            case E_DFmode:
              if (GET_MODE (x3) != E_DFmode)
                return NULL;
              if (fp_register_operand (operands[0], E_DFmode)
                  && fp_register_operand (operands[1], E_DFmode)
                  && 
#line 14817 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_420 (insn, operands);
              if (!general_reg_operand (operands[0], E_DFmode)
                  || !general_reg_operand (operands[1], E_DFmode)
                  || !
#line 14824 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_426 (insn, operands);

            case E_XFmode:
              if (GET_MODE (x3) != E_XFmode)
                return NULL;
              if (fp_register_operand (operands[0], E_XFmode)
                  && fp_register_operand (operands[1], E_XFmode)
                  && 
#line 14817 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return gen_split_422 (insn, operands);
              if (!general_reg_operand (operands[0], E_XFmode)
                  || !general_reg_operand (operands[1], E_XFmode)
                  || !
#line 14824 "../../../gcc/config/i386/i386.md"
(TARGET_80387 && reload_completed))
                return NULL;
              return gen_split_428 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (pattern766 (x1) != 0
              || !(
#line 14748 "../../../gcc/config/i386/i386.md"
(TARGET_SSE) && 
#line 14750 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_415 (insn, operands);

        case 2:
          if (!(
#line 14395 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 14399 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_397 (insn, operands);

        case 3:
          if (!(
#line 14395 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 14399 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_398 (insn, operands);

        default:
          return NULL;
        }

    case ABS:
      switch (pattern324 (x1))
        {
        case 0:
          if (((
#line 14644 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14647 "../../../gcc/config/i386/i386.md"
( 1)))
            return gen_split_404 (insn, operands);
          if (!((
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (DImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14719 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_413 (insn, operands);

        case 1:
          if (!((
#line 14644 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && ix86_pre_reload_split ()) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14647 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 2:
          if (!(
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (QImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14719 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_410 (insn, operands);

        case 3:
          if (!(
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (HImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14719 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_411 (insn, operands);

        case 4:
          if (!(
#line 14715 "../../../gcc/config/i386/i386.md"
(TARGET_CMOVE
   && (SImode != QImode || !TARGET_PARTIAL_REG_STALL)
   && ix86_pre_reload_split ()) && 
#line 14719 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_412 (insn, operands);

        case 5:
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern957 (x3, 
E_TFmode) != 0
                  || !(
#line 14773 "../../../gcc/config/i386/i386.md"
(TARGET_SSE) && 
#line 14775 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_416 (insn, operands);

            case E_SFmode:
              if (pattern958 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 14909 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH) && 
#line 14911 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_443 (insn, operands);

            case E_DFmode:
              if (pattern958 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 14909 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH) && 
#line 14911 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_444 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case LSHIFTRT:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern298 (x6, 
E_CCmode, 
17) != 0
          || !mask_reg_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!mask_reg_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_0_to_31_operand (operands[2], E_VOIDmode)
          || !
#line 2319 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && reload_completed))
        return NULL;
      return gen_split_1020 (insn, operands);

    case UNSPEC:
      switch (pattern499 (x1))
        {
        case 0:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1123 (insn, operands);

        case 1:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1144 (insn, operands);

        case 2:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1150 (insn, operands);

        case 3:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1186 (insn, operands);

        case 4:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1195 (insn, operands);

        case 5:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1126 (insn, operands);

        case 6:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1129 (insn, operands);

        case 7:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1132 (insn, operands);

        case 8:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1135 (insn, operands);

        case 9:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1138 (insn, operands);

        case 10:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1147 (insn, operands);

        case 11:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1153 (insn, operands);

        case 12:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1156 (insn, operands);

        case 13:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1159 (insn, operands);

        case 14:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1162 (insn, operands);

        case 15:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1165 (insn, operands);

        case 16:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1198 (insn, operands);

        case 17:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1141 (insn, operands);

        case 18:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1189 (insn, operands);

        case 19:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1192 (insn, operands);

        case 20:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1183 (insn, operands);

        case 21:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1124 (insn, operands);

        case 22:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1145 (insn, operands);

        case 23:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1151 (insn, operands);

        case 24:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1187 (insn, operands);

        case 25:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1196 (insn, operands);

        case 26:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1127 (insn, operands);

        case 27:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1130 (insn, operands);

        case 28:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1133 (insn, operands);

        case 29:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1136 (insn, operands);

        case 30:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1139 (insn, operands);

        case 31:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1148 (insn, operands);

        case 32:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1154 (insn, operands);

        case 33:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1157 (insn, operands);

        case 34:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1160 (insn, operands);

        case 35:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1163 (insn, operands);

        case 36:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1166 (insn, operands);

        case 37:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1199 (insn, operands);

        case 38:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1142 (insn, operands);

        case 39:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1190 (insn, operands);

        case 40:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1193 (insn, operands);

        case 41:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1184 (insn, operands);

        case 42:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1125 (insn, operands);

        case 43:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1146 (insn, operands);

        case 44:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1152 (insn, operands);

        case 45:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1188 (insn, operands);

        case 46:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1197 (insn, operands);

        case 47:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1128 (insn, operands);

        case 48:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1131 (insn, operands);

        case 49:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1134 (insn, operands);

        case 50:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1137 (insn, operands);

        case 51:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1140 (insn, operands);

        case 52:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1149 (insn, operands);

        case 53:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1155 (insn, operands);

        case 54:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1158 (insn, operands);

        case 55:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1161 (insn, operands);

        case 56:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1164 (insn, operands);

        case 57:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1167 (insn, operands);

        case 58:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1200 (insn, operands);

        case 59:
          if (!((
#line 4435 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V32HFmode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)) && 
#line 4441 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1143 (insn, operands);

        case 60:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1191 (insn, operands);

        case 61:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1194 (insn, operands);

        case 62:
          if (!((
#line 4524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
  && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
  && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4529 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1185 (insn, operands);

        case 63:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1213 (insn, operands);

        case 64:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1216 (insn, operands);

        case 65:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1225 (insn, operands);

        case 66:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1231 (insn, operands);

        case 67:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1219 (insn, operands);

        case 68:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1222 (insn, operands);

        case 69:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1228 (insn, operands);

        case 70:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1232 (insn, operands);

        case 71:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1233 (insn, operands);

        case 72:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1234 (insn, operands);

        case 73:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1235 (insn, operands);

        case 74:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (HImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (HImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1236 (insn, operands);

        case 75:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1214 (insn, operands);

        case 76:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1217 (insn, operands);

        case 77:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1226 (insn, operands);

        case 78:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1237 (insn, operands);

        case 79:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1220 (insn, operands);

        case 80:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1223 (insn, operands);

        case 81:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1229 (insn, operands);

        case 82:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1238 (insn, operands);

        case 83:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1239 (insn, operands);

        case 84:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1240 (insn, operands);

        case 85:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1241 (insn, operands);

        case 86:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (SImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (SImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1242 (insn, operands);

        case 87:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V64QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1215 (insn, operands);

        case 88:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1218 (insn, operands);

        case 89:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V16HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1227 (insn, operands);

        case 90:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V16SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1243 (insn, operands);

        case 91:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32QImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1221 (insn, operands);

        case 92:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V32HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1224 (insn, operands);

        case 93:
          if (!((
#line 4634 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW
   && ix86_pre_reload_split ()
   && (GET_MODE_NUNITS (V8HImode)
      < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4640 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1230 (insn, operands);

        case 94:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1244 (insn, operands);

        case 95:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4SImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1245 (insn, operands);

        case 96:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V8DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1246 (insn, operands);

        case 97:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V4DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1247 (insn, operands);

        case 98:
          if (!((
#line 4724 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && (!VALID_MASK_AVX512BW_MODE (DImode) || TARGET_AVX512BW)
   && (GET_MODE_NUNITS (V2DImode)
       < GET_MODE_PRECISION (DImode))
   && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)) && 
#line 4730 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1248 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern470 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1439 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1466 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1493 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1520 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1547 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1574 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1601 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1628 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1655 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1682 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1709 (insn, operands);

            case 11:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1736 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1442 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1469 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1496 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1523 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1550 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1577 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1604 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1631 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1658 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1685 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1712 (insn, operands);

            case 23:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1739 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1445 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1472 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1499 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1526 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1553 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1580 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1607 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1634 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1661 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1688 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1715 (insn, operands);

            case 35:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1742 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2735 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2744 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2753 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2762 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2771 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2780 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2789 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2798 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2807 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2816 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2825 (insn, operands);

            case 47:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2834 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2087 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2114 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2141 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2168 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2195 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2222 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2249 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2276 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2303 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2330 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2357 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2384 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2090 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2117 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2144 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2171 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2198 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2225 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2252 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2279 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2306 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2333 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2360 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2387 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2093 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2120 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2147 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2174 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2201 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2228 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2255 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2282 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2309 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2336 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2363 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2390 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern470 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1448 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1475 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1502 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1529 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1556 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1583 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1610 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1637 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1664 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1691 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1718 (insn, operands);

            case 11:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1745 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1451 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1478 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1505 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1532 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1559 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1586 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1613 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1640 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1667 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1694 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1721 (insn, operands);

            case 23:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1748 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1454 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1481 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1508 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1535 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1562 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1589 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1616 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1643 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1670 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1697 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1724 (insn, operands);

            case 35:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1751 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2738 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2747 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2756 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2765 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2774 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2783 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2792 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2801 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2810 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2819 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2828 (insn, operands);

            case 47:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2837 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2096 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2123 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2150 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2177 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2204 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2231 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2258 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2285 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2312 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2339 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2366 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2393 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2099 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2126 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2153 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2180 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2207 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2234 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2261 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2288 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2315 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2342 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2369 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2396 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern472 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2102 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2129 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2156 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2183 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2210 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2237 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2264 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2291 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2318 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2345 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2372 (insn, operands);

            case 11:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2399 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      return split_59 (x1, insn);

    case VEC_DUPLICATE:
      switch (pattern546 (x2))
        {
        case 0:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 568 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3134 (insn, operands);

        case 1:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 569 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return NULL;
          return gen_split_3135 (insn, operands);

        case 2:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3136 (insn, operands);

        case 3:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 570 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3137 (insn, operands);

        case 4:
          if (!
#line 18661 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3138 (insn, operands);

        case 5:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(64 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
            return NULL;
          return gen_split_3139 (insn, operands);

        case 6:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 571 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3140 (insn, operands);

        case 7:
          if (!
#line 18661 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3141 (insn, operands);

        case 8:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 572 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3142 (insn, operands);

        case 9:
          if (!
#line 18661 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3143 (insn, operands);

        case 10:
          if (!(
#line 18661 "../../../gcc/config/i386/sse.md"
(32 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)) && 
#line 573 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return NULL;
          return gen_split_3144 (insn, operands);

        case 11:
          if (!
#line 18661 "../../../gcc/config/i386/sse.md"
(16 == 64 || TARGET_AVX512VL
   || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256)))
            return NULL;
          return gen_split_3145 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!general_reg_operand (operands[1], E_QImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return NULL;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 27
          || GET_MODE (x8) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 17
          || GET_MODE (x9) != E_CCmode)
        return NULL;
      x10 = XVECEXP (x8, 0, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x11 = XEXP (x7, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_178 (insn, operands);

    case E_SImode:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != POPCOUNT
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = XEXP (x7, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x12 = XEXP (x8, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return NULL;
      x13 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x13) != SET
          || pattern1615 (x13) != 0)
        return NULL;
      x14 = XEXP (x13, 1);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      operands[3] = x16;
      if (!register_operand (operands[3], E_QImode))
        return NULL;
      x17 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x17) != SET)
        return NULL;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != IF_THEN_ELSE)
        return NULL;
      x19 = XEXP (x18, 0);
      if (!bt_comparison_operator (x19, E_VOIDmode))
        return NULL;
      operands[4] = x19;
      if (pattern1727 (x17) != 0)
        return NULL;
      x20 = XEXP (x18, 1);
      x21 = XEXP (x20, 0);
      operands[5] = x21;
      if (!
#line 22833 "../../../gcc/config/i386/i386.md"
(REGNO (operands[2]) == REGNO (operands[3])
   && peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (3, operands[2])
   && peep2_regno_dead_p (4, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_179 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!memory_operand (x2, E_SImode))
        return NULL;
      operands[1] = x2;
      res = peephole2_31 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      operands[0] = x2;
      if (!
#line 27802 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((SImode == HImode
       && TARGET_LCP_STALL)
       || (!TARGET_USE_MOV0
          && TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))
   && peep2_regno_dead_p (0, FLAGS_REG)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_237 (insn, operands);

    case E_DImode:
      operands[1] = x2;
      if (!memory_operand (operands[1], E_DImode))
        return NULL;
      if (peep2_current_count >= 2)
        {
          x3 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x3) == SET)
            {
              x4 = XEXP (x3, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x5 = XEXP (x3, 0);
                  operands[2] = x5;
                  if (memory_operand (operands[2], E_DImode))
                    {
                      if (peep2_current_count >= 3)
                        {
                          x6 = PATTERN (peep2_next_insn (2));
                          if (pattern1156 (x6, 
E_DImode) == 0
                              && (
#line 27027 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                            {
                              *pmatch_len_ = 3;
                              res = gen_peephole2_201 (insn, operands);
                              if (res != NULL_RTX)
                                return res;
                            }
                        }
                      if ((
#line 27043 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_203 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
      if (!(
#line 27056 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_size_p () && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_205 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return NULL;
  x8 = XEXP (x6, 1);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!register_operand (operands[1], E_VOIDmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x9 = PATTERN (peep2_next_insn (1));
      if (pattern354 (x9, 
PLUS, 
2) != 0)
        return NULL;
      x10 = XVECEXP (x9, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return NULL;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 17
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XVECEXP (x9, 0, 0);
      x13 = XEXP (x12, 1);
      x14 = XEXP (x13, 1);
      operands[2] = x14;
      if (!x86_64_immediate_operand (operands[2], E_VOIDmode))
        return NULL;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[0]))
        return NULL;
      x16 = XEXP (x12, 0);
      if (!rtx_equal_p (x16, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x13) != E_SImode
              || !
#line 6442 "../../../gcc/config/i386/i386.md"
(!TARGET_AVOID_LEA_FOR_ADDR || optimize_function_for_size_p (cfun)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_60 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || GET_MODE (x13) != E_DImode
              || !(
#line 6442 "../../../gcc/config/i386/i386.md"
(!TARGET_AVOID_LEA_FOR_ADDR || optimize_function_for_size_p (cfun)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_61 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (peep2_current_count < 3
          || XWINT (x8, 0) != -1LL)
        return NULL;
      x9 = PATTERN (peep2_next_insn (1));
      if (pattern1152 (x9, 
-1) != 0)
        return NULL;
      x17 = PATTERN (peep2_next_insn (2));
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 0);
      operands[1] = x19;
      if (pattern1641 (x17) != 0)
        return NULL;
      x20 = XEXP (x18, 1);
      operands[2] = x20;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!general_reg_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !
#line 8725 "../../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_70 (insn, operands);

        case E_HImode:
          if (!general_reg_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !
#line 8725 "../../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_71 (insn, operands);

        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 8725 "../../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_72 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 8725 "../../../gcc/config/i386/i386.md"
(peep2_regno_dead_p (3, FLAGS_REG)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_73 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) == 1
          && XINT (x2, 1) == 41
          && pattern60 (x1, 
E_CCCmode) == 0
          && 
#line 2136 "../../../gcc/config/i386/i386.md"
(TARGET_SLOW_STC && !optimize_insn_for_size_p ()))
        {
          *pmatch_len_ = 0;
          res = gen_peephole2_1 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      break;

    case COMPARE:
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case FLOAT_EXTEND:
      if (GET_MODE (x2) == E_DFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (sse_reg_operand (operands[0], E_DFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (memory_operand (operands[1], E_SFmode)
                  && 
#line 5388 "../../../gcc/config/i386/i386.md"
(TARGET_SPLIT_MEM_OPND_FOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_52 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      break;

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) == E_SFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (sse_reg_operand (operands[0], E_SFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (memory_operand (operands[1], E_DFmode)
                  && 
#line 5618 "../../../gcc/config/i386/i386.md"
(TARGET_SPLIT_MEM_OPND_FOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_53 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      break;

    case FIX:
      res = peephole2_2 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case NE:
    case EQ:
      res = peephole2_3 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = peephole2_8 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case VEC_SELECT:
      res = peephole2_9 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      res = peephole2_14 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case E_DImode:
      res = peephole2_19 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (peep2_current_count >= 2)
    {
      res = peephole2_23 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  operands[0] = x3;
  res = peephole2_27 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  switch (GET_CODE (x2))
    {
    case BSWAP:
      if (GET_MODE (x2) == E_HImode)
        {
          operands[0] = x3;
          if (general_reg_operand (operands[0], E_HImode))
            {
              x4 = XEXP (x2, 0);
              if (rtx_equal_p (x4, operands[0])
                  && 
#line 22626 "../../../gcc/config/i386/i386.md"
(!(TARGET_USE_XCHGB ||
     TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun))
   && peep2_regno_dead_p (0, FLAGS_REG)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_175 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      break;

    case IOR:
      res = peephole2_28 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case ZERO_EXTEND:
      res = peephole2_29 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case IF_THEN_ELSE:
      res = peephole2_30 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = peephole2_32 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      operands[1] = x2;
      if (immediate_operand (operands[1], E_SImode))
        {
          operands[0] = x3;
          if (memory_operand (operands[0], E_SImode)
              && 
#line 27818 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((SImode == HImode
       && TARGET_LCP_STALL)
       || (TARGET_SPLIT_LONG_MOVES
          && get_attr_length (insn) >= ix86_cur_cost ()->large_insn))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_240 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      break;

    default:
      break;
    }
  if (GET_CODE (x3) == REG)
    {
      res = peephole2_34 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count >= 2)
    {
      res = peephole2_36 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case COMPARE:
      operands[1] = x2;
      if (!compare_operator (operands[1], E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT
          || !flags_reg_operand (operands[0], E_VOIDmode))
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode)
              && XWINT (x5, 0) == 0LL
              && 
#line 27833 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p () && ix86_match_ccmode (insn, CCNOmode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_241 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!register_operand (operands[2], E_VOIDmode))
            return NULL;
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 28736 "../../../gcc/config/i386/i386.md"
((((!TARGET_FUSE_CMP_AND_BRANCH || optimize_insn_for_size_p ())
     && incdec_operand (operands[3], GET_MODE (operands[3])))
    || (!TARGET_FUSE_CMP_AND_BRANCH
	&& INTVAL (operands[3]) == 128))
   && ix86_match_ccmode (insn, CCGCmode)
   && peep2_reg_dead_p (1, operands[2])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_363 (insn, operands);

        case AND:
          if (XWINT (x5, 0) != 0LL)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && immediate_operand (operands[3], E_SImode)
                  && 
#line 27875 "../../../gcc/config/i386/i386.md"
(ix86_match_ccmode (insn, CCNOmode)
   && (REGNO (operands[2]) != AX_REG
       || satisfies_constraint_K (operands[3]))
   && peep2_reg_dead_p (1, operands[2])))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_245 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case E_QImode:
              if (register_operand (operands[2], E_QImode)
                  && immediate_operand (operands[3], E_QImode)
                  && 
#line 27895 "../../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_246 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          if (GET_CODE (x6) != SUBREG
              || maybe_ne (SUBREG_BYTE (x6), 0)
              || GET_MODE (x6) != E_QImode)
            return NULL;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTRACT:
            case ZERO_EXTRACT:
              operands[4] = x8;
              x9 = XEXP (x8, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return NULL;
              x10 = XEXP (x8, 2);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
                  || GET_MODE (x4) != E_QImode)
                return NULL;
              x11 = XEXP (x8, 0);
              operands[2] = x11;
              if (!int248_register_operand (operands[2], E_VOIDmode))
                return NULL;
              operands[3] = x7;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return NULL;
              switch (GET_MODE (operands[4]))
                {
                case E_HImode:
                  if (!extract_operator (operands[4], E_HImode)
                      || !
#line 27917 "../../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_247 (insn, operands);

                case E_SImode:
                  if (!extract_operator (operands[4], E_SImode)
                      || !
#line 27917 "../../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_248 (insn, operands);

                case E_DImode:
                  if (!extract_operator (operands[4], E_DImode)
                      || !(
#line 27917 "../../../gcc/config/i386/i386.md"
(! TARGET_PARTIAL_REG_STALL
   && ix86_match_ccmode (insn, CCNOmode)
   && REGNO (operands[2]) != AX_REG
   && peep2_reg_dead_p (1, operands[2])) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_249 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_gr_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_gr_operand (operands[1], E_QImode)
              || !
#line 27851 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((TARGET_NOT_UNPAIRABLE
	&& (!MEM_P (operands[0])
	    || !memory_displacement_operand (operands[0], QImode)))
       || (TARGET_NOT_VECTORMODE
	   && long_memory_operand (operands[0], QImode)))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_242 (insn, operands);

        case E_HImode:
          if (!nonimmediate_gr_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_gr_operand (operands[1], E_HImode)
              || !
#line 27851 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((TARGET_NOT_UNPAIRABLE
	&& (!MEM_P (operands[0])
	    || !memory_displacement_operand (operands[0], HImode)))
       || (TARGET_NOT_VECTORMODE
	   && long_memory_operand (operands[0], HImode)))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_243 (insn, operands);

        case E_SImode:
          if (!nonimmediate_gr_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_gr_operand (operands[1], E_SImode)
              || !
#line 27851 "../../../gcc/config/i386/i386.md"
(optimize_insn_for_speed_p ()
   && ((TARGET_NOT_UNPAIRABLE
	&& (!MEM_P (operands[0])
	    || !memory_displacement_operand (operands[0], SImode)))
       || (TARGET_NOT_VECTORMODE
	   && long_memory_operand (operands[0], SImode)))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_244 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (GET_CODE (x2) == CONST_INT)
        {
          res = peephole2_37 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      operands[1] = x2;
      x12 = PATTERN (peep2_next_insn (1));
      if (pattern550 (x12, 
109, 
4) != 0)
        return NULL;
      x13 = XVECEXP (x12, 0, 1);
      if (pattern1157 (x13) != 0
          || pattern1406 (x12) != 0)
        return NULL;
      x14 = XVECEXP (x12, 0, 0);
      x15 = XEXP (x14, 1);
      x16 = XVECEXP (x15, 0, 2);
      operands[3] = x16;
      if (pattern1689 (x12) != 0)
        return NULL;
      x17 = PATTERN (peep2_next_insn (2));
      x18 = XEXP (x17, 1);
      x19 = XEXP (x18, 1);
      operands[6] = x19;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern1740 (x12, 
E_HImode) != 0
              || !
#line 521 "../../../gcc/config/i386/sync.md"
((rtx_equal_p (operands[0], operands[5])
    && rtx_equal_p (operands[1], operands[6]))
   || (rtx_equal_p (operands[0], operands[6])
       && rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_379 (insn, operands);

        case E_SImode:
          if (pattern1740 (x12, 
E_SImode) != 0
              || !
#line 521 "../../../gcc/config/i386/sync.md"
((rtx_equal_p (operands[0], operands[5])
    && rtx_equal_p (operands[1], operands[6]))
   || (rtx_equal_p (operands[0], operands[6])
       && rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_380 (insn, operands);

        case E_DImode:
          if (pattern1740 (x12, 
E_DImode) != 0
              || !(
#line 521 "../../../gcc/config/i386/sync.md"
((rtx_equal_p (operands[0], operands[5])
    && rtx_equal_p (operands[1], operands[6]))
   || (rtx_equal_p (operands[0], operands[6])
       && rtx_equal_p (operands[1], operands[5]))) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_381 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern57 (x2))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (x86_64_nonmemory_operand (operands[1], E_SImode))
            {
              x4 = XEXP (x2, 0);
              if (rtx_equal_p (x4, operands[0])
                  && 
#line 28516 "../../../gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_317 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!x86_64_nonmemory_operand (operands[1], E_SImode)
              || !rtx_equal_p (x5, operands[0])
              || !
#line 28525 "../../../gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_319 (insn, operands);

        case 1:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (x86_64_nonmemory_operand (operands[1], E_DImode))
            {
              x4 = XEXP (x2, 0);
              if (rtx_equal_p (x4, operands[0])
                  && (
#line 28516 "../../../gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_318 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!x86_64_nonmemory_operand (operands[1], E_DImode)
              || !rtx_equal_p (x5, operands[0])
              || !(
#line 28525 "../../../gcc/config/i386/i386.md"
(!TARGET_OPT_AGU
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_320 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x4 = XEXP (x2, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const_int_operand (operands[1], E_SImode)
              || !
#line 28558 "../../../gcc/config/i386/i386.md"
(pow2p_hwi (INTVAL (operands[1]))
   && peep2_regno_dead_p (0, FLAGS_REG)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_321 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const_int_operand (operands[1], E_DImode)
              || !(
#line 28558 "../../../gcc/config/i386/i386.md"
(pow2p_hwi (INTVAL (operands[1]))
   && peep2_regno_dead_p (0, FLAGS_REG)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_322 (insn, operands);

        default:
          return NULL;
        }

    case VEC_CONCAT:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_V2DFmode
          || !sse_reg_operand (operands[0], E_V2DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_DFmode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[4] = x5;
      if (!const0_operand (operands[4], E_DFmode))
        return NULL;
      x12 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x12) != SET)
        return NULL;
      x20 = XEXP (x12, 1);
      if (GET_CODE (x20) != VEC_CONCAT
          || GET_MODE (x20) != E_V2DFmode)
        return NULL;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != VEC_SELECT
          || GET_MODE (x21) != E_DFmode)
        return NULL;
      x22 = XEXP (x21, 1);
      if (GET_CODE (x22) != PARALLEL
          || XVECLEN (x22, 0) != 1)
        return NULL;
      x23 = XVECEXP (x22, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x24 = XEXP (x12, 0);
      operands[2] = x24;
      if (!sse_reg_operand (operands[2], E_V2DFmode))
        return NULL;
      x25 = XEXP (x20, 1);
      operands[3] = x25;
      if (!memory_operand (operands[3], E_DFmode))
        return NULL;
      x26 = XEXP (x21, 0);
      if (!rtx_equal_p (x26, operands[2])
          || !
#line 1951 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_SSE_UNALIGNED_LOAD_OPTIMAL
   && ix86_operands_ok_for_move_multiple (operands, true, DFmode)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_375 (insn, operands);

    default:
      return NULL;
    }
}
